<%@
page import="
java.util.*,
ca.ubc.cs.beta.hal.utils.Global,
ca.ubc.cs.beta.hal.environments.AlgorithmRun, 
ca.ubc.cs.beta.hal.algorithms.AlgorithmRunRequest, 
ca.ubc.cs.beta.hal.frontend.util.UIHelper,
java.text.SimpleDateFormat"
%>

<%
response.setHeader("Cache-control","no-cache");
response.setHeader("Pragma","no-cache");
response.setDateHeader("Expires",0);
%>

<%  
long runId = 0;
// defaults
long pagenum = 1;
long offset = 0;
int limit = 10;
long subrunCount = 0;

long maxPage = 1;

boolean autorefresh = false;

int limits[] = {10,25,50,100};

String dateFormat = "MMM dd, yyyy HH:mm:ss";
SimpleDateFormat sdf = new SimpleDateFormat(dateFormat);

String idCols       = "1";
String statusCols   = "2";
String algCols      = "3";
String startCols    = "2";
String endCols      = "2";
String cpuCols      = "2";

ArrayList<Double> errorCodes = new ArrayList<Double>();
errorCodes.add(AlgorithmRun.RunStatus.COMMFAILURE);
errorCodes.add(AlgorithmRun.RunStatus.EXCEPTION_FAILURE);

ArrayList<Double> warnCodes = new ArrayList<Double>();
warnCodes.add(AlgorithmRun.RunStatus.TIMEOUT);

AlgorithmRun run = null;
Map<String,String[]> paramMap = request.getParameterMap();
Iterable<? extends AlgorithmRun> subruns = null;
if (paramMap.containsKey("runId")) {
	try {
		runId = Long.parseLong(paramMap.get("runId")[0]);
		run = Global.getDataManager().getRun(runId);
		
		if (paramMap.containsKey("page"))
			pagenum = Long.parseLong(paramMap.get("page")[0]);
		if (paramMap.containsKey("limit"))
			limit = Integer.parseInt(paramMap.get("limit")[0]);
		if (paramMap.containsKey("autorefresh"))
			autorefresh = Boolean.parseBoolean(paramMap.get("autorefresh")[0]);
		
		//System.out.println("autorefresh: "+autorefresh);
		//System.out.println("offset: "+offset+" limit: "+limit);
		//System.out.println(subruns);
		
		if (pagenum<1) { throw new java.lang.IllegalArgumentException("Subrun.jsp: pagenum must be greater than 0. "+pagenum+" was given."); }
		
		
		// We get the subrun count first so that we can calculate
		// the max number of pages that we can display
		//
		// it is only after knowing maxPages can we determine
		// if the supplied page number is greater than then
		// max page number so we can limit the query as necessary
		
		subrunCount = run.getSubrunCount();
		//System.out.println("subrun count: "+subrunCount);
        
		if (subrunCount < 1) {
			// if it's the case that we have no subruns, we should still display
			// a page, thus there is only a maximum number of one pages.
			maxPage = 1;
		} else if (subrunCount % limit == 0) {
		
			// if the number of subruns is evenly divisible by the
			// limit, then the maximum number of pages is just
			// the division.  this is because when numpage == maxpage,
			// we calculate the offset as (numpage-1)*limit == (maxpage-1)*limit
			// which is exactly the right offset we need.
			maxPage = (subrunCount/limit);
		} else {
			// when the subrun count is not evenly divisible by
			// the limit, we must always round up the number to
			// account for the extra page that we must include due
			// to the remainder.
		    maxPage = (int)Math.ceil(subrunCount/(double)limit);
		}
        
        if (pagenum > maxPage) { pagenum = maxPage; }
		offset = (pagenum-1)*limit;
		
		subruns = run.getSubruns(offset, limit);
		
		
	} catch (Exception e) { e.printStackTrace(); }
}
%>
<div id="subrunsTable">
<!-- ---------- PAGINATION SECTION ---------- -->
<div id="subrunsTableNav" class="pagination">
<ul id="pageNavigation">
    <li><a name="1" id="firstPageLink" class="subrun" href="/jsp/Subruns.jsp?runId=<%= runId %>&limit=<%= limit %>">&lt;&lt;</a></li>
    <%
    long lowerPageBound=pagenum-2;
    long upperPageBound=pagenum+2;
    
    //System.out.println("CurPage: "+curPage+" MaxPage: "+maxPage);
    
    if (lowerPageBound<1) { lowerPageBound=1; upperPageBound=5; }
    else if (upperPageBound>maxPage) { lowerPageBound=maxPage-4; upperPageBound=maxPage; }
    
    if (maxPage<5) { lowerPageBound=1; upperPageBound=maxPage; }
    %>
    
    <% if (pagenum==1) { %>
        <li><a name="1" class="subrun" href="/jsp/Subruns.jsp?runId=<%= runId %>">&lt;</a></li>
    <% } else { %>
        <li><a name="<%= pagenum-1 %>" class="subrun" href="/jsp/Subruns.jsp?runId=<%= runId %>&page=<%= (pagenum-1) %>&limit=<%= limit %>">&lt;</a></li>
    <% } %>
    
    <% for(long i=lowerPageBound; i<=upperPageBound; i++) { %>
        <li<% if(pagenum==i) { %> class="active disabled"<% } %>><a name="<%= i %>" class="subrun" href="/jsp/Subruns.jsp?runId=<%= runId %>&page=<%= i %>&limit=<%= limit %>"><%= i %></a></li>
    <% } %>
    
    <% if (pagenum == maxPage) { %>
        <li><a name="<%= maxPage %>" class="subrun" href="/jsp/Subruns.jsp?runId=<%= runId %>&page=<%= pagenum %>&limit=<%= limit %>">&gt;</a></li>
    <% } else { %>
        <li><a name="<%= pagenum+1 %>" class="subrun" href="/jsp/Subruns.jsp?runId=<%= runId %>&page=<%= pagenum+1 %>&limit=<%= limit %>">&gt;</a></li>
    <% } %>
    
    <li><a name="<%= maxPage %>" class="subrun" id="maxPageLink" href="/jsp/Subruns.jsp?runId=<%= runId %>&page=<%= maxPage %>&limit=<%= limit %>">&gt;&gt;</a></li>
</ul>

<!-- ---------- LIMIT SECTION ---------- -->
<ul id="limitNavigation">
    <li class="active disabled"><a name="limit">Per Page</a></li>
    <% for(int lim: limits) { %>
    <li<% if(lim==limit) { %> class="active disabled"<% } %>><a name="<%= lim %>" href="/jsp/Subruns.jsp?runId=<%= runId %>&page=<%= pagenum %>&limit=<%= lim %>" class="limit"><%= lim %></a></li>
    <% } %>
</ul>
<!-- ---------- AUTOREFRESH SECTION ---------- -->
<ul id="autoRefreshNavigation">
    <li class="active disabled"><a name="refresh">Auto-Refresh</a></li>
    <li><button name="1" id = "autorefreshbutton" class="btn btn-large autorefresh<% if (autorefresh) { %><%= " active btn-danger"  %><% } else { %><%= " btn-success"%><% } %>" data-toggle="button"><% if(autorefresh) { %><%= "Stop" %><% } else { %><%= "Start" %><% } %></button></li>
    <!-- <li><a href="#" id="loadingTableSpinnerIconDiv"></a></li>  -->
</ul>

<ul>
    <li class="disable"><a href="#" id="loadingTableSpinnerIconDiv" style="visibility: hidden;"><img src="/hal/commands/getFile/web/icons/ajax-loader.gif"></img></a></li>
</ul>

</div>
<div id="subrunsData" class="container">
<div class="row">
<div class="span<%= idCols %>"><strong>Id</strong></div>
<div class="span<%= statusCols %>"><strong>Status</strong></div>
<div class="span<%= algCols %>"><strong>Target Algorithm</strong></div>
<div class="span<%= startCols %>"><strong>Start Time</strong></div>
<div class="span<%= endCols %>"><strong>End Time</strong></div>
<div class="span<%= cpuCols %>"><strong>CPU Time (s)</strong></div>
</div>
<hr>


<% for(AlgorithmRun r : subruns) { %>
<div class="row">
    <div class="span<%= idCols %>"><a href="/hal/monitorRun?runId=<%= r.getId() %>"><%= r.getId() %></a></div>
    
    
    <div class="span<%= statusCols %>">
        <% if(errorCodes.contains(r.getStatus()) || r.getStatus() > 0.9) { %>
        <span class="label label-important">
        <% } else if(warnCodes.contains(r.getStatus())) { %>
        <span class="label label-warning">
        <% } else { %>
        <span class="label label-info">
        <% } %>
        <%= UIHelper.getHumanReadableRunState(r.getStatus()) %>
        </span>
    </div>
    
    <div class="span<%= algCols %>"><%= r.getAlgorithmRunRequest().getImplementation().getName() %></div>
    <div class="span<%= startCols %>"><% if (r.getStartTime() == null) { %>--<% } else { %><%= sdf.format(r.getStartTime()) %><% } %></div>
    <div class="span<%= endCols %>"><% if (r.getFinishTime() == null) { %>--<% } else { %><%= sdf.format(r.getFinishTime()) %><% } %></div>
    <div class="span<%= cpuCols %>"><%= String.format("%.2f",r.getTotalCpuTime()) %></div>
</div>
<% } %>


</div>
</div>