function createConfigurableParameterSelector(options) {
    var selectorContainer = $('<div></div>');

    var hiddenConfigurableInputDiv = $('<div></div>');

    var otherAlgorithmSettingsHeader = $('<div></div>');
    otherAlgorithmSettingsHeader.addClass('setSelectionHeader');
    otherAlgorithmSettingsHeader.html('<span>Other algorithm settings</span>');

    var otherAlgorithmSettingsSelectAllNone = $('<span></span>');
    otherAlgorithmSettingsSelectAllNone.attr('style', 'float: right; text-align: right;');

    var otherAlgorithmSettingsSelectAll = $('<a></a>');
    otherAlgorithmSettingsSelectAll.html('all');
    otherAlgorithmSettingsSelectAll.click(function() {
        otherAlgorithmSettings.children().addClass('setSelectionElementSelected');
    });

    var otherAlgorithmSettingsSelectNone = $('<a></a>');
    otherAlgorithmSettingsSelectNone.html('none');
    otherAlgorithmSettingsSelectNone.click(function() {
        otherAlgorithmSettings.children().removeClass('setSelectionElementSelected');
    });

    otherAlgorithmSettingsSelectAllNone.append(otherAlgorithmSettingsSelectAll);
    otherAlgorithmSettingsSelectAllNone.append(' | ');
    otherAlgorithmSettingsSelectAllNone.append(otherAlgorithmSettingsSelectNone);

    otherAlgorithmSettingsHeader.append(otherAlgorithmSettingsSelectAllNone);

    var otherAlgorithmSettings = $('<div></div>');
    otherAlgorithmSettings.addClass('setSelection');

    var otherAlgorithmSettingsContainer = $('<div></div>');
    otherAlgorithmSettingsContainer.addClass('floatLeft');
    otherAlgorithmSettingsContainer.append(otherAlgorithmSettingsHeader);
    otherAlgorithmSettingsContainer.append(otherAlgorithmSettings);

    var configurableParametersHeader = $('<div></div>');
    configurableParametersHeader.addClass('setSelectionHeader');
    configurableParametersHeader.append('<span>Configurable parameters</span>');

    var configurableParametersSelectAllNone = $('<span></span>');
    configurableParametersSelectAllNone.attr('style', 'float: right; text-align: right;');

    var configurableParametersSelectAll = $('<a></a>');
    configurableParametersSelectAll.html('all');
    configurableParametersSelectAll.click(function() {
        configurableParameters.children().addClass('setSelectionElementSelected');
    });

    var configurableParametersSelectNone = $('<a></a>');
    configurableParametersSelectNone.html('none');
    configurableParametersSelectNone.click(function() {
        configurableParameters.children().removeClass('setSelectionElementSelected');
    });

    configurableParametersSelectAllNone.append(configurableParametersSelectAll);
    configurableParametersSelectAllNone.append(' | ');
    configurableParametersSelectAllNone.append(configurableParametersSelectNone);

    configurableParametersHeader.append(configurableParametersSelectAllNone);

    var configurableParameters = $('<div></div>');
    configurableParameters.addClass('setSelection');

    var configurableParametersContainer = $('<div></div>');
    configurableParametersContainer.addClass('floatLeft');
    configurableParametersContainer.append(configurableParametersHeader);
    configurableParametersContainer.append(configurableParameters);

    var configurableTracking = {};
    var inputParameters = options.implementationValues.inputParameters;
    for (var i in inputParameters) {
        var selectionElement = $('<div></div>');
        selectionElement.addClass('setSelectionElement');
        selectionElement.html(inputParameters[i].name);
        selectionElement.click(function() {
            $(this).toggleClass('setSelectionElementSelected');
        });

        var isConfigurableTracking = $('<input></input>');
        isConfigurableTracking.attr('id', options.idPrefix + inputParameters[i].name);
        isConfigurableTracking.attr('name', options.idPrefix + inputParameters[i].name);
        isConfigurableTracking.attr('type', 'hidden');
        hiddenConfigurableInputDiv.append(isConfigurableTracking);
        configurableTracking[inputParameters[i].name] = isConfigurableTracking;

        if (inputParameters[i].isConfigurable) {
            configurableParameters.append(selectionElement);
            isConfigurableTracking.attr('value', 'true');
        } else {
            otherAlgorithmSettings.append(selectionElement);
            isConfigurableTracking.attr('value', 'false');
        }
    }

    var leftToRightButton = $('<input></input>');
    leftToRightButton.attr('type', 'button');
    leftToRightButton.attr('value', '>');
    leftToRightButton.click(function() {
        var selected = otherAlgorithmSettings.find('.setSelectionElementSelected');
        selected.prependTo(configurableParameters);

        selected.each(function() {
            configurableTracking[$(this).text()].attr('value', 'true');
        });

        otherAlgorithmSettings.children().removeClass('setSelectionElementSelected');
        configurableParameters.children().removeClass('setSelectionElementSelected');
    });

    var rightToLeftButton = $('<input></input>');
    rightToLeftButton.attr('type', 'button');
    rightToLeftButton.attr('value', '<');
    rightToLeftButton.click(function() {
        var selected = configurableParameters.find('.setSelectionElementSelected');
        selected.prependTo(otherAlgorithmSettings);

        selected.each(function() {
            configurableTracking[$(this).text()].attr('value', 'false');
        });

        otherAlgorithmSettings.children().removeClass('setSelectionElementSelected');
        configurableParameters.children().removeClass('setSelectionElementSelected');
    });

    var selectionButtons = $('<div></div>');
    selectionButtons.addClass('setSelectionButtons');
    selectionButtons.append(leftToRightButton);
    selectionButtons.append(rightToLeftButton);

    var clearDiv = $('<div></div>');
    clearDiv.addClass('clear');

    // Next/Reenable/Cancel buttons
    var nextReenableCancelButtons = $('<div></div>');
    nextReenableCancelButtons.addClass('center');

    var reenableInputDescription = $('<div></div>');
    reenableInputDescription.addClass('formFieldDescriptionCentered');
    reenableInputDescription.html('Please click the button below if you wish to edit the configurable parameter identification after submission. WARNING: this may cause some of your data in the subsequent areas of the form to be removed.');
    reenableInputDescription.hide();

    var nextButton = $('<input></input>');
    nextButton.attr('type', 'button');
    nextButton.attr('value', 'Next');
    nextButton.attr('id', 'configurableParameterSelectionNextButton');

    nextButton.click(function() {
        options.errorsTarget.html('');
        options.errorsTarget.hide();

        var onResult = function(result) {
                nextButton.attr('disabled', false);

                if (result.successful) {
                    disableFormElementsUnder(options.target);

                    nextButton.hide();
                    cancelButton.hide();
                    reenableInputDescription.show();

                    reenableInputButton.attr('disabled', false);
                    reenableInputButton.show();

                    options.onSuccess(result);
                } else {
                    options.errorsTarget.removeClass('alert').removeClass('success');
                    options.errorsTarget.addClass('error');

                    options.errorsTarget.html(result.errorMessage);
                    options.errorTarget.show();
                }
            };

        nextButton.attr('disabled', true);

        options.onSubmit(onResult);
    });

    var reenableInputButton = $('<input></input>');
    reenableInputButton.addClass('enableAfterSubmission');
    reenableInputButton.attr('type', 'button');
    reenableInputButton.attr('value', 'Re-enable input');

    reenableInputButton.click(function() {
        enableFormElementsUnder(options.target);
        options.onReenable();

        reenableInputDescription.hide();
        reenableInputButton.attr('disabled', true);
        reenableInputButton.hide();
        nextButton.show();
        cancelButton.show();
    });

    reenableInputButton.hide();

    var cancelButton = $('<input></input>');
    cancelButton.attr('type', 'button');
    cancelButton.attr('value', 'Cancel');
    cancelButton.click(cancelForm);

    nextReenableCancelButtons.append($('<hr>'));
    nextReenableCancelButtons.append(reenableInputDescription);
    nextReenableCancelButtons.append(nextButton);
    nextReenableCancelButtons.append(reenableInputButton);
    nextReenableCancelButtons.append(cancelButton);
    //////
    selectorContainer.append(hiddenConfigurableInputDiv);
    selectorContainer.append(otherAlgorithmSettingsContainer);
    selectorContainer.append(selectionButtons);
    selectorContainer.append(configurableParametersContainer);
    selectorContainer.append(clearDiv);
    selectorContainer.append(nextReenableCancelButtons);

    options.target.append(selectorContainer);

    // handle defaults
    // here defaults refers to configurable parameters
    if (options.defaults) {
        for (var i in options.defaults) {
            $('.setSelectionElement').each(function(index, item) {
                if ($(item).html() == options.defaults[i]) {
                    $(item).click();
                }
            });
        }

        leftToRightButton.click();
    }
}

function createParameterConditionEntry(options) {
    if (options.showAnd) {
        var and = $('<span></span>');
        and.append('AND');

        options.target.append(and);
    }

    var parameterSelect = $('<select></select>');
    parameterSelect.attr('id', options.idPrefix + 'parameter');
    parameterSelect.attr('name', options.idPrefix + 'parameter');

    for (var i in options.parameters) {
        var opt = $('<option></option>');
        opt.attr('value', options.parameters[i].name);
        opt.html(options.parameters[i].name);

        parameterSelect.append(opt);
    }

    if (options.parameter !== undefined) {
        parameterSelect.val(options.parameter);
    }

    options.target.append(parameterSelect);

    var hasValuesInDomain = $('<span></span>');
    hasValuesInDomain.html(' has values in the domain:');

    options.target.append(hasValuesInDomain);

    var dummyParam = {};

    if (options.domain !== undefined) {
        dummyParam.hasDomain = true;
        dummyParam.domain = options.domain;
    } else {
        dummyParam.hasDomain = false;
    }

    dummyParam.hasSemanticDomain = false;
    var domainSelector = $('<div></div>');
    createParameterDomainSpecification({
        'target': domainSelector,
        'parameter': dummyParam,
        'idPrefix': options.idPrefix + 'domain_',
        'showDefaultValueField': false,
        'showTransformationField': false
    });

    options.target.append(domainSelector);

    var removeButton = $('<input></input>');
    removeButton.attr('type', 'button');
    removeButton.attr('value', 'Remove');
    removeButton.click(function() {
        options.target.remove();
    });

    options.target.append(removeButton);
}

function createParameterCondition(options) {
    var headerText = $('<span></span>');
    headerText.html('Parameter conditional rule');

    var headerLink = $('<a></a>');
    headerLink.append(headerText);

    var header = $('<div></div>');
    header.addClass('expanded');
    header.append(headerLink);

    var content = $('<div></div>');
    content.addClass('collapsibleContent');

    var container = $('<div></div>');
    container.addClass('collapsible');
    container.append(header);
    container.append(content);

    collapsible(container);

    var parameterChoice = $('<div></div>');
    var parameterSelect = $('<select></select>');
    parameterSelect.attr('id', options.idPrefix + 'parameter');
    parameterSelect.attr('name', options.idPrefix + 'parameter');

    for (var i in options.parameters) {
        var opt = $('<option></option>');
        opt.attr('value', options.parameters[i].name);
        opt.html(options.parameters[i].name);

        parameterSelect.append(opt);
    }

    var activeText = $('<span></span>');
    activeText.append(' only affects algorithm behaviour if:');

    if (options.parameter !== undefined) {
        parameterSelect.val(options.parameter);
    }

    parameterChoice.append(parameterSelect);
    parameterChoice.append(activeText);

    var numConditions = 0;
    var conditions = $('<div></div>');
    var numConditionsField = $('<input></input>');
    numConditionsField.attr('id', options.idPrefix + 'numberOfEntries');
    numConditionsField.attr('name', options.idPrefix + 'numberOfEntries');
    numConditionsField.attr('type', 'hidden');
    numConditionsField.attr('value', numConditions);
    conditions.append(numConditionsField);

    var buttons = $('<div></div>');

    var addCondition = $('<input></input>');
    addCondition.attr('type', 'button');
    addCondition.attr('value', 'Add condition');
    addCondition.click(function() {
        var cond = $('<div></div>');
        cond.addClass('parameterCondition');

        createParameterConditionEntry({
            'target': cond,
            'parameters': options.parameters,
            'parameter': undefined,
            'domain': undefined,
            'idPrefix': options.idPrefix + 'conditionEntry_' + numConditions + '_',
            'showAnd': (conditions.children().size() > 1)
        });

        conditions.append(cond);

        numConditions = numConditions + 1;
        numConditionsField.val(numConditions);
    });

    if (options.entries !== undefined) {
        for (var i in options.entries) {
            var cond = $('<div></div>');
            cond.addClass('parameterCondition');

            createParameterConditionEntry({
                'target': cond,
                'parameters': options.parameters,
                'parameter': options.entries[i].parameterName,
                'domain': options.entries[i].domain,
                'idPrefix': options.idPrefix + 'conditionEntry_' + numConditions + '_',
                'showAnd': (conditions.children().size() > 1)
            });

            conditions.append(cond);

            numConditions = numConditions + 1;
            numConditionsField.val(numConditions);
        }
    }

    var removeConditions = $('<input></input>');
    removeConditions.attr('type', 'button');
    removeConditions.attr('value', 'Remove these conditions');
    removeConditions.click(function() {
        options.target.remove();
    });

    buttons.append(addCondition);
    buttons.append(removeConditions);

    content.append(parameterChoice);
    content.append(conditions);
    content.append(buttons);

    options.target.append(container);
}

function createProhibitedCombination(options) {
    var headerText = $('<span></span>');
    headerText.html('Prohibited combination');

    var headerLink = $('<a></a>');
    headerLink.append(headerText);

    var header = $('<div></div>');
    header.addClass('expanded');
    header.append(headerLink);

    var content = $('<div></div>');
    content.addClass('collapsibleContent');

    var container = $('<div></div>');
    container.addClass('collapsible');
    container.append(header);
    container.append(content);

    collapsible(container);

    var numProhibitions = 0;
    var prohibitions = $('<div></div>');
    var numProhibitionsField = $('<input></input>');
    numProhibitionsField.attr('id', options.idPrefix + 'numberOfEntries');
    numProhibitionsField.attr('name', options.idPrefix + 'numberOfEntries');
    numProhibitionsField.attr('type', 'hidden');
    numProhibitionsField.attr('value', numProhibitions);

    prohibitions.append(numProhibitionsField);

    var buttons = $('<div></div>');
    var addParameter = $('<input></input>');
    addParameter.attr('type', 'button');
    addParameter.attr('value', 'Add parameter');
    addParameter.click(function() {
        var entry = $('<div></div>');
        entry.addClass('parameterProhibition');

        createParameterConditionEntry({
            'target': entry,
            'parameters': options.parameters,
            'parameter': undefined,
            'domain': undefined,
            'idPrefix': options.idPrefix + 'prohibitionEntry_' + numProhibitions + '_',
            'showAnd': (prohibitions.children().size() > 1)
        });

        prohibitions.append(entry);

        numProhibitions = numProhibitions + 1;
        numProhibitionsField.val(numProhibitions);
    });

    if (options.entries !== undefined) {
        for (var i in options.entries) {
            var entry = $('<div></div>');
            entry.addClass('parameterProhibition');

            createParameterConditionEntry({
                'target': entry,
                'parameters': options.parameters,
                'parameter': options.entries[i].parameterName,
                'domain': options.entries[i].domain,
                'idPrefix': options.idPrefix + 'prohibitionEntry_' + numProhibitions + '_',
                'showAnd': (prohibitions.children().size() > 1)
            });

            prohibitions.append(entry);

            numProhibitions = numProhibitions + 1;
            numProhibitionsField.val(numProhibitions);
        }
    }

    var removeRule = $('<input></input>');
    removeRule.attr('type', 'button');
    removeRule.attr('value', 'Remove this rule');
    removeRule.click(function() {
        options.target.remove();
    });

    buttons.append(addParameter);
    buttons.append(removeRule);

    content.append(prohibitions);
    content.append(buttons);

    options.target.append(container);
}

function createParameterConditionality(options) {
    var ruleContainer = $('<div></div>');

    var numConditions = 0;
    var numConditionsField = $('<input></input>');
    numConditionsField.attr('id', options.idPrefix + 'numberOfConditionalityRules');
    numConditionsField.attr('name', options.idPrefix + 'numberOfConditionalityRules');
    numConditionsField.attr('type', 'hidden');
    numConditionsField.attr('value', numConditions);

    ruleContainer.append(numConditionsField);

    var numProhibitions = 0;
    var numProhibitionsField = $('<input></input>');
    numProhibitionsField.attr('id', options.idPrefix + 'numberOfProhibitedCombinations');
    numProhibitionsField.attr('name', options.idPrefix + 'numberOfProhibitedCombinations');
    numProhibitionsField.attr('type', 'hidden');
    numProhibitionsField.attr('value', numProhibitions);

    ruleContainer.append(numProhibitionsField);

    var buttonsContainer = $('<div></div>');
    var addConditionalRule = $('<input></input>');
    addConditionalRule.attr('type', 'button');
    addConditionalRule.attr('value', 'Add conditional rule')
    addConditionalRule.click(function() {
        var condition = $('<div></div>');

        createParameterCondition({
            'target': condition,
            'parameters': options.parameters,
            'parameter': undefined,
            'entries': undefined,
            'idPrefix': options.idPrefix + 'conditionalRule_' + numConditions + '_'
        });

        numConditions = numConditions + 1;
        numConditionsField.val(numConditions);

        ruleContainer.append(condition);
    });

    if (options.conditionalityRules !== undefined) {
        for (var i in options.conditionalityRules) {
            var condition = $('<div></div>');

            createParameterCondition({
                'target': condition,
                'parameters': options.parameters,
                'parameter': options.conditionalityRules[i].parameterName,
                'entries': options.conditionalityRules[i].entries,
                'idPrefix': options.idPrefix + 'conditionalRule_' + numConditions + '_'
            });

            numConditions = numConditions + 1;
            numConditionsField.val(numConditions);

            ruleContainer.append(condition);
        }
    }

    var addProhibitedCombinations = $('<input></input>');
    addProhibitedCombinations.attr('type', 'button').attr('value','Add forbidden combinations');
    //addProhibitedCombinations.attr('value', 'Add prohibited combinations')
    addProhibitedCombinations.click(function() {
        var prohibition = $('<div></div>');

        createProhibitedCombination({
            'target': prohibition,
            'parameters': options.parameters,
            'entries': undefined,
            'idPrefix': options.idPrefix + 'prohibitedCombination_' + numProhibitions + '_'
        });

        numProhibitions = numProhibitions + 1;
        numProhibitionsField.val(numProhibitions);

        ruleContainer.append(prohibition);
    });

    if (options.prohibitedCombinations !== undefined) {
        for (var i in options.prohibitedCombinations) {
            var prohibition = $('<div></div>');

            createProhibitedCombination({
                'target': prohibition,
                'parameters': options.parameters,
                'entries': options.prohibitedCombinations[i].entries,
                'idPrefix': options.idPrefix + 'prohibitedCombination_' + numProhibitions + '_'
            });

            numProhibitions = numProhibitions + 1;
            numProhibitionsField.val(numProhibitions);

            ruleContainer.append(prohibition);
        }
    }

    buttonsContainer.append(addConditionalRule);
    buttonsContainer.append(addProhibitedCombinations);

    var allContainer = $('<div></div>');
    allContainer.append(ruleContainer);
    allContainer.append(buttonsContainer);

    options.target.append(allContainer);
}

function createParameterSpecification(options) {
    var parameterSpecificationHeaderText = $('<span></span>');
    parameterSpecificationHeaderText.html('Domain specification');

    var parameterSpecificationHeaderLink = $('<a></a>');
    parameterSpecificationHeaderLink.append(parameterSpecificationHeaderText);

    var parameterSpecificationHeader = $('<div></div>');
    parameterSpecificationHeader.addClass('expanded');
    parameterSpecificationHeader.append(parameterSpecificationHeaderLink);

    var parameterSpecification = $('<div></div>');
    parameterSpecification.addClass('collapsibleContent');

    var parameterSpecificationContainer = $('<div></div>');
    parameterSpecificationContainer.addClass('collapsible');
    parameterSpecificationContainer.append(parameterSpecificationHeader);
    parameterSpecificationContainer.append(parameterSpecification);

    collapsible(parameterSpecificationContainer);

    for (var i in options.parameters) {
        var parameterField = $('<div></div>');
        createParameterField({
            'target': parameterField,
            'parameter': options.parameters[i],
            'idPrefix': options.idPrefix + 'parameters_' + options.parameters[i].name + '_',
            'showSemanticsSelector': options.showSemanticsSelector,
            'semanticsOptions': options.semanticsOptions,
            'showDefaultValueField': options.showDefaultValueField,
            'showTransformationField': options.showTransformationField
        });

        parameterSpecification.append(parameterField);
    }

    var parameterConditionalityHeaderText = $('<span></span>').html('Conditionality and forbidden combinations');
    //parameterConditionalityHeaderText.html('Conditionality and prohibited combinations');

    var parameterConditionalityHeaderLink = $('<a></a>');
    parameterConditionalityHeaderLink.append(parameterConditionalityHeaderText);

    var parameterConditionalityHeader = $('<div></div>');
    parameterConditionalityHeader.addClass('collapsed');
    parameterConditionalityHeader.append(parameterConditionalityHeaderLink);

    var parameterConditionality = $('<div></div>');
    parameterConditionality.addClass('collapsibleContent');

    var parameterConditionalityContainer = $('<div></div>');
    parameterConditionalityContainer.addClass('collapsible');
    parameterConditionalityContainer.append(parameterConditionalityHeader);
    parameterConditionalityContainer.append(parameterConditionality);

    collapsible(parameterConditionalityContainer);

    // Next/Reenable/Cancel buttons
    var nextReenableCancelButtons = $('<div></div>');
    nextReenableCancelButtons.addClass('center');

    var reenableInputDescription = $('<div></div>');
    reenableInputDescription.addClass('formFieldDescriptionCentered');
    reenableInputDescription.html('Please click the button below if you wish to edit the parameter specification after submission. WARNING: this may cause some of your data in the subsequent areas of the form to be removed.');
    reenableInputDescription.hide();

    var editDomainsButton = $('<input></input>');
    editDomainsButton.attr('type', 'button');
    editDomainsButton.attr('value', 'Edit domains');
    editDomainsButton.attr('id', 'editDomainsButton');
    editDomainsButton.hide();
    editDomainsButton.click(function() {
        enableFormElementsUnder(parameterSpecification);

        collapse(parameterConditionalityHeader);
        parameterConditionalityContainer.hide();

        expand(parameterSpecificationHeader);

        editDomainsButton.hide();
        nextButton.hide();
        moveToConditionalityAndProhibitedConfigurationsButton.show();
    });

    var moveToConditionalityAndProhibitedConfigurationsButton = $('<input></input>');
    moveToConditionalityAndProhibitedConfigurationsButton.attr('type', 'button');
    moveToConditionalityAndProhibitedConfigurationsButton.attr('value', 'Next');
    moveToConditionalityAndProhibitedConfigurationsButton.attr('id', 'moveToConditionalityAndProhibitedConfigurationsButton');
    moveToConditionalityAndProhibitedConfigurationsButton.click(function() {
        disableFormElementsUnder(parameterSpecification);

        collapse(parameterSpecificationHeader);

        parameterConditionality.html('');

        createParameterConditionality({
            'target': parameterConditionality,
            'parameters': options.parameters,
            'conditionalityRules': options.conditionalityRules,
            'prohibitedCombinations': options.prohibitedCombinations,
            'idPrefix': options.idPrefix
        });

        parameterConditionalityContainer.show();
        expand(parameterConditionalityHeader);

        moveToConditionalityAndProhibitedConfigurationsButton.hide();
        editDomainsButton.show();
        nextButton.show();
    });

    var nextButton = $('<input></input>');
    nextButton.attr('type', 'button');
    nextButton.attr('value', 'Next');
    nextButton.hide();
    nextButton.click(function() {
        options.errorsTarget.html('');
        options.errorsTarget.hide();

        var onResult = function(result) {
                nextButton.attr('disabled', false);

                if (result.successful) {
                    disableFormElementsUnder(options.target);

                    nextButton.hide();
                    editDomainsButton.hide();
                    moveToConditionalityAndProhibitedConfigurationsButton.hide();
                    cancelButton.hide();
                    reenableInputDescription.show();

                    reenableInputButton.attr('disabled', false);
                    reenableInputButton.show();

                    options.onSuccess(result);
                } else {
                    options.errorsTarget.removeClass('alert').removeClass('success');
                    options.errorsTarget.addClass('error');

                    options.errorsTarget.html(result.errorMessage);
                    options.errorsTarget.show();
                }
            };

        nextButton.attr('disabled', true);

        options.onSubmit(onResult);
    });

    var reenableInputButton = $('<input></input>');
    reenableInputButton.addClass('enableAfterSubmission');
    reenableInputButton.attr('type', 'button');
    reenableInputButton.attr('value', 'Re-enable input');

    reenableInputButton.click(function() {
        enableFormElementsUnder(options.target);
        options.onReenable();

        expand(parameterSpecificationHeader);
        collapse(parameterConditionalityHeader);

        reenableInputDescription.hide();
        reenableInputButton.attr('disabled', true);
        reenableInputButton.hide();
        nextButton.show();
        cancelButton.show();
    });

    reenableInputButton.hide();

    var cancelButton = $('<input></input>');
    cancelButton.attr('type', 'button');
    cancelButton.attr('value', 'Cancel');
    cancelButton.click(cancelForm);

    if (!options.showConditionalitySpecification) {
        editDomainsButton.hide();
        moveToConditionalityAndProhibitedConfigurationsButton.hide();
        nextButton.show();
        reenableInputButton.hide();
        cancelButton.show();
    }

    nextReenableCancelButtons.append($('<hr>'));
    nextReenableCancelButtons.append(reenableInputDescription);
    nextReenableCancelButtons.append(editDomainsButton);
    nextReenableCancelButtons.append(moveToConditionalityAndProhibitedConfigurationsButton);
    nextReenableCancelButtons.append(nextButton);
    nextReenableCancelButtons.append(reenableInputButton);
    nextReenableCancelButtons.append(cancelButton);
    //////
    var parameterSections = $('<div></div>');
    parameterSections.append(parameterSpecificationContainer);

    if (options.showConditionalitySpecification) {
        parameterSections.append(parameterConditionalityContainer);
    }

    parameterSections.append(nextReenableCancelButtons);

    options.target.append(parameterSections);
}

function createAlgorithmImplementationSpecification(options) {
    var target = options.target;
    var formReference = options.formReference;

    // Name
    var newAlgorithmNameLabel = $('<label></label>');
    newAlgorithmNameLabel.attr('for', options.idPrefix + 'algorithmName');
    newAlgorithmNameLabel.html('Algorithm name');

    var newAlgorithmNameField = $('<input></input>');
    newAlgorithmNameField.attr('id', options.idPrefix + 'algorithmName');
    newAlgorithmNameField.attr('name', options.idPrefix + 'algorithmName');
    newAlgorithmNameField.attr('type', 'text');
    newAlgorithmNameField.attr('size', 50);

    var newAlgorithmName = $('<div></div>');
    newAlgorithmName.addClass('formElement');
    newAlgorithmName.append(newAlgorithmNameLabel);
    newAlgorithmName.append(newAlgorithmNameField);

    target.append(newAlgorithmName);
    //////
    // Version
    var newAlgorithmVersionLabel = $('<label></label>');
    newAlgorithmVersionLabel.attr('for', options.idPrefix + 'algorithmVersion');
    newAlgorithmVersionLabel.html('Algorithm version (optional)');

    var newAlgorithmVersionField = $('<input></input>');
    newAlgorithmVersionField.attr('id', options.idPrefix + 'algorithmVersion');
    newAlgorithmVersionField.attr('name', options.idPrefix + 'algorithmVersion');
    newAlgorithmVersionField.attr('type', 'text');
    newAlgorithmVersionField.attr('size', 50);

    var newAlgorithmVersion = $('<div></div>');
    newAlgorithmVersion.addClass('formElement');
    newAlgorithmVersion.append(newAlgorithmVersionLabel);
    newAlgorithmVersion.append(newAlgorithmVersionField);

    target.append(newAlgorithmVersion);
    //////
    // Description
    var newAlgorithmDescriptionLabel = $('<label></label>');
    newAlgorithmDescriptionLabel.attr('for', options.idPrefix + 'algorithmDescription');
    newAlgorithmDescriptionLabel.html('Description / notes (optional)');

    var newAlgorithmDescriptionField = $('<textarea></textarea>');
    newAlgorithmDescriptionField.attr('id', options.idPrefix + 'algorithmDescription');
    newAlgorithmDescriptionField.attr('name', options.idPrefix + 'algorithmDescription');
    newAlgorithmDescriptionField.attr('cols', 75);
    newAlgorithmDescriptionField.attr('rows', 6);

    var newAlgorithmDescription = $('<div></div>');
    newAlgorithmDescription.addClass('formElement');
    newAlgorithmDescription.append(newAlgorithmDescriptionLabel);
    newAlgorithmDescription.append(newAlgorithmDescriptionField);

    target.append(newAlgorithmDescription);
    //////
    // Tags
    var newAlgorithmTagsHeaderText = $('<span></span>');
    newAlgorithmTagsHeaderText.html('Supported instance tag sets');

    var newAlgorithmTagsHeaderLink = $('<a></a>');
    newAlgorithmTagsHeaderLink.append(newAlgorithmTagsHeaderText).attr('id', 'newAlgorithmTagsHeaderLink');

    var newAlgorithmTagsHeader = $('<div></div>');
    newAlgorithmTagsHeader.addClass('collapsed');
    newAlgorithmTagsHeader.append(newAlgorithmTagsHeaderLink);

    var newAlgorithmTagsContent = $('<div></div>');
    newAlgorithmTagsContent.addClass('collapsibleContent');

    //	var tagSetDescription = $('<div></div>');
    //	tagSetDescription.addClass('formFieldDescription');
    //	tagSetDescription.html('Please specify each of the allowed sets of instance tags supported by this algorithm. Each tag set should be a comma-separated list of tags, and you may use the drop-down selector to insert tags that are already defined in HAL.');
    //	newAlgorithmTagsContent.append(tagSetDescription);
    //	
    //	var tagSetContainer = $('<div></div>');
    //	newAlgorithmTagsContent.append(tagSetContainer);
    //
    //	var numTags = 0;
    //	var numTagsField = $('<input></input>');
    //	numTagsField.attr('type', 'hidden');
    //	numTagsField.attr('name', options.idPrefix+'numberOfTagSets');
    //	numTagsField.attr('id', options.idPrefix+'numberOfTagSets');
    //	numTagsField.attr('value', numTags);
    //	newAlgorithmTagsContent.append(numTagsField);
    //	
    //	var addTagSetButton = $('<input></input>');
    //	addTagSetButton.attr('id', options.idPrefix+'addTagSetButton');
    //	addTagSetButton.attr('type', 'button');
    //	addTagSetButton.attr('value', 'Add tag set');
    //	addTagSetButton.click(function() {		
    //		var newTagSetDiv = $('<div></div>');
    //		tagSetContainer.append(newTagSetDiv);
    //		
    //		createTagSelector({'target' : newTagSetDiv, 'removable' : true, 'idPrefix' : options.idPrefix+'tagSet_'+numTags+'_'});
    //		
    //		numTags = numTags+1;
    //		numTagsField.val(numTags);
    //	});
    //	
    //	newAlgorithmTagsContent.append(addTagSetButton);
    createMultipleTagSetSelector({
        target: newAlgorithmTagsContent,
        idPrefix: options.idPrefix,
        description: 'Please specify each of the allowed sets of instance tags supported by this algorithm. Each tag set should be a comma-separated list of tags, and you may use the drop-down selector to insert tags that are already defined in HAL.'
    });

    var newAlgorithmTagsContainer = $('<div></div>');
    newAlgorithmTagsContainer.addClass('collapsible');
    newAlgorithmTagsContainer.append(newAlgorithmTagsHeader);
    newAlgorithmTagsContainer.append(newAlgorithmTagsContent);

    target.append(newAlgorithmTagsContainer);

    collapsible(newAlgorithmTagsContainer);
    //////
    // Properties / advanced
    var newAlgorithmAdvancedPropertiesHeaderText = $('<span></span>');
    newAlgorithmAdvancedPropertiesHeaderText.html('Advanced algorithm properties');

    var newAlgorithmAdvancedPropertiesHeaderLink = $('<a></a>').attr('id', 'newAlgorithmAdvancedPropertiesHeaderLink');
    newAlgorithmAdvancedPropertiesHeaderLink.append(newAlgorithmAdvancedPropertiesHeaderText);

    var newAlgorithmAdvancedPropertiesHeader = $('<div></div>');
    newAlgorithmAdvancedPropertiesHeader.addClass('collapsed');
    newAlgorithmAdvancedPropertiesHeader.append(newAlgorithmAdvancedPropertiesHeaderLink)
    .append($('<a></a>').append($('<img></img>').attr({ 'src': '/hal/commands/getFile/web/icons/question_mark.png' })).click(function() { window.open('/jsp/HelpPage.jsp#exportableAlgorithm'); }));

    var newAlgorithmAdvancedPropertiesContent = $('<div></div>');
    newAlgorithmAdvancedPropertiesContent.addClass('collapsibleContent');

    var newAlgorithmDeterministicLabel = $('<label></label>');
    newAlgorithmDeterministicLabel.addClass('width200');
    newAlgorithmDeterministicLabel.attr('for', options.idPrefix + 'isDeterministic');
    newAlgorithmDeterministicLabel.html('Is your algorithm deterministic?')

    var newAlgorithmDeterministicField = $('<input></input>');
    newAlgorithmDeterministicField.attr('id', options.idPrefix + 'isDeterministic');
    newAlgorithmDeterministicField.attr('name', options.idPrefix + 'isDeterministic');
    newAlgorithmDeterministicField.attr('type', 'checkbox');

    var newAlgorithmDeterministicProperty = $('<div></div>');
    newAlgorithmDeterministicProperty.addClass('formElementInline');
    newAlgorithmDeterministicProperty.append(newAlgorithmDeterministicLabel);
    newAlgorithmDeterministicProperty.append(newAlgorithmDeterministicField);
    newAlgorithmAdvancedPropertiesContent.append(newAlgorithmDeterministicProperty);

    var newAlgorithmExportableLabel = $('<label></label>');
    newAlgorithmExportableLabel.addClass('width200');
    newAlgorithmExportableLabel.attr('for', options.idPrefix + 'isExportable');
    newAlgorithmExportableLabel.html('Is your algorithm exportable?')

    var newAlgorithmExportableField = $('<input></input>');
    newAlgorithmExportableField.attr('id', options.idPrefix + 'isExportable');
    newAlgorithmExportableField.attr('name', options.idPrefix + 'isExportable');
    newAlgorithmExportableField.attr('type', 'checkbox');

    var newAlgorithmExportableProperty = $('<div></div>');
    newAlgorithmExportableProperty.addClass('formElementInline');
    newAlgorithmExportableProperty.append(newAlgorithmExportableLabel);
    newAlgorithmExportableProperty.append(newAlgorithmExportableField);
    newAlgorithmAdvancedPropertiesContent.append(newAlgorithmExportableProperty);

    var newAlgorithmCutoffAgnosticLabel = $('<label></label>');
    newAlgorithmCutoffAgnosticLabel.addClass('width200');
    newAlgorithmCutoffAgnosticLabel.attr('for', options.idPrefix + 'isCutoffAgnostic');
    newAlgorithmCutoffAgnosticLabel.html('Is the algorithm behaviour independent of the cutoff?')

    var newAlgorithmCutoffAgnosticField = $('<input></input>');
    newAlgorithmCutoffAgnosticField.attr('id', options.idPrefix + 'isCutoffAgnostic');
    newAlgorithmCutoffAgnosticField.attr('name', options.idPrefix + 'isCutoffAgnostic');
    newAlgorithmCutoffAgnosticField.attr('type', 'checkbox');

    var newAlgorithmCutoffAgnosticProperty = $('<div></div>');
    newAlgorithmCutoffAgnosticProperty.addClass('formElementInline');
    newAlgorithmCutoffAgnosticProperty.append(newAlgorithmCutoffAgnosticLabel);
    newAlgorithmCutoffAgnosticProperty.append(newAlgorithmCutoffAgnosticField);
    newAlgorithmAdvancedPropertiesContent.append(newAlgorithmCutoffAgnosticProperty);

    var newAlgorithmAdvancedPropertiesContainer = $('<div></div>');
    newAlgorithmAdvancedPropertiesContainer.addClass('collapsible');
    newAlgorithmAdvancedPropertiesContainer.append(newAlgorithmAdvancedPropertiesHeader);
    newAlgorithmAdvancedPropertiesContainer.append(newAlgorithmAdvancedPropertiesContent);

    target.append(newAlgorithmAdvancedPropertiesContainer);

    collapsible(newAlgorithmAdvancedPropertiesContainer);
    //////
    // Executable path
    var newAlgorithmExecutablePathLabel = $('<label></label>');
    newAlgorithmExecutablePathLabel.attr('for', options.idPrefix + 'implementationExecutablePath');
    newAlgorithmExecutablePathLabel.html('File system path to the algorithm executable');

    var newAlgorithmExecutablePathField = $('<input></input>');
    newAlgorithmExecutablePathField.attr('id', options.idPrefix + 'implementationExecutablePath');
    newAlgorithmExecutablePathField.attr('name', options.idPrefix + 'implementationExecutablePath');
    newAlgorithmExecutablePathField.attr('type', 'text');
    newAlgorithmExecutablePathField.attr('size', 100);

    var newAlgorithmExecutablePath = $('<div></div>');
    newAlgorithmExecutablePath.addClass('formElement');
    newAlgorithmExecutablePath.append(newAlgorithmExecutablePathLabel);
    newAlgorithmExecutablePath.append(newAlgorithmExecutablePathField);

    target.append(newAlgorithmExecutablePath);
    //////
    // Executable argument string
    var newAlgorithmArgumentStringLabel = $('<label></label>');
    newAlgorithmArgumentStringLabel.attr('for', options.idPrefix + 'argumentString');
    newAlgorithmArgumentStringLabel.html('Command-line argument string specification');
    //<a onClick="window.open(\'/jsp/HelpPage.jsp#callstring\');" style="background-color: #3A87AD; color: white">&nbsp;?&nbsp;</a>
    var newAlgorithmArgumentStringDescription = $('<div></div>');
    newAlgorithmArgumentStringDescription.addClass('formFieldDescription');
    newAlgorithmArgumentStringDescription.html('Please specify the algorithm command-line argument string, with parameter values surrounded by \'$\', and optional portions surrounded by \'[\' and \']\'. For example, "--instance $instanceFile$ --seed $seed$ --parameterOne $p1$ [--parameterTwo $p2$]".&nbsp;&nbsp;');

    var newAlgorithmArgumentStringField = $('<textarea></textarea>');
    newAlgorithmArgumentStringField.attr('id', options.idPrefix + 'argumentString');
    newAlgorithmArgumentStringField.attr('name', options.idPrefix + 'argumentString');
    newAlgorithmArgumentStringField.attr('cols', 75);
    newAlgorithmArgumentStringField.attr('rows', 6);

    var newAlgorithmArgumentString = $('<div></div>');
    newAlgorithmArgumentString.addClass('formElement');
    newAlgorithmArgumentString.append(newAlgorithmArgumentStringLabel)
//    .append($('<a></a>').html('?').css('background-color','#3A87AD').css('color','white').click(function() {
//    	window.open('/jsp/HelpPage.jsp#callstring');
//    }));
    // <a onClick="window.open(\'/jsp/HelpPage.jsp#callstring\');" style="background-color: #3A87AD; color: white">?</a>
    
    newAlgorithmArgumentString.append(newAlgorithmArgumentStringDescription);
    //newAlgorithmArgumentString.append("<div style='inline'><a style='background-color:#3A87AD; color:white'>?</a></div>");
    //newAlgorithmArgumentStringDescription.append("<a style='background-color:#3A87AD; color:white'>&nbsp;?&nbsp;</a>")
    newAlgorithmArgumentStringDescription.append($('<a></a>').append($('<img></img>').attr({ 'src': '/hal/commands/getFile/web/icons/question_mark.png' })).click(function() {
    	window.open('/jsp/HelpPage.jsp#callstring');
    }));
    newAlgorithmArgumentString.append(newAlgorithmArgumentStringField);

    target.append(newAlgorithmArgumentString);
    //////
    // Executable output strings
    var newAlgorithmOutputStringsHeaderText = $('<span></span>');
    newAlgorithmOutputStringsHeaderText.html('Algorithm output specification');

    var newAlgorithmOutputStringsHeaderLink = $('<a></a>');
    newAlgorithmOutputStringsHeaderLink.append(newAlgorithmOutputStringsHeaderText);

    var newAlgorithmOutputStringsHeader = $('<div></div>');
    newAlgorithmOutputStringsHeader.addClass('expanded');
    newAlgorithmOutputStringsHeader.append(newAlgorithmOutputStringsHeaderLink);

    var newAlgorithmOutputStringsContent = $('<div></div>');
    newAlgorithmOutputStringsContent.addClass('collapsibleContent');

    var outputStringsDescription = $('<div></div>');
    outputStringsDescription.addClass('formFieldDescription');
    outputStringsDescription.html('Please specify regular expressions for capturing output, with each output variable surrounded by \'$\', and optional portions surrounded by \'[\' and \']\'.<br/>WARNING: Each line in the text field will be matched separately.');
    newAlgorithmOutputStringsContent.append(outputStringsDescription);

    var outputStringsContainer = $('<div></div>');
    newAlgorithmOutputStringsContent.append(outputStringsContainer);

    var numOutputStrings = 0;
    var numOutputStringsField = $('<input></input>');
    numOutputStringsField.attr('type', 'hidden');
    numOutputStringsField.attr('name', options.idPrefix + 'numberOfOutputStrings');
    numOutputStringsField.attr('id', options.idPrefix + 'numberOfOutputStrings');
    numOutputStringsField.attr('value', numOutputStrings);
    newAlgorithmOutputStringsContent.append(numOutputStringsField);

    var addOutputStringButton = $('<input></input>');
    addOutputStringButton.attr('type', 'button');
    addOutputStringButton.attr('value', 'Add output capture string');
    addOutputStringButton.attr('id', 'newAlgorithm_implementation_addCaptureStringButton');
    addOutputStringButton.click(function() {
        var newOutputStringDiv = $('<div></div>');
        outputStringsContainer.append(newOutputStringDiv);

        createOutputStringField({
            'target': newOutputStringDiv,
            'removable': true,
            'idPrefix': options.idPrefix + 'outputString_' + numOutputStrings + '_'
        });

        numOutputStrings = numOutputStrings + 1;
        numOutputStringsField.val(numOutputStrings);
    });

    newAlgorithmOutputStringsContent.append(addOutputStringButton);


    var newAlgorithmOutputStringsContainer = $('<div></div>');
    newAlgorithmOutputStringsContainer.addClass('collapsible');
    newAlgorithmOutputStringsContainer.append(newAlgorithmOutputStringsHeader);
    newAlgorithmOutputStringsContainer.append(newAlgorithmOutputStringsContent);

    target.append(newAlgorithmOutputStringsContainer);

    collapsible(newAlgorithmOutputStringsContainer);
    //////
    // Buttons
    var newAlgorithmImplementationButtons = $('<div></div>');
    newAlgorithmImplementationButtons.addClass('center');

    var newAlgorithmImplementationReenableInputDescription = $('<div></div>');
    newAlgorithmImplementationReenableInputDescription.addClass('formFieldDescriptionCentered');
    newAlgorithmImplementationReenableInputDescription.html('Please click the button below if you wish to edit the basic algorithm specification after submission. WARNING: this may cause some of your data in the subsequent areas of the form to be removed.');
    newAlgorithmImplementationReenableInputDescription.hide();


    // changed button value to "next" since
    // the word "validate" could be misleading
    var newAlgorithmImplementationValidateButton = $('<input></input>');
    newAlgorithmImplementationValidateButton.attr('type', 'button');
    newAlgorithmImplementationValidateButton.attr('value', 'Next');
    newAlgorithmImplementationValidateButton.attr('id', 'newAlgorithmImplementationValidateButton');

    newAlgorithmImplementationValidateButton.click(function() {
        options.errorsTarget.html('');
        options.errorsTarget.hide();

        var onResult = function(result) {
                newAlgorithmImplementationValidateButton.attr('disabled', false);

                if (result.successful) {
                    disableFormElementsUnder(options.target);

                    newAlgorithmImplementationValidateButton.hide();
                    newAlgorithmImplementationCancelButton.hide();
                    newAlgorithmImplementationReenableInputDescription.show();

                    newAlgorithmImplementationReenableInputButton.attr('disabled', false);
                    newAlgorithmImplementationReenableInputButton.show();

                    options.onSuccess(result);
                } else {
                    options.errorsTarget.removeClass('alert').removeClass('success');
                    options.errorsTarget.addClass('error');

                    options.errorsTarget.html(result.errorMessage);
                    options.errorsTarget.show();
                }
            };

        newAlgorithmImplementationValidateButton.attr('disabled', true);
        options.onSubmit(onResult);
    });

    var newAlgorithmImplementationReenableInputButton = $('<input></input>');
    newAlgorithmImplementationReenableInputButton.addClass('enableAfterSubmission');
    newAlgorithmImplementationReenableInputButton.attr('type', 'button');
    newAlgorithmImplementationReenableInputButton.attr('value', 'Re-enable input');

    newAlgorithmImplementationReenableInputButton.click(function() {
        enableFormElementsUnder(options.target);
        options.onReenable();

        newAlgorithmImplementationReenableInputDescription.hide();
        newAlgorithmImplementationReenableInputButton.attr('disabled', true);
        newAlgorithmImplementationReenableInputButton.hide();
        newAlgorithmImplementationValidateButton.show();
        newAlgorithmImplementationCancelButton.show();
    });

    newAlgorithmImplementationReenableInputButton.hide();

    var newAlgorithmImplementationCancelButton = $('<input></input>');
    newAlgorithmImplementationCancelButton.attr('type', 'button');
    newAlgorithmImplementationCancelButton.attr('value', 'Cancel');
    newAlgorithmImplementationCancelButton.click(cancelForm);

    newAlgorithmImplementationButtons.append($('<hr>'));
    newAlgorithmImplementationButtons.append(newAlgorithmImplementationReenableInputDescription);
    newAlgorithmImplementationButtons.append(newAlgorithmImplementationValidateButton);
    newAlgorithmImplementationButtons.append(newAlgorithmImplementationReenableInputButton);
    newAlgorithmImplementationButtons.append(newAlgorithmImplementationCancelButton);

    target.append(newAlgorithmImplementationButtons);
    //////
    // handle defaults
    if (!(options.defaults == undefined)) {
        newAlgorithmNameField.val(options.defaults.name);
        newAlgorithmVersionField.val(options.defaults.version);
        newAlgorithmDescriptionField.val(options.defaults.description);

        //tags
        if (options.defaults.tags.length > 0) {
            $('#newAlgorithmTagsHeaderLink').click();
            for (var i in options.defaults.tags) {
                $('#newAlgorithm_implementation_addTagSetButton').click();
                $('#newAlgorithm_implementation_tagSet_' + i + '_tagField').val(options.defaults.tags[i]);
            }
        }

        //advanced properties
        $('#newAlgorithmAdvancedPropertiesHeaderLink').click();

        newAlgorithmDeterministicField.each(function() {
            this.checked = options.defaults.deterministic;
        });
        newAlgorithmExportableField.each(function() {
            this.checked = options.defaults.exportable;
        });
        newAlgorithmCutoffAgnosticField.each(function() {
            this.checked = options.defaults.cutoffAgnostic;
        });

        newAlgorithmExecutablePathField.val(options.defaults.executablePath);
        newAlgorithmArgumentStringField.val(options.defaults.argumentString);

        var filloutputFields = function() {
                var outputs_counter = 0;

                if (!(options.defaults.stdoutOutput == undefined)) {
                    for (var i in options.defaults.stdoutOutput) {
                        $('#newAlgorithm_implementation_addCaptureStringButton').click();
                        $('#newAlgorithm_implementation_outputString_' + outputs_counter + '_outputTypeField').val('stdout');
                        $('#newAlgorithm_implementation_outputString_' + outputs_counter + '_outputStringField').val(options.defaults.stdoutOutput[i]);
                        outputs_counter = outputs_counter + 1;

                    }
                }

                if (!(options.defaults.stderrOutput == undefined)) {
                    for (var i in options.defaults.stderrOutput) {
                        $('#newAlgorithm_implementation_addCaptureStringButton').click();
                        $('#newAlgorithm_implementation_outputString_' + outputs_counter + '_outputTypeField').val('stderr');
                        $('#newAlgorithm_implementation_outputString_' + outputs_counter + '_outputStringField').val(options.defaults.stderrOutput[i]);
                        outputs_counter = outputs_counter + 1;
                    }
                }
            }();

    }
}

function createNewAlgorithmForm(options) {

    var newAlgorithmForm = $('<form></form>');
    newAlgorithmForm.attr('id', 'newAlgorithm');

    var newAlgorithmFormAllContents = $('<div></div>');
    newAlgorithmFormAllContents.addClass('formContent');

    newAlgorithmFormAllContents.append(newAlgorithmForm);
    //newAlgorithmFormAllContents.hide();
    var newAlgorithmContents = $('<div></div>');
    newAlgorithmContents.attr('id', 'newAlgorithm_formContent');
    newAlgorithmForm.append(newAlgorithmContents);

    // New or clone an algorithm
    var newAlgorithmCreationModeSectionHeaderText = $('<span></span>').html('Algorithm creation mode');

    var newAlgorithmCreationModeSectionHeaderLink = $('<a></a>').append(newAlgorithmCreationModeSectionHeaderText);

    var newAlgorithmCreationModeSectionHeader = $('<div></div>').addClass('expanded').append(newAlgorithmCreationModeSectionHeaderLink);

    var newAlgorithmCreationModeSectionContent = $('<div></div>').attr('id', 'newAlgorithm_creationModeSectionContent').addClass('collapsibleContent');

    var newAlgorithmCreationModeSectionContainer = $('<div></div>').attr('id', 'newAlgorithm_creationModeSectionContainer').addClass('collapsible').append(newAlgorithmCreationModeSectionHeader).append(newAlgorithmCreationModeSectionContent);

    newAlgorithmContents.append(newAlgorithmCreationModeSectionContainer);

    collapsible(newAlgorithmCreationModeSectionContainer);

    // Clone mode form
    var newAlgorithmCloneModeSectionHeaderText = $('<span></span>').html('Clone an existing algorithm');
    var newAlgorithmCloneModeSectionHeaderLink = $('<a></a>').append(newAlgorithmCloneModeSectionHeaderText);
    var newAlgorithmCloneModeSectionHeader = $('<div></div>').addClass('collapsed').append(newAlgorithmCloneModeSectionHeaderLink);

    var newAlgorithmCloneModeSectionContent = $('<div></div>').attr('id', 'newAlgorithmCloneModeSectionContent').addClass('collapsibleContent');

    var newAlgorithmCloneModeSection = $('<div></div>').attr('id', 'newAlgorithm_cloneModeSection').addClass('collapsible').append(newAlgorithmCloneModeSectionHeader).append(newAlgorithmCloneModeSectionContent).hide();

    newAlgorithmContents.append(newAlgorithmCloneModeSection);
    collapsible(newAlgorithmCloneModeSection);

    // Creation Mode content
    var creationModeRootUL = $('<div></div>');
    //$('<ul></ul>');
    var newModeLink =
    //$('<a></a>')
    $('<input></input>').attr('type', 'button').attr('value', 'Define new algorithm')
    //.attr('href','#')
    .click(function() {

        $.ajax({
            url: '/hal/getFormSnippet/utilities/getOtherAlgorithmSettingsSemantics',
            data: {
                'hal_httpResponseContentType': 'json'
            },
            success: function(data) {
                disableFormElementsUnder(creationModeRootUL);

                collapse(newAlgorithmCreationModeSectionHeader);

                // hide the lower sections in case the user is jumping back.
                newAlgorithmConfigurableParameterSpecification.hide();
                newAlgorithmOtherSettingsSpecification.hide();
                newAlgorithmOutputSpecification.hide();

                getOutputSemanticsOptions(data);

                newAlgorithmImplementationSection.show();
                expand(newAlgorithmImplementationSectionHeader);
            },
            dataType: 'json'
        });

        return false;
    });


    var cloneModeLink =
    //$('<a></a>')
    $('<input></input>').attr('type', 'button').attr('value', 'Clone an existing algorithm')
    //.attr('href','#');
    .click(function() {
        disableFormElementsUnder(creationModeRootUL);

        // add content to the clone mode container
        collapse(newAlgorithmCreationModeSectionHeader);

        // hide the lower sections in case the user is jumping back.
        newAlgorithmConfigurableParameterSpecification.hide();
        newAlgorithmOtherSettingsSpecification.hide();
        newAlgorithmOutputSpecification.hide();

        newAlgorithmCloneModeSection.show();
        expand(newAlgorithmCloneModeSectionHeader);

        var spinnerDiv = $('<div></div>').addClass('spinner')
        //.addClass('center')
        .html($('<img></img').attr('src', '/hal/commands/getFile/web/icons/ajax-loader.gif').attr('alt', 'Loading. Please wait.'));

        var cloneModeSelectorDiv = $('<div></div>');

        var cloneModeButtonBarDiv = $('<div></div>').addClass('center');

        var cloneModeErrorDiv = $('<div></div>');

        newAlgorithmCloneModeSectionContent.append(spinnerDiv).append(cloneModeSelectorDiv).append(cloneModeErrorDiv).append(cloneModeButtonBarDiv);

        $.ajax({
            url: '/jsp/getParameterizedAlgorithmNames.jsp',
            dataType: 'json',
            success: function(data) {
                if (!data.successful) {
                    cloneModeErrorDiv.addClass('error').html(data.error);

                    spinnerDiv.remove();

                    var cloneModeCancelButton = $('<input></input>').attr('type', 'button').attr('value', 'Cancel').appendTo(cloneModeButtonBarDiv).click(cancelForm);
                } else {
                    if (data.result.algorithmNames.length < 1) {
                        // output some error message
                    } else {
                        var algorithmNames = data.result.algorithmNames;

                        // create the selector box
                        var parameterizedAlgorithmSelectionBox = $('<select></select>');

                        var emptySelector = $('<option></option>').attr('id', 'empty').attr('value', '').html('Select an Existing Algorithm');

                        parameterizedAlgorithmSelectionBox.append(emptySelector);

                        for (var i in algorithmNames) {
                            $('<option></option>').attr('id', algorithmNames[i].name).attr('value', algorithmNames[i].name).html(algorithmNames[i].name).appendTo(parameterizedAlgorithmSelectionBox);
                        }

                        // add the box to the ui
                        spinnerDiv.remove();

                        //newAlgorithmCloneModeSectionContent
                        cloneModeSelectorDiv.append(parameterizedAlgorithmSelectionBox);

                        // create next button
                        $('<hr></hr>').appendTo(cloneModeButtonBarDiv);
                        
                        var cloneModeCancelButton = $('<input></input>').attr('type', 'button').attr('value', 'Cancel').click(cancelForm);
                        
                        var cloneModeSectionNextButton = $('<input></input>').attr('type', 'button').attr('value', 'Next')
                        //.appendTo(newAlgorithmCloneModeSectionContent)
                        .click(function() {
                            var algName = parameterizedAlgorithmSelectionBox.val();

                            if (algName != '') {
                                $.ajax({
                                    url: '/jsp/getAlgorithmJSON.jsp',
                                    data: {
                                        algorithmName: algName
                                    },
                                    dataType: 'json',
                                    success: function(data) {
                                        if (data.successful) {

                                            $.ajax({
                                                url: '/hal/getFormSnippet/utilities/getOtherAlgorithmSettingsSemantics',
                                                data: {
                                                    'hal_httpResponseContentType': 'json'
                                                },
                                                dataType: 'json',
                                                success: function(semantic_data) {
                                                    disableFormElementsUnder(cloneModeSelectorDiv);
                                                    cloneModeSectionNextButton.remove();

                                                    var algorithmObj = createAlgorithmObject(data.result.algorithm);
                                                    options.defaults = algorithmObj;

                                                    collapse(newAlgorithmCloneModeSectionHeader);

                                                    // hide the lower sections in case the user is jumping back.
                                                    newAlgorithmConfigurableParameterSpecification.hide();
                                                    newAlgorithmOtherSettingsSpecification.hide();
                                                    newAlgorithmOutputSpecification.hide();

                                                    getOutputSemanticsOptions(semantic_data);

                                                    newAlgorithmImplementationSection.show();
                                                    expand(newAlgorithmImplementationSectionHeader);
                                                }

                                                //	                               				});
                                                //	                                    	   cloneModeSectionNextButton.remove();
                                                //	                                    	   disableFormElementsUnder(cloneModeSelectorDiv);
                                                //	                                    	   
                                                //	                                           var algorithmObj = createAlgorithmObject(data.result.algorithm);
                                                //	                                           options.defaults = algorithmObj;
                                                //	                                           
                                                //	                                           collapse(newAlgorithmCloneModeSectionHeader);
                                                //
                                                //	                       					   // hide the lower sections in case the user is jumping back.
                                                //	                                           newAlgorithmConfigurableParameterSpecification.hide();
                                                //	                                       	   newAlgorithmOtherSettingsSpecification.hide();
                                                //	                                       	   newAlgorithmOutputSpecification.hide();
                                                //
                                                //	                       					   getOutputSemanticsOptions(data);
                                                //
                                                //	                       					   newAlgorithmImplementationSection.show();
                                                //	                       					   expand(newAlgorithmImplementationSectionHeader);
                                                //}
                                                //} 
                                            });
                                        }
                                    }
                                });

                                

                            }

                        });
                        //}
                        
                        cloneModeButtonBarDiv.append(cloneModeSectionNextButton).append(cloneModeCancelButton);
                    }
                }
            }
        });
    });

    for (var i in o = [newModeLink, cloneModeLink]) {
        //$('<li></li>').append(o[i]).appendTo(creationModeRootUL);
        creationModeRootUL.append(o[i]);
    }

    newAlgorithmCreationModeSectionContent.append($('<div></div>').addClass('formFieldDescription').html('Define a brand new algorithm or clone an already defined algorithm.'));
    newAlgorithmCreationModeSectionContent.append(creationModeRootUL);

    // Implementation
    var newAlgorithmImplementationSectionHeaderText = $('<span></span>').html('Basic algorithm specification');

    var newAlgorithmImplementationSectionHeaderLink = $('<a></a>').append(newAlgorithmImplementationSectionHeaderText);

    var newAlgorithmImplementationSectionHeader = $('<div></div>').addClass('collapsed').append(newAlgorithmImplementationSectionHeaderLink);

    var newAlgorithmImplementationSectionContent = $('<div></div>').attr('id', 'newAlgorithm_implementationSectionContent').addClass('collapsibleContent');

    var newAlgorithmImplementationSection = $('<div></div>').attr('id', 'newAlgorithm_implementationSection').addClass('collapsible').append(newAlgorithmImplementationSectionHeader).append(newAlgorithmImplementationSectionContent).hide();

    newAlgorithmContents.append(newAlgorithmImplementationSection);


    collapsible(newAlgorithmImplementationSection);

    var implementationValues;
    //////
    // Configurable parameter identification
    var newAlgorithmConfigurableParameterSelectionHeaderText = $('<span></span>').html('Identify automatically configurable parameters');

    var newAlgorithmConfigurableParameterSelectionHeaderLink = $('<a></a>').append(newAlgorithmConfigurableParameterSelectionHeaderText);

    var newAlgorithmConfigurableParameterSelectionHeader = $('<div></div>').addClass('collapsed').append(newAlgorithmConfigurableParameterSelectionHeaderLink);

    var newAlgorithmConfigurableParameterSelectionContent = $('<div></div>').attr('id', 'newAlgorithm_configurableParameterSelectionContent').addClass('collapsibleContent');

    var newAlgorithmConfigurableParameterSelection = $('<div></div>').attr('id', 'newAlgorithm_configurableParameterSelection').addClass('collapsible').append(newAlgorithmConfigurableParameterSelectionHeader).append(newAlgorithmConfigurableParameterSelectionContent).hide();

    newAlgorithmForm.append(newAlgorithmConfigurableParameterSelection);

    collapsible(newAlgorithmConfigurableParameterSelection);
    //////
    // Specify configurable parameters
    var newAlgorithmConfigurableParameterSpecificationHeaderText = $('<span></span>').html('Specify domains and conditionality for the automatically configurable parameters');

    var newAlgorithmConfigurableParameterSpecificationHeaderLink = $('<a></a>').append(newAlgorithmConfigurableParameterSpecificationHeaderText);

    var newAlgorithmConfigurableParameterSpecificationHeader = $('<div></div>').addClass('collapsed').append(newAlgorithmConfigurableParameterSpecificationHeaderLink);

    var newAlgorithmConfigurableParameterSpecificationContent = $('<div></div>').attr('id', 'newAlgorithm_configurableParameterSpecificationContent').addClass('collapsibleContent');

    var newAlgorithmConfigurableParameterSpecification = $('<div></div>').attr('id', 'newAlgorithm_configurableParameterSpecification').addClass('collapsible').append(newAlgorithmConfigurableParameterSpecificationHeader).append(newAlgorithmConfigurableParameterSpecificationContent).hide();

    newAlgorithmForm.append(newAlgorithmConfigurableParameterSpecification);

    collapsible(newAlgorithmConfigurableParameterSpecification);
    //////
    // Specify other algorithm settings
    var newAlgorithmOtherSettingsSpecificationHeaderText = $('<span></span>').html('Specify domains for the other algorithm settings');

    var newAlgorithmOtherSettingsSpecificationHeaderLink = $('<a></a>').append(newAlgorithmOtherSettingsSpecificationHeaderText);

    var newAlgorithmOtherSettingsSpecificationHeader = $('<div></div>').addClass('collapsed').append(newAlgorithmOtherSettingsSpecificationHeaderLink);

    var newAlgorithmOtherSettingsSpecificationContent = $('<div></div>').attr('id', 'newAlgorithm_otherSettingsSpecificationContent').addClass('collapsibleContent');

    var newAlgorithmOtherSettingsSpecification = $('<div></div>').attr('id', 'newAlgorithm_otherSettingsSpecification').addClass('collapsible').append(newAlgorithmOtherSettingsSpecificationHeader).append(newAlgorithmOtherSettingsSpecificationContent).hide();

    newAlgorithmForm.append(newAlgorithmOtherSettingsSpecification);

    collapsible(newAlgorithmOtherSettingsSpecification);
    //////
    // Specify outputs
    var newAlgorithmOutputSpecificationHeaderText = $('<span></span>').html('Specify domains for the algorithm outputs');

    var newAlgorithmOutputSpecificationHeaderLink = $('<a></a>').append(newAlgorithmOutputSpecificationHeaderText);

    var newAlgorithmOutputSpecificationHeader = $('<div></div>').addClass('collapsed').append(newAlgorithmOutputSpecificationHeaderLink);

    var newAlgorithmOutputSpecificationContent = $('<div></div>').attr('id', 'newAlgorithm_outputSpecificationContent').addClass('collapsibleContent');

    var newAlgorithmOutputSpecification = $('<div></div>').attr('id', 'newAlgorithm_outputSpecification').addClass('collapsible').append(newAlgorithmOutputSpecificationHeader).append(newAlgorithmOutputSpecificationContent).hide();

    newAlgorithmForm.append(newAlgorithmOutputSpecification);

    collapsible(newAlgorithmOutputSpecification);
    //////
    // Hidden validation config fields
    var validationOptions = $('<div></div>');

    var onlyValidate = $('<input></input>').attr('id', 'onlyValidate').attr('name', 'onlyValidate').attr('type', 'hidden').attr('value', 'false');

    //validationOptions.append(onlyValidate);
    var allowImplementationSpecificationErrors = $('<input></input>').attr('id', 'allowImplementationSpecificationErrors').attr('name', 'allowImplementationSpecificationErrors').attr('type', 'hidden').attr('value', 'false');

    //validationOptions.append(allowImplementationSpecificationErrors);
    var allowConfigurableParameterSelectionErrors = $('<input></input>').attr('id', 'allowConfigurableParameterSelectionErrors').attr('name', 'allowConfigurableParameterSelectionErrors').attr('type', 'hidden').attr('value', 'false');

    //validationOptions.append(allowConfigurableParameterSelectionErrors);
    var allowConfigurableParameterSpecificationErrors = $('<input></input>').attr('id', 'allowConfigurableParameterSpecificationErrors').attr('name', 'allowConfigurableParameterSpecificationErrors').attr('type', 'hidden').attr('value', 'false');

    //validationOptions.append(allowConfigurableParameterSpecificationErrors);
    var allowOtherSettingsSpecificationErrors = $('<input></input>').attr('id', 'allowOtherSettingsSpecificationErrors').attr('name', 'allowOtherSettingsSpecificationErrors').attr('type', 'hidden').attr('value', 'false');

    //validationOptions.append(allowOtherSettingsSpecificationErrors);
    var allowOutputSpecificationErrors = $('<input></input>').attr('id', 'allowOutputSpecificationErrors').attr('name', 'allowOutputSpecificationErrors').attr('type', 'hidden').attr('value', 'false');

    //validationOptions.append(allowOutputSpecificationErrors);
    for (var i in o = [onlyValidate, allowImplementationSpecificationErrors, allowConfigurableParameterSelectionErrors, allowConfigurableParameterSpecificationErrors, allowOtherSettingsSpecificationErrors, allowOutputSpecificationErrors]) {
        validationOptions.append(o[i]);
    }

    validationOptions.hide();
    newAlgorithmForm.append(validationOptions);
    //////
    // Buttons
    var newAlgorithmFormButtons = $('<div></div>');
    newAlgorithmFormButtons.addClass('center');

    var newAlgorithmSubmitButton = $('<input></input>');
    newAlgorithmSubmitButton.attr('type', 'button');
    newAlgorithmSubmitButton.attr('value', 'Submit');
    newAlgorithmSubmitButton.click(function() {
        newAlgorithmSubmitButton.attr('disabled', true);

        var spinnerDiv = $('<div></div>');
        spinnerDiv.addClass('spinner');
        spinnerDiv.addClass('center');
        spinnerDiv.html($('<img></img').attr('src', '/hal/commands/getFile/web/icons/ajax-loader.gif').attr('alt', 'Loading. Please wait.'));

        newAlgorithmStatusMessages.removeClass('alert').removeClass('error');
        newAlgorithmStatusMessages.addClass('success');
        newAlgorithmStatusMessages.html(spinnerDiv);
        newAlgorithmStatusMessages.show();

        enableFormElementsUnder(newAlgorithmForm);

        onlyValidate.attr('value', 'false');
        allowImplementationSpecificationErrors.attr('value', 'false');
        allowConfigurableParameterSelectionErrors.attr('value', 'false');
        allowConfigurableParameterSpecificationErrors.attr('value', 'false');
        allowOtherSettingsSpecificationErrors.attr('value', 'false');
        allowOutputSpecificationErrors.attr('value', 'false');

        var formData = newAlgorithmForm.serialize();
        formData['hal_httpResponseContentType'] = 'json';

        $.post('/hal/processFormSnippet/createAlgorithm/createAlgorithm', formData, function(response) {
            newAlgorithmSubmitButton.attr('disabled', false);

            if (response.successful) {
                newAlgorithmStatusMessages.removeClass('alert').removeClass('error');
                newAlgorithmStatusMessages.addClass('success');
                newAlgorithmStatusMessages.addClass('center');
                newAlgorithmStatusMessages.html('New algorithm ' + implementationValues.algorithmName + ' was defined successfully!');
                newAlgorithmStatusMessages.show();

                if ($('#formParent').children().size() > 1) {
                    $('#formParent').children().last().slideUp();
                    $('#formParent').children().last().remove();
                    $('#formParent').children().last().slideDown();

                    for (var i in options.classesToUpdate) {
                        $('.' + options.classesToUpdate[i]).append();

                        $('.' + options.classesToUpdate[i]).val(implementationValues.algorithmName);

                        $('.' + options.classesToUpdate[i]).change();
                    }
                } else {
                    setTimeout("window.location.href = '/hal/'", 1000);
                }
            } else {
                disableFormElementsUnder(newAlgorithmForm);
                enableFormElementsUnder(newAlgorithmFormButtons);
                enableFormElementsUnder(validationOptions);

                newAlgorithmForm.find('.enableAfterSubmission').attr('disabled', false);

                newAlgorithmStatusMessages.removeClass('alert').removeClass('success');
                newAlgorithmStatusMessages.addClass('error');

                newAlgorithmStatusMessages.html(response.errorMessage);
                newAlgorithmStatusMessages.show();
            }
        }, 'json');
    });

    var newAlgorithmCancelButton = $('<input></input>');
    newAlgorithmCancelButton.attr('type', 'button');
    newAlgorithmCancelButton.attr('value', 'Cancel');
    newAlgorithmCancelButton.attr('id', 'newAlgorithmCancelButton');
    newAlgorithmCancelButton.click(cancelForm);

    newAlgorithmFormButtons.append($('<hr>'));
    newAlgorithmFormButtons.append(newAlgorithmSubmitButton);
    newAlgorithmFormButtons.append(newAlgorithmCancelButton);

    newAlgorithmFormButtons.hide();

    newAlgorithmForm.append(newAlgorithmFormButtons);
    //////
    // Status monitoring
    var newAlgorithmStatusMessages = $('<div></div>');
    newAlgorithmStatusMessages.attr('id', 'newAlgorithm_statusMessages');
    newAlgorithmStatusMessages.hide();

    newAlgorithmForm.append(newAlgorithmStatusMessages);
    //////
    options.target.append(newAlgorithmFormAllContents);

    var enableFinalSubmitButtons = function(result) {
            implementationValues = result.validationResult;

            disableFormElementsUnder(newAlgorithmImplementationSectionContent);
            disableFormElementsUnder(newAlgorithmConfigurableParameterSelectionContent);
            disableFormElementsUnder(newAlgorithmConfigurableParameterSpecificationContent);
            disableFormElementsUnder(newAlgorithmOtherSettingsSpecificationContent);
            disableFormElementsUnder(newAlgorithmOutputSpecificationContent);
            newAlgorithmImplementationSectionContent.find('.enableAfterSubmission').attr('disabled', false);
            newAlgorithmConfigurableParameterSelectionContent.find('.enableAfterSubmission').attr('disabled', false);
            newAlgorithmConfigurableParameterSpecificationContent.find('.enableAfterSubmission').attr('disabled', false);
            newAlgorithmOtherSettingsSpecificationContent.find('.enableAfterSubmission').attr('disabled', false);
            newAlgorithmOutputSpecificationContent.find('.enableAfterSubmission').attr('disabled', false);

            // collapse the output section.
            collapse(newAlgorithmOutputSpecificationHeader);

            enableFormElementsUnder(newAlgorithmFormButtons);
            newAlgorithmFormButtons.show();
        };

    // set up output specification after next is pressed in other algorithm settings
    var otherSettingsSpecificationOnSuccess = function(result) {
            implementationValues = result.validationResult;

            disableFormElementsUnder(newAlgorithmImplementationSectionContent);
            disableFormElementsUnder(newAlgorithmConfigurableParameterSelectionContent);
            disableFormElementsUnder(newAlgorithmConfigurableParameterSpecificationContent);
            disableFormElementsUnder(newAlgorithmOtherSettingsSpecificationContent);
            newAlgorithmImplementationSectionContent.find('.enableAfterSubmission').attr('disabled', false);
            newAlgorithmConfigurableParameterSelectionContent.find('.enableAfterSubmission').attr('disabled', false);
            newAlgorithmConfigurableParameterSpecificationContent.find('.enableAfterSubmission').attr('disabled', false);
            newAlgorithmOtherSettingsSpecificationContent.find('.enableAfterSubmission').attr('disabled', false);

            // collapse the specification section
            collapse(newAlgorithmOtherSettingsSpecificationHeader);

            newAlgorithmOutputSpecificationContent.html('');

            var outputParameters = new Array();
            for (var i in implementationValues.outputParameters) {
                var param = implementationValues.outputParameters[i]
                if (options.defaults && options.defaults.outputSpace()[param.name]) {
                    param.hasDomain = true;
                    param.domain = options.defaults.outputSpace()[param.name];
                    param.hasDefaults = options.defaults.outputSpace()[param.name].hasDefaults;
                    param.hasSemantics = options.defaults.outputSpace()[param.name].hasSemantics;
                    param.semantics = options.defaults.outputSpace()[param.name].semantics;

                }

                outputParameters.push(param);
            }


            // initialise the other algorithm settings specification screen
            createParameterSpecification({
                'target': newAlgorithmOutputSpecificationContent,
                'implementationValues': implementationValues,
                'errorsTarget': newAlgorithmStatusMessages,
                'parameters': outputParameters,
                'conditionalityRules': implementationValues.outputParametersConditionalityRules,
                'prohibitedCombinations': implementationValues.outputParametersProhibitedCombinations,
                'idPrefix': 'newAlgorithm_outputParameters_',
                'formReference': newAlgorithmForm,
                'showSemanticsSelector': true,
                'semanticsOptions': outputSemanticsOptions,
                'showDefaultValueField': false,
                'showConditionalitySpecification': false,
                'showTransformationField': false,
                'onReenable': function() {
                    newAlgorithmFormButtons.hide();
                },
                'onSubmit': function(onReturn) {
                    onlyValidate.attr('value', 'true');
                    allowImplementationSpecificationErrors.attr('value', 'false');
                    allowConfigurableParameterSelectionErrors.attr('value', 'false');
                    allowConfigurableParameterSpecificationErrors.attr('value', 'false');
                    allowOtherSettingsSpecificationErrors.attr('value', 'false');
                    allowOutputSpecificationErrors.attr('value', 'false');

                    enableFormElementsUnder(newAlgorithmImplementationSectionContent);
                    enableFormElementsUnder(newAlgorithmConfigurableParameterSelectionContent);
                    enableFormElementsUnder(newAlgorithmConfigurableParameterSpecificationContent);
                    enableFormElementsUnder(newAlgorithmOtherSettingsSpecificationContent);
                    enableFormElementsUnder(newAlgorithmOutputSpecificationContent);

                    var formData = newAlgorithmForm.serialize();

                    $.post('/hal/processFormSnippet/createAlgorithm/createAlgorithm', formData, onReturn, 'json');
                },
                'onSuccess': enableFinalSubmitButtons
            });

            // expand the output specification
            newAlgorithmOutputSpecification.show();
            expand(newAlgorithmOutputSpecificationHeader);
        };

    // set up other algorithm settings specification after next is pressed in configurable param specification
    var configurableParameterSpecificationOnSuccess = function(result) {
            implementationValues = result.validationResult;

            disableFormElementsUnder(newAlgorithmImplementationSectionContent);
            disableFormElementsUnder(newAlgorithmConfigurableParameterSelectionContent);
            disableFormElementsUnder(newAlgorithmConfigurableParameterSpecificationContent);
            newAlgorithmImplementationSectionContent.find('.enableAfterSubmission').attr('disabled', false);
            newAlgorithmConfigurableParameterSelectionContent.find('.enableAfterSubmission').attr('disabled', false);
            newAlgorithmConfigurableParameterSpecificationContent.find('.enableAfterSubmission').attr('disabled', false);

            // collapse the specification section
            collapse(newAlgorithmConfigurableParameterSpecificationHeader);

            // hide the lower sections in case the user is jumping back
            newAlgorithmOutputSpecification.hide();

            newAlgorithmOtherSettingsSpecificationContent.html('');

/*
		var otherAlgorithmSettings = {};
		for (var i in implementationValues.inputParameters) {
			var param = implementationValues.inputParameters[i];
			if (!param.isConfigurable) {
				otherAlgorithmSettings[i] = param;
			}
		}
		*/

            var otherAlgorithmSettings = new Array();
            for (var i in implementationValues.inputParameters) {
                var param = implementationValues.inputParameters[i];
                if (!param.isConfigurable) {
                    if (options.defaults && options.defaults.scenarioSpace()[param.name]) {
                        param.hasDomain = true;
                        param.hasDefaults = options.defaults.scenarioSpace()[param.name].hasDefaults;
                        param.domain = options.defaults.scenarioSpace()[param.name];
                        param.hasSemantics = options.defaults.scenarioSpace()[param.name].hasSemantics;
                        param.semantics = options.defaults.scenarioSpace()[param.name].semantics;
                    }

                    otherAlgorithmSettings.push(param);
                }
            }

            var otherSettingsConditionalityRules = implementationValues.otherSettingsConditionalityRules;
            if (otherSettingsConditionalityRules.length <= 0) {
                if (options.defaults && options.defaults.otherSettingsConditionalityRules().length > 0) {
                    otherSettingsConditionalityRules = options.defaults.otherSettingsConditionalityRules();
                }
            }

            var otherSettingsProhibitedCombinations = implementationValues.otherSettingsProhibitedCombinations;
            if (otherSettingsProhibitedCombinations.length <= 0) {
                if (options.defaults && options.defaults.otherSettingsProhibitedCombinations().length > 0) {
                    otherSettingsProhibitedCombinations = options.defaults.otherSettingsProhibitedCombinations();
                }
            }

            // initialise the other algorithm settings specification screen
            createParameterSpecification({
                'target': newAlgorithmOtherSettingsSpecificationContent,
                'implementationValues': implementationValues,
                'errorsTarget': newAlgorithmStatusMessages,
                'parameters': otherAlgorithmSettings,
                'conditionalityRules': otherSettingsConditionalityRules,
                'prohibitedCombinations': otherSettingsProhibitedCombinations,
                'idPrefix': 'newAlgorithm_otherSettings_',
                'formReference': newAlgorithmForm,
                'showSemanticsSelector': true,
                'semanticsOptions': otherSettingsSemanticsOptions,
                'showDefaultValueField': true,
                'showConditionalitySpecification': true,
                'showTransformationField': true,
                'onReenable': function() {
                    newAlgorithmFormButtons.hide();

                    enableFormElementsUnder(newAlgorithmOutputSpecificationContent);

                    collapse(newAlgorithmOutputSpecificationHeader);
                },
                'onSubmit': function(onReturn) {
                    onlyValidate.attr('value', 'true');
                    allowImplementationSpecificationErrors.attr('value', 'false');
                    allowConfigurableParameterSelectionErrors.attr('value', 'false');
                    allowConfigurableParameterSpecificationErrors.attr('value', 'false');
                    allowOtherSettingsSpecificationErrors.attr('value', 'false');
                    allowOutputSpecificationErrors.attr('value', 'true');

                    enableFormElementsUnder(newAlgorithmImplementationSectionContent);
                    enableFormElementsUnder(newAlgorithmConfigurableParameterSelectionContent);
                    enableFormElementsUnder(newAlgorithmConfigurableParameterSpecificationContent);
                    enableFormElementsUnder(newAlgorithmOtherSettingsSpecificationContent);

                    var formData = newAlgorithmForm.serialize();

                    $.post('/hal/processFormSnippet/createAlgorithm/createAlgorithm', formData, onReturn, 'json');
                },
                'onSuccess': otherSettingsSpecificationOnSuccess
            });

            // expand the other algorithm settings specification
            newAlgorithmOtherSettingsSpecification.show();
            expand(newAlgorithmOtherSettingsSpecificationHeader);
        };

    // set up configurable parameter specification after next is pressed in selection
    var configurableParameterSelectionOnSuccess = function(result) {
            implementationValues = result.validationResult;

            // re-disable the previous sections
            disableFormElementsUnder(newAlgorithmImplementationSectionContent);
            disableFormElementsUnder(newAlgorithmConfigurableParameterSelectionContent);
            newAlgorithmImplementationSectionContent.find('.enableAfterSubmission').attr('disabled', false);
            newAlgorithmConfigurableParameterSelectionContent.find('.enableAfterSubmission').attr('disabled', false);

            // collapse the selection section
            collapse(newAlgorithmConfigurableParameterSelectionHeader);

            // hide the lower sections in case the user is jumping back.
            newAlgorithmOtherSettingsSpecification.hide();
            newAlgorithmOutputSpecification.hide();

            newAlgorithmConfigurableParameterSpecificationContent.html('');

            var configurableParameters = new Array();
            for (var i in implementationValues.inputParameters) {
                var param = implementationValues.inputParameters[i];
                if (param.isConfigurable) {
                    // added for defaults
                    if (options.defaults && options.defaults.configurationSpace()[param.name]) {
                        param.hasDomain = true;
                        param.domain = options.defaults.configurationSpace()[param.name];
                    }

                    configurableParameters.push(param);
                }
            }

            var configurableParameterConditionalityRules = implementationValues.configurableParameterConditionalityRules;
            if (configurableParameterConditionalityRules.length == 0) {
                if (options.defaults && options.defaults.configurableParametersConditionalityRules().length > 0) {
                    configurableParameterConditionalityRules = options.defaults.configurableParametersConditionalityRules();
                }
            }

            var configurableParameterProhibitedCombinations = implementationValues.configurableParameterProhibitedCombinations;
            if (configurableParameterProhibitedCombinations.length == 0) {
                if (options.defaults && options.defaults.configurableParametersProhibitedCombinationRules().length > 0) {
                    configurableParameterProhibitedCombinations = options.defaults.configurableParametersProhibitedCombinationRules();
                }
            }

            // initialise the configurable parameter specification section
            createParameterSpecification({
                'target': newAlgorithmConfigurableParameterSpecificationContent,
                'errorsTarget': newAlgorithmStatusMessages,
                'implementationValues': implementationValues,
                'parameters': configurableParameters,
                'conditionalityRules': configurableParameterConditionalityRules,
                'prohibitedCombinations': configurableParameterProhibitedCombinations,
                'idPrefix': 'newAlgorithm_configurableParameters_',
                'showSemanticsSelector': false,
                'semanticsOptions': undefined,
                'showDefaultValueField': true,
                'showConditionalitySpecification': true,
                'showTransformationField': true,
                'onReenable': function() {
                    newAlgorithmFormButtons.hide();

                    enableFormElementsUnder(newAlgorithmOtherSettingsSpecificationContent);
                    enableFormElementsUnder(newAlgorithmOutputSpecificationContent);

                    collapse(newAlgorithmOtherSettingsSpecificationHeader);
                    collapse(newAlgorithmOutputSpecificationHeader);
                },
                'onSubmit': function(onReturn) {
                    onlyValidate.attr('value', 'true');
                    allowImplementationSpecificationErrors.attr('value', 'false');
                    allowConfigurableParameterSelectionErrors.attr('value', 'false');
                    allowConfigurableParameterSpecificationErrors.attr('value', 'false');
                    allowOtherSettingsSpecificationErrors.attr('value', 'true');
                    allowOutputSpecificationErrors.attr('value', 'true');

                    enableFormElementsUnder(newAlgorithmImplementationSectionContent);
                    enableFormElementsUnder(newAlgorithmConfigurableParameterSelectionContent);
                    enableFormElementsUnder(newAlgorithmConfigurableParameterSpecificationContent);

                    var formData = newAlgorithmForm.serialize();

                    $.post('/hal/processFormSnippet/createAlgorithm/createAlgorithm', formData, onReturn, 'json');
                },
                'onSuccess': configurableParameterSpecificationOnSuccess
            });

            // expand the configurable parameter specification
            newAlgorithmConfigurableParameterSpecification.show();
            expand(newAlgorithmConfigurableParameterSpecificationHeader);
        };

    // fill in the implementation content.
    var implementationOnSuccess = function(result) {
            implementationValues = result.validationResult;

            // re-disable the implementation section
            disableFormElementsUnder(newAlgorithmImplementationSectionContent);
            newAlgorithmImplementationSectionContent.find('.enableAfterSubmission').attr('disabled', false);

            // collapse the implementation section.
            collapse(newAlgorithmImplementationSectionHeader);

            // hide the lower sections in case the user is jumping back.
            newAlgorithmConfigurableParameterSpecification.hide();
            newAlgorithmOtherSettingsSpecification.hide();
            newAlgorithmOutputSpecification.hide();

            newAlgorithmConfigurableParameterSelectionContent.html('');

            // initialise the configurable parameter selection
            var parameterSelectorOptions = {};
            parameterSelectorOptions.target = newAlgorithmConfigurableParameterSelectionContent;
            parameterSelectorOptions.errorsTarget = newAlgorithmStatusMessages;
            parameterSelectorOptions.implementationValues = implementationValues;
            parameterSelectorOptions.idPrefix = "newAlgorithm_isConfigurable_";
            parameterSelectorOptions.onReenable = function() {
                newAlgorithmFormButtons.hide();

                enableFormElementsUnder(newAlgorithmConfigurableParameterSpecificationContent);
                enableFormElementsUnder(newAlgorithmOtherSettingsSpecificationContent);
                enableFormElementsUnder(newAlgorithmOutputSpecificationContent);

                collapse(newAlgorithmConfigurableParameterSpecificationHeader);
                collapse(newAlgorithmOtherSettingsSpecificationHeader);
                collapse(newAlgorithmOutputSpecificationHeader);
            };
            parameterSelectorOptions.onSubmit = function(onReturn) {
                onlyValidate.attr('value', 'true');
                allowImplementationSpecificationErrors.attr('value', 'false');
                allowConfigurableParameterSelectionErrors.attr('value', 'false');
                allowConfigurableParameterSpecificationErrors.attr('value', 'true');
                allowOtherSettingsSpecificationErrors.attr('value', 'true');
                allowOutputSpecificationErrors.attr('value', 'true');

                enableFormElementsUnder(newAlgorithmImplementationSectionContent);
                enableFormElementsUnder(newAlgorithmConfigurableParameterSelectionContent);

                var formData = newAlgorithmForm.serialize();

                $.post('/hal/processFormSnippet/createAlgorithm/createAlgorithm', formData, onReturn, 'json');
            };
            parameterSelectorOptions.onSuccess = configurableParameterSelectionOnSuccess;

            // here defaults refers to known configurable parameters
            if (options.defaults) {
                parameterSelectorOptions.defaults = options.defaults.configurationParameters();
            }

            createConfigurableParameterSelector(parameterSelectorOptions);

/*
		createConfigurableParameterSelector({
			'target' : newAlgorithmConfigurableParameterSelectionContent,
			'errorsTarget' : newAlgorithmStatusMessages,
			'implementationValues' : implementationValues,
			'idPrefix' : 'newAlgorithm_isConfigurable_',
			'onReenable' : function() {
				newAlgorithmFormButtons.hide();
				
				enableFormElementsUnder(newAlgorithmConfigurableParameterSpecificationContent);
				enableFormElementsUnder(newAlgorithmOtherSettingsSpecificationContent);
				enableFormElementsUnder(newAlgorithmOutputSpecificationContent);
				
				collapse(newAlgorithmConfigurableParameterSpecificationHeader);
				collapse(newAlgorithmOtherSettingsSpecificationHeader);
				collapse(newAlgorithmOutputSpecificationHeader);
			},
			'onSubmit' : function(onReturn) {
				onlyValidate.attr('value', 'true');
				allowImplementationSpecificationErrors.attr('value', 'false');
				allowConfigurableParameterSelectionErrors.attr('value', 'false');
				allowConfigurableParameterSpecificationErrors.attr('value', 'true');
				allowOtherSettingsSpecificationErrors.attr('value', 'true');
				allowOutputSpecificationErrors.attr('value', 'true');
				
				enableFormElementsUnder(newAlgorithmImplementationSectionContent);
				enableFormElementsUnder(newAlgorithmConfigurableParameterSelectionContent);
				
				var formData = newAlgorithmForm.serialize();
				
				$.post('/hal/processFormSnippet/createAlgorithm/createAlgorithm',
					formData,
					onReturn,
					'json'
				);
			},
			'onSuccess' : configurableParameterSelectionOnSuccess,
			defaults: { parameters: options.defaults.configurationParameters() }
		});
		*/

            // expand the configurable parameter selection
            newAlgorithmConfigurableParameterSelection.show();
            expand(newAlgorithmConfigurableParameterSelectionHeader);
        };

    var otherSettingsSemanticsOptions;
    var outputSemanticsOptions;

    var getOutputSemanticsOptions = function(otherSettingsResponse) {
            if (otherSettingsResponse.successful) {
                otherSettingsSemanticsOptions = otherSettingsResponse.semanticsOptions;

                $.post('/hal/getFormSnippet/utilities/getOutputSemantics', {
                    'hal_httpResponseContentType': 'json'
                }, function(outputResponse) {
                    if (outputResponse.successful) {
                        outputSemanticsOptions = outputResponse.semanticsOptions;

                        var specificationOptions = {};
                        specificationOptions.target = newAlgorithmImplementationSectionContent;
                        specificationOptions.errorsTarget = newAlgorithmStatusMessages;
                        specificationOptions.formReference = newAlgorithmForm;
                        specificationOptions.idPrefix = "newAlgorithm_implementation_";
                        specificationOptions.onReenable = function() {
                            newAlgorithmFormButtons.hide();

                            enableFormElementsUnder(newAlgorithmConfigurableParameterSelectionContent);
                            enableFormElementsUnder(newAlgorithmConfigurableParameterSpecificationContent);
                            enableFormElementsUnder(newAlgorithmOtherSettingsSpecificationContent);
                            enableFormElementsUnder(newAlgorithmOutputSpecificationContent);

                            collapse(newAlgorithmConfigurableParameterSelectionHeader);
                            collapse(newAlgorithmConfigurableParameterSpecificationHeader);
                            collapse(newAlgorithmOtherSettingsSpecificationHeader);
                            collapse(newAlgorithmOutputSpecificationHeader);
                        };
                        specificationOptions.onSubmit = function(onReturn) {
                            onlyValidate.attr('value', 'true');
                            allowImplementationSpecificationErrors.attr('value', 'false');
                            allowConfigurableParameterSelectionErrors.attr('value', 'true');
                            allowConfigurableParameterSpecificationErrors.attr('value', 'true');
                            allowOtherSettingsSpecificationErrors.attr('value', 'true');
                            allowOutputSpecificationErrors.attr('value', 'true');

                            enableFormElementsUnder(newAlgorithmImplementationSectionContent);
                            var formData = newAlgorithmForm.serialize();

                            $.post('/hal/processFormSnippet/createAlgorithm/createAlgorithm', formData, onReturn, 'json');
                        };
                        specificationOptions.onSuccess = implementationOnSuccess;

                        if (options.defaults) {
                            specificationOptions.defaults = {
                                name: options.defaults.name() + " (Copy of)",
                                version: options.defaults.version(),
                                description: options.defaults.description(),
                                tags: options.defaults.tags(),
                                deterministic: options.defaults.isDeterministic(),
                                exportable: options.defaults.isExportable(),
                                cutoffAgnostic: options.defaults.isCutoffAgnostic(),
                                executablePath: options.defaults.executablePath(),
                                argumentString: options.defaults.argumentString(),
                                stdoutOutput: options.defaults.stdoutOutput(),
                                stderrOutput: options.defaults.stderrOutput()
                            }
                        }

                        createAlgorithmImplementationSpecification(specificationOptions);

/*
						createAlgorithmImplementationSpecification({
							'target' : newAlgorithmImplementationSectionContent,
							'errorsTarget' : newAlgorithmStatusMessages,
							'formReference' : newAlgorithmForm,
							'idPrefix' : 'newAlgorithm_implementation_',
							'onReenable' : function() {
								newAlgorithmFormButtons.hide();
								
								enableFormElementsUnder(newAlgorithmConfigurableParameterSelectionContent);
								enableFormElementsUnder(newAlgorithmConfigurableParameterSpecificationContent);
								enableFormElementsUnder(newAlgorithmOtherSettingsSpecificationContent);
								enableFormElementsUnder(newAlgorithmOutputSpecificationContent);
								
								collapse(newAlgorithmConfigurableParameterSelectionHeader);
								collapse(newAlgorithmConfigurableParameterSpecificationHeader);
								collapse(newAlgorithmOtherSettingsSpecificationHeader);
								collapse(newAlgorithmOutputSpecificationHeader);
							},
							'onSubmit' : function(onReturn) {
								onlyValidate.attr('value', 'true');
								allowImplementationSpecificationErrors.attr('value', 'false');
								allowConfigurableParameterSelectionErrors.attr('value', 'true');
								allowConfigurableParameterSpecificationErrors.attr('value', 'true');
								allowOtherSettingsSpecificationErrors.attr('value', 'true');
								allowOutputSpecificationErrors.attr('value', 'true');
								
								enableFormElementsUnder(newAlgorithmImplementationSectionContent);
								var formData = newAlgorithmForm.serialize();
								
								$.post('/hal/processFormSnippet/createAlgorithm/createAlgorithm',
									formData,
									onReturn,
									'json'
								);
							},
							'onSuccess' : implementationOnSuccess,
							defaults: { 
								name: options.defaults.name(), 
								version: options.defaults.version(),
								description: options.defaults.description(),
								tags: options.defaults.tags(),
								deterministic: options.defaults.isDeterministic(),
								exportable: options.defaults.isExportable(),
								cutoffAgnostic: options.defaults.isCutoffAgnostic(),
								executablePath: options.defaults.executablePath(),
								argumentString: options.defaults.argumentString(),
								stdoutOutput: options.defaults.stdoutOutput(),
								stderrOutput: options.defaults.stderrOutput()
							}
						});
						*/

                        newAlgorithmFormAllContents.show();
                    }
                }, 'json');
            }
        };

    //	$.post('/hal/getFormSnippet/utilities/getOtherAlgorithmSettingsSemantics',
    //		{
    //			'hal_httpResponseContentType' : 'json'
    //		},
    //		getOutputSemanticsOptions,
    //		'json'
    //	);
    }

    function createAlgorithmSelector(options) {
        options.target.addClass('formElement');
        
        var initialValue = options.initialValue;
        
        var algorithmLabel = $('<label></label>');
        algorithmLabel.attr('for', options.idPrefix + '_id');
        algorithmLabel.html('Algorithm');

        var algorithmField = $('<select></select>');
        algorithmField.attr('id', options.idPrefix + '_id');
        algorithmField.attr('name', options.idPrefix + '_id');

        parameterizedAlgorithms = {};
        parameterlessAlgorithms = {};
        for (var i in options.algorithms) {
            var idString = options.algorithms[i].implementationName + '_xXxversionxXx_' + options.algorithms[i].implementationVersion + '_xXxversionxXx_' + options.algorithms[i].algorithmName;

            if (options.algorithms[i].isParameterized) {
                parameterizedAlgorithms[idString] = options.algorithms[i];
            } else {
                parameterlessAlgorithms[idString] = options.algorithms[i];
            }
        }

        if (numberOfProperties(parameterizedAlgorithms) > 0 && options.includeParameterisedAlgorithms) {
        	algorithmField.append($('<option></option>').attr('value', '').html('--- Parameterized algorithms ---'));

            for (var i in parameterizedAlgorithms) {
                var opt = $('<option></option>');
                opt.attr('value', i);
                opt.html(parameterizedAlgorithms[i].algorithmName);

                algorithmField.append(opt);
                
//                if (numberOfProperties(parameterizedAlgorithms)==1 &&
//                		(!options.includeParameterlessAlgorithms ||
//                				numberOfProperties(parameterlessAlgorithms)<1)) {
//                	algorithmField.val(i);
//                }
            }
        }

        if (numberOfProperties(parameterlessAlgorithms) > 0 && options.includeParameterlessAlgorithms) {
            if (numberOfProperties(parameterizedAlgorithms) > 0 && options.includeParameterisedAlgorithms) {
                algorithmField.append($('<option></option>').attr('value', '').html(''));
            }
            algorithmField.append($('<option></option>').attr('value', '').html('--- Parameterless algorithms ---'));

            for (var i in parameterlessAlgorithms) {
                var opt = $('<option></option>');
                opt.attr('value', i);
                opt.html(parameterlessAlgorithms[i].algorithmName);
                
                algorithmField.append(opt);
                
                //if (numberOfProperties(parameterlessAlgorithms)==1 
                //		&& (!options.includeParameterizedAlgorithms 
                //				|| numberOfProperties(parameterizedAlgorithms)<1)) {
                //	algorithmField.val(i);
                //}
            }
        }
        // finish constructing main select ( the parameterized/parameterless algorithm select field )
        // set the default if there is one
        
        if (initialValue) {
        	algorithmField.children().each(function(index,item) {
        		if ($(item).val() == initialValue) { algorithmField.val(initialValue); }
        	});
        }
        

        var configurationSelectionLabel = $('<label></label>');
        configurationSelectionLabel.attr('for', options.idPrefix + '_configurationName');
        configurationSelectionLabel.html('Configuration');

        var configurationSelectionField = $('<select></select>');
        configurationSelectionField.attr('id', options.idPrefix + '_configurationName');
        configurationSelectionField.attr('name', options.idPrefix + '_configurationName');
        configurationSelectionField.addClass(options.idPrefix + '_configurationName');

        configurationSelectionField.change(function() {
            if (configurationSelectionField.val() !== undefined) {
                // Fill in configuration
                collapseMenu(showConfigurationContainer);
                showConfigurationContainer.show();
            }
        });

        var configurationSelectionContainer = $('<div></div>');
        configurationSelectionContainer.addClass('formElement');
        configurationSelectionContainer.append(configurationSelectionLabel);
        configurationSelectionContainer.append(configurationSelectionField);

        if (options.showNewConfigurationButton) {
            var newConfigurationButton = $('<input></input>');
            newConfigurationButton.attr('type', 'button');
            newConfigurationButton.attr('value', 'New configuration');
            newConfigurationButton.click(function() {
                var formParent = $('#formParent');

                formParent.children().each(function() {
                    $(this).slideUp();
                });

                var tempFormDiv = $('<div></div>').addClass('formContainer');

                formParent.append(tempFormDiv);
                formParent.children().last().load('/hal/getForm/parameterSpace', {
                    'parameterSpaceType': 'configuration',
                    'algorithmImplementationName': parameterizedAlgorithms[algorithmField.val()].implementationName,
                    'algorithmImplementationVersion': parameterizedAlgorithms[algorithmField.val()].implementationVersion,
                    'algorithmName': parameterizedAlgorithms[algorithmField.val()].algorithmName,
                    'classesToUpdate': options.idPrefix + 'configurationName'
                });
            });

            configurationSelectionContainer.append(newConfigurationButton);
        }

        var showConfigurationHeaderText = $('<span></span>').html('Parameter values');
        var showConfigurationContent = $('<div></div>');
        var showConfigurationContainer = $('<div></div>');

        createCollapsibleMenu({
            'headerContent': showConfigurationHeaderText,
            'contentContainer': showConfigurationContent,
            'menuContainer': showConfigurationContainer,
            'initialState': 'collapsed'
        });

        configurationSelectionContainer.hide();
        showConfigurationContainer.hide();

        algorithmField.change(function() {
            if (algorithmField.val() !== '' && algorithmField.val() !== undefined && algorithmField.val() !== null) {
                if (parameterizedAlgorithms[algorithmField.val()] !== undefined && options.forceParameterless) {
                    configurationSelectionField.html('');

                    var defaultOpt = $('<option></option>');
                    defaultOpt.attr('value', '');
                    defaultOpt.html('--- Choose a configuration ---');

                    configurationSelectionField.append(defaultOpt);

                    for (var i in parameterizedAlgorithms[algorithmField.val()].configurations) {
                        var opt = $('<option></option>');
                        opt.attr('value', i);
                        opt.html(i);

                        configurationSelectionField.append(opt);
                    }

                    configurationSelectionContainer.show();

                    configurationSelectionField.change(function() {
                        collapseMenu(showConfigurationContainer);

                        // Fill in configuration
                        var config = parameterizedAlgorithms[algorithmField.val()].configurations[configurationSelectionField.val()];

                        showConfigurationContent.html('');
                        for (var i in config) {
                            var entry = $('<div></div>');
                            entry.append(i + ' : ' + config[i]);
                            showConfigurationContent.append(entry);
                        }

                        showConfigurationContainer.show();
                    });
                } else if (parameterlessAlgorithms[algorithmField.val()] !== undefined) {
                    collapseMenu(showConfigurationContainer);

                    // Fill in configuration
                    var config = parameterlessAlgorithms[algorithmField.val()].configurations['single configuration'];

                    showConfigurationContent.html('');
                    for (var i in config) {
                        var entry = $('<div></div>');
                        entry.append(i + ' : ' + config[i]);
                        showConfigurationContent.append(entry);
                    }

                    configurationSelectionContainer.hide();
                    showConfigurationContainer.show();
                }
            } else {
                configurationSelectionContainer.hide();
                showConfigurationContainer.hide();
            }
        });

        var removeAlgorithmButton = $('<input></input>');
        removeAlgorithmButton.attr('type', 'button');
        removeAlgorithmButton.attr('value', 'Remove');
        removeAlgorithmButton.click(function() {
            $(this).parent().remove();
            //$('#newMultipleAlgorithmAnalysis_algorithms_numberOfAlgorithms').val(algorithmCounter.decrement().getValue());
        });

        options.target.append(algorithmLabel);
        options.target.append(algorithmField);
        options.target.append(configurationSelectionContainer);
        options.target.append(showConfigurationContainer);
        if (options.isRemovable) {
            options.target.append(removeAlgorithmButton);
        }
    }

    // It is possible that this function is no longer used,
    // deferring in preference to Hal.multipleAlgorithmSelector();

    function createMultipleAlgorithmSelector(options) {
        options.target.html('');
        var compatibleAlgorithmsList = []

        var outerContainer = $('<div></div>');
        outerContainer.hide();

        var description = $('<div></div>');
        description.addClass('formFieldDescription');
        description.html(options.description);
        outerContainer.append(description);

        var numAlgorithms = 0;
        var numAlgorithmsField = $('<input></input>');
        numAlgorithmsField.attr('type', 'hidden');
        numAlgorithmsField.attr('name', options.idPrefix + 'numberOfAlgorithms');
        numAlgorithmsField.attr('id', options.idPrefix + 'numberOfAlgorithms');
        numAlgorithmsField.attr('value', numAlgorithms);
        outerContainer.append(numAlgorithmsField);

        var algorithms = $('<div></div>');
        outerContainer.append(algorithms);

        var addClick = function() {
                var newAlgorithmDiv = $('<div></div>');
                algorithms.append(newAlgorithmDiv);

                createAlgorithmSelector({
                    'target': newAlgorithmDiv,
                    'algorithms': compatibleAlgorithmsList,
                    //'idPrefix': options.idPrefix + 'targetAlgorithm_' + algorithmCounter.getValue() + '_',
                    'idPrefix' : options.idPrefix+'targetAlgorithm_'+numAlgorithms+'_',
                    'forceParameterless': options.forceParameterless,
                    'showNewConfigurationButton': options.showNewConfigurationButton,
                    'removable': true
                });

                numAlgorithms = numAlgorithms+1;
                numAlgorithmsField.attr('value', numAlgorithms);
                //algorithmCounter.increment();
                //numAlgorithmsField.attr('value', algorithmCounter.getValue());
            }

        var addButton = $('<input></input>');
        addButton.attr('type', 'button');
        addButton.attr('value', 'Add algorithm');
        addButton.click(addClick);

        var next = function() {
                options.onNext();
            }

        var nextButton = $('<input></input>');
        nextButton.attr('type', 'button');
        nextButton.attr('value', 'Next');
        nextButton.click(next);

        var buttons = $('<div></div>');
        buttons.append('<hr>');
        buttons.append(addButton);
        buttons.append(nextButton);

        outerContainer.append(buttons);

        $.post('/hal/getFormSnippet/utilities/getCompatibleAlgorithms', {
            'hal_httpResponseContentType': 'json',
            'instanceSet': options.instanceSet
        }, function(response) {
            if (response.successful) {
                compatibleAlgorithmsList = response.result.compatibleAlgorithms

                outerContainer.show();
                options.target.html(outerContainer);
                options.onFinished(compatibleAlgorithmsList);
            }
        }, 'json');
    }

    HAL.multipleAlgorithmSelector = function(options) {
        if (!(this instanceof HAL.multipleAlgorithmSelector)) {
            return new HAL.multipleAlgorithmSelector(options);
        }
        
        var initialValues = options.initialValues; // array

        var _idPrefix = options.idPrefix == null ? 'noid' : options.idPrefix;
        var _includeParameterisedAlgorithms = options.includeParameterisedAlgorithms == null ? false : options.includeParameterisedAlgorithms;
        var _includeParameterlessAlgorithms = options.includeParameterlessAlgorithms == null ? false : options.includeParameterlessAlgorithms;
        var _forceParameterlessSelection = options.forceParameterlessSelection == null ? false : options.forceParameterlessSelection;
        var _minimum = options.minimum == null ? 1 : options.minimum;
        var _maximum = options.maximum;

        var _algorithmList = options.algorithmList == null ? [] : options.algorithmList;

        // context-sensitive description for the user.
        var _help = $('<div></div>');
        _help.addClass('formFieldDescription');
        if (_minimum == _maximum) {
            _help.html('Please select ' + _minimum + ' algorithm');

            if (_minimum != 1) {
                _help.append('s');
            }
            _help.append('.');
        } else if (_maximum == null) {
            _help.html('Please select ' + _minimum + ' or more algorithms.');
        } else {
            _help.html('Please select between ' + _minimum + ' and ' + _maximum + ' algorithms.');
        }

        // container holding the algorithm selections and count.
        var _numAlgorithms = 0;
        var _numAlgorithmsField = $('<input></input>');
        _numAlgorithmsField.attr('type', 'hidden');
        _numAlgorithmsField.attr('name', options.idPrefix + '_numberOfAlgorithms');
        _numAlgorithmsField.attr('id', options.idPrefix + '_numberOfAlgorithms');
        _numAlgorithmsField.attr('value', _numAlgorithms);

        var _algorithms = [];
        var _algorithmsContainer = $('<div></div>');

        var _addAlgorithmSelector = function(addOptions) {
        	
                var alg = new HAL.algorithmSelector({
                    //idPrefix: _idPrefix + '_' + algorithmCounter.getValue(),
                	idPrefix: _idPrefix+'_'+_numAlgorithms,
                    includeParameterisedAlgorithms: _includeParameterisedAlgorithms,
                    includeParameterlessAlgorithms: _includeParameterlessAlgorithms,
                    forceParameterlessSelection: _forceParameterlessSelection,
                    isRemovable: addOptions.isRemovable,
                    algorithms: _algorithmList,
                    initialValue : (addOptions.initialValue) ? addOptions.initialValue : undefined
                });

                _algorithms.push(alg);
                _algorithmsContainer.append(alg.getElement());

                _numAlgorithms = _numAlgorithms+1;
                _numAlgorithmsField.val(_numAlgorithms);
                // modified to use global object algorithmCounter to properly
                // increment and decrement the number of algorithms in the 
                // algorithm selector menu.
                //_numAlgorithmsField.val(algorithmCounter.increment().getValue());
            }
        
        var numMinimumSelectors = _minimum;
        if (initialValues && initialValues.length > _minimum) { numMinimumSelectors = initialValues.length; }

        for (var i = 0; i < numMinimumSelectors; i++) {
        	
            _addAlgorithmSelector({
                isRemovable: false,
                initialValue : (initialValues) ? initialValues[i] : undefined
            });
        }

        var _container = $('<div></div>');
        _container.append(_help);
        _container.append(_numAlgorithmsField);
        _container.append(_algorithmsContainer);

        return {
            getElement: function() {
                return _container;
            },
            updateAlgorithmList: function(newAlgorithmList) {
                _algorithmList = newAlgorithmList;

                for (var i in _algorithms) {
                    _algorithms[i].updateAlgorithmList(_algorithmList);
                }
            },
            getValue: function(index) {
                return _algorithms[index].getValue();
            },
            setValues : function(values) {
            	for(var i in values) { // values is an array, so i are numerical indexes
            		if (i < _algorithms.length) {
            			// we do not need to create additional selectors yet
            			_algorithms[i].setValue(values[i]);
            		} else {
            			_addAlgorithmSelector({
            				isRemovable: false,
            				initialValue : values[i],
            			});
            		}
            	}
            },
            addAlgorithmSelector: function(addOptions) {
                _addAlgorithmSelector(addOptions);
            }
        }
    }

    HAL.algorithmSelector = function(options) {
        if (!(this instanceof HAL.algorithmSelector)) {
            return new HAL.algorithmSelector(options);
        }

        var _container = $('<div></div>');

        var _idPrefix = options.idPrefix;
        var _algorithms = options.algorithms;
        var _includeParameterisedAlgorithms = options.includeParameterisedAlgorithms;
        var _includeParameterlessAlgorithms = options.includeParameterlessAlgorithms;
        var _forceParameterlessSelection = options.forceParameterlessSelection;
        var _showNewConfigurationButton = options.showNewConfigurationButton;
        var _isRemovable = options.isRemovable;

        createAlgorithmSelector({
            'target': _container,
            'idPrefix': _idPrefix,
            'algorithms': _algorithms,
            'includeParameterisedAlgorithms': _includeParameterisedAlgorithms,
            'includeParameterlessAlgorithms': _includeParameterlessAlgorithms,
            'forceParameterless': _forceParameterlessSelection,
            'showNewConfigurationButton': _showNewConfigurationButton,
            'isRemovable': _isRemovable,
            initialValue : (options.initialValue) ? options.initialValue : undefined
        });

        return {
            getElement: function() {
                return _container;
            },
            getValue: function() {
                return _container.find('select').val();
            },
            setValue : function(value) {
            	var selector = _container.find('select');
            	
            	selector.children().each(function(index,item) {
            		if ($(item).val() == value) { selector.val(value); }
            	});
            	return this;
            },
            updateAlgorithmList: function(newAlgorithmList) {
                _algorithms = newAlgorithmList;

                var oldVal = _container.find('select').val();
                
                if (oldVal == null) {
                	if (!options.initialValue) { oldVal = ''; }
                	else { oldVal = options.initialValue; }
                }

                _container.empty();

                createAlgorithmSelector({
                    'target': _container,
                    'idPrefix': _idPrefix,
                    'algorithms': _algorithms,
                    'includeParameterisedAlgorithms': _includeParameterisedAlgorithms,
                    'includeParameterlessAlgorithms': _includeParameterlessAlgorithms,
                    'forceParameterless': _forceParameterlessSelection,
                    'showNewConfigurationButton': _showNewConfigurationButton,
                    'isRemovable': _isRemovable,
                    //initialValue: (options.initialValue) ? options.initialValue : undefined
                });

                var selector = _container.find('select');
                // replace if the current value is nothing, but the 
                // selector used to have a value
                if (selector.val() == "" && oldVal !== "") {
                	selector.val(oldVal);
                }
            }
        }
    };

    HAL.defaultMultipleAlgorithmSelectionMenu = function(options) {
        if (!(this instanceof HAL.defaultMultipleAlgorithmSelectionMenu)) {
            return new HAL.defaultMultipleAlgorithmSelectionMenu(options);
        }
        

        var _headerContent = options.headerContent == null ? 'Target algorithm selection' : options.headerContent;
        var _idPrefix = options.idPrefix == null ? 'noid' : options.idPrefix;
        var _isMenuEnabled = options.enabled == null ? true : options.enabled;
        var _isMenuExpanded = options.expanded == null ? true : options.expanded;
        var _minimumAlgorithms = options.minimumAlgorithms == null ? 0 : options.minimumAlgorithms;
        var _maximumAlgorithms = options.maximumAlgorithms;
        var _includeParameterisedAlgorithms = options.includeParameterisedAlgorithms == null ? true : options.includeParameterisedAlgorithms;
        var _includeParameterlessAlgorithms = options.includeParameterlessAlgorithms == null ? true : options.includeParameterlessAlgorithms;
        var _forceParameterlessSelection = options.forceParameterlessSelection == null ? false : options.forceParameterlessSelection;

        var _algorithms = options.algorithms == null ? {} : options.algorithms;

        var _menu = new HAL.menu({
            header: _headerContent,
            enabled: _isMenuEnabled,
            expanded: _isMenuExpanded,
            showPrevious: true,
            showNext: true
        });

        var _multipleAlgorithmSelector = new HAL.multipleAlgorithmSelector({
            idPrefix: _idPrefix + '_algorithms',
            includeParameterisedAlgorithms: _includeParameterisedAlgorithms,
            includeParameterlessAlgorithms: _includeParameterlessAlgorithms,
            forceParameterlessSelection: _forceParameterlessSelection,
            minimum: _minimumAlgorithms,
            maximum: _maximumAlgorithms,
            initialValues: (options.defaults && options.defaults.initialValues) ? options.defaults.initialValues : undefined // array
        });

        if (_minimumAlgorithms !== _maximumAlgorithms) {
            var addAlgorithmButton = $('<input></input>');
            addAlgorithmButton.attr('type', 'button');
            addAlgorithmButton.attr('value', 'Add algorithm');
            addAlgorithmButton.click(function() {
                _multipleAlgorithmSelector.addAlgorithmSelector({
                    isRemovable: true
                });
            });
            _menu.addNavigationElement(addAlgorithmButton);
        }

        _menu.getContentElement().append(_multipleAlgorithmSelector.getElement());

        return {
            getMenuElement: function() {
                return _menu.getMenuElement();
            },
            getMenuObject: function() {
                return _menu;
            },
            getContentElement: function() {
                return _menu.getContentElement();
            },
            getAlgorithm: function(index) {
                return _multipleAlgorithmSelector.getValue(index);
            },
            setDefaults : function(defaults) {
            	_multipleAlgorithmSelector.setValues(defaults.targetAlgorithms);
            	return this;
            },
            clear : function() {
            	//_multipleAlgorithmSelector.clear();
            },
            update: function(filterOptions, successCallback, failureCallback) {
                this.setBusy(true);

                var myMenu = this;
                $.post('/hal/getFormSnippet/utilities/getCompatibleAlgorithms', {
                    'hal_httpResponseContentType': 'json',
                    'instanceSet': filterOptions.compatibleWithInstanceDistribution
                }, function(response) {
                    if (response.successful) {
                        _algorithms = response.result.compatibleAlgorithms;

                        _multipleAlgorithmSelector.updateAlgorithmList(_algorithms);
                        successCallback();

                    } else {
                        failureCallback();
                    }

                    myMenu.setBusy(false);
                }, 'json');
            },
            enable: function() {
                _menu.enable();
            },
            disable: function() {
                _menu.disable();
            },
            expand: function() {
                _menu.expand();
            },
            collapse: function() {
                _menu.collapse();
            },
            setBusy: function(isBusy) {
                _menu.setBusy(isBusy);
            },
            addOnNext: function(f) {
                _menu.addOnNext(f);
            },
            addOnPrevious: function(f) {
                _menu.addOnPrevious(f);
            }
        };
    };
