// Generated by CoffeeScript 1.3.3
(function() {
  var domainDisplay;

  Handlebars.registerHelper('eachSpaceBootstrap', function(space) {
    var buffer, keyvals;
    keyvals = _.pairs(space);
    buffer = "";
    buffer = _.reduce(keyvals, function(accumulator, pair) {
      return accumulator + ("            <div class=\"row\">                <div class=\"span3\"><a name=\"" + pair[0] + "\" id=\"" + pair[0] + "\"></a>" + pair[0] + "</div>                <div class=\"row\">                    <div class=\"span9\">" + (domainDisplay({
        domain: pair[1]
      })) + "</div>                </div>            </div>") + "<div class=\"row\">                <div class=\"span12\">                    <hr/>                </div>            </div>";
    }, buffer);
    return buffer;
  });

  Handlebars.registerHelper('eachConditionalBootstrap', function(condition) {
    return "<div class=\"row\">        <div class=\"span2\">Conditional on</div>        <div class=\"span7\">" + condition.parameterName + "</div>    </div>    " + (domainDisplay({
      domain: condition.domain
    }));
  });

  Handlebars.registerHelper('processProhibitedBootstrap', function(entries) {
    var list;
    list = _.map(entries, function(entry) {
      return "<div class=\"row\">            <div class=\"span2\">Parameter</div>            <div class=\"span7\">" + entry.parameterName + "</div>        </div>        " + (domainDisplay({
        domain: entry.domain,
        withDefault: false
      }));
    });
    return list.join("<div class=\"row\"><div class=\"span6\"><hr/></div></div>");
  });

  Handlebars.registerHelper('parseArguments', function(argumentString) {
    var regex;
    regex = /\$(.+?)\$/g;
    return (_.map(argumentString, function(item) {
      var buffer;
      buffer = "<div class=\"row\"><div class=\"span6\">";
      buffer = buffer + (item.replace(regex, function(val, match) {
        return "<a class=\"scrollTo\" href=\"#" + match + "\">" + val + "</a>";
      }));
      buffer = buffer + "</div></div>";
      return buffer;
    })).join('');
  });

  domainDisplay = function(options) {
    var classname, domain, isNumbers, list, _ref;
    if (options == null) {
      options = {};
    }
    if ((_ref = options.withDefault) == null) {
      options.withDefault = true;
    }
    domain = options.domain;
    classname = domain.classname;
    if (classname.match(/RealDomain/) || classname.match(/IntegerDomain/)) {
      return "<div class=\"row\">            <div class=\"span2\">Domain</div>            <div class=\"span7\">" + (classname.match(/RealDomain/) ? "Real" : "Integer") + "</div>        </div>        " + (options.withDefault ? "<div class=\"row\">                <div class=\"span2\">Default</div>                <div class=\"span7\">" + domain["default"] + "</div>            </div>" : "") + "        <div class=\"row\">            <div class=\"span2\">Range</div>            <div class=\"span7\">[" + domain.range[0] + ", " + domain.range[1] + "]</div>        </div>        " + (domain.scale != null ? "<div class=\"row\">                <div class=\"span2\">Scale</div>                <div class=\"span7\">" + (domain.scale === "LOG" ? "Logarithmic" : "Exponential") + "</div>            </div>" : "") + "                " + ((domain.hasSemantics != null) && domain.hasSemantics ? "<div class=\"row\">                <div class=\"span2\">Semantics</div>                <div class=\"span7\">" + domain.semantics + "</div>            </div>" : "") + "        ";
    } else if (classname.match(/CategoricalDomain/)) {
      isNumbers = _.reduce(domain.items, function(acc, val) {
        return acc = acc && _.isNumber(val);
      }, true);
      list = domain.items;
      if (!isNumbers) {
        list = _.map(list, function(item) {
          return "&quot;" + item + "&quot;";
        });
      }
      return "<div class=\"row\">            <div class=\"span2\">Domain</div>            <div class=\"span7\">Categorical</div>        </div>        " + (options.withDefault ? "<div class=\"row\">                <div class=\"span2\">Default</div>                <div class=\"span7\">" + (isNumbers ? domain["default"] : "&quot;" + domain["default"] + "&quot;") + "</div>            </div>" : "") + "        <div class=\"row\">            <div class=\"span2\">Values</div>            <div class=\"span4\">[" + (list.join(", ")) + "]</div>        </div>        " + ((domain.hasSemantics != null) && domain.hasSemantics ? "<div class=\"row\">                <div class=\"span2\">Semantics</div>                <div class=\"span7\">" + domain.semantics + "</div>            </div>" : "") + "        ";
    } else if (classname.match(/BooleanDomain/)) {
      return "<div class=\"row\">            <div class=\"span2\">Domain</div>            <div class=\"span7\">Boolean</div>        </div>        <div class=\"row\">            <div class=\"span2\">Default</div>            <div class=\"span7\">" + domain["default"] + "</div>        </div>                <div class=\"row\">            <div class=\"span2\">Regex</div>            <div class=\"span7\">" + domain.regex + "</div>        </div>        " + ((domain.hasSemantics != null) && domain.hasSemantics ? "<div class=\"row\">                <div class=\"span2\">Semantics</div>                <div class=\"span7\">" + domain.semantics + "</div>            </div>" : "") + "        ";
    } else if (classname.match(/FileDomain/)) {
      return "<div class=\"row\">            <div class=\"span2\">Domain</div>            <div class=\"span7\">File</div>        </div>        <div class=\"row\">            <div class=\"span2\">Default</div>            <div class=\"span7\">" + ((domain["default"] != null) && domain["default"] ? "" + domain["default"] : "") + "</div>        </div>        <div class=\"row\">            <div class=\"span2\">Restrictions:</div>            <div class=\"span7\">" + domain.restriction + "</div>        </div>        " + ((domain.hasSemantics != null) && domain.hasSemantics ? "<div class=\"row\">                <div class=\"span2\">Semantics</div>                <div class=\"span7\">" + domain.semantics + "</div>            </div>" : "") + "        ";
    } else {
      return "";
    }
  };

  $(function() {
    return $.ajax({
      url: '/jsp/getAlgorithmJSON.jsp',
      data: {
        'algorithmName': $.QueryString['algorithmName']
      },
      dataType: 'json',
      success: function(response) {
        var obj, template;
        if (response.successful) {
          obj = createAlgorithmObject(response.result.algorithm);
          template = Handlebars.templates['algorithms/algorithmSpecification'];
          $('#tableDiv').append(template({
            name: obj.name(),
            version: obj.version(),
            description: obj.description(),
            path: obj.path(),
            tags: obj.tags(),
            isExportable: obj.isExportable(),
            isDeterministic: obj.isDeterministic(),
            isCutoffAgnostic: obj.isCutoffAgnostic(),
            executablePath: obj.executablePath(),
            argumentString: obj.argumentString(),
            stdoutOutput: obj.stdoutOutput(),
            stderrOutput: obj.stderrOutput(),
            configuration: obj.configuration(),
            configurationParameters: obj.configurationParameters(),
            configurationSpace: obj.configurationSpace(),
            outputSpace: obj.outputSpace(),
            scenarioSpace: obj.scenarioSpace(),
            configurableConditionalityRules: obj.configurableParametersConditionalityRules(),
            configurableProhibitedCombinations: obj.configurableParametersProhibitedCombinationRules(),
            otherConditionalityRules: obj.otherSettingsConditionalityRules(),
            otherProhibitedCombinations: obj.otherSettingsProhibitedCombinations()
          }));
          return $(".scrollTo").click(function(event) {
            event.preventDefault();
            if ($('#configurationSpace').find(this.hash).size() > 0) {
              $('#algorithmTabs a[href="#configurationSpace"]').tab("show");
            } else if ($('#otherSettingsSpace').find(this.hash).size() > 0) {
              $('#algorithmTabs a[href="#otherSettingsSpace"]').tab("show");
            } else {
              $('#algorithmTabs a[href="#outputSpace"]').tab("show");
            }
            return $('html,body').animate({
              scrollTop: $(this.hash).offset().top
            }, 500);
          });
        }
      }
    });
  });

}).call(this);
