// Generated by CoffeeScript 1.3.3
(function() {
  var displayType, domainDisplay;

  Handlebars.registerHelper('displayFeatureDomain', function(domain) {
    return domainDisplay({
      'domain': domain,
      'withDefault': false
    });
  });

  Handlebars.registerHelper('displayFeatureTags', function(tags) {
    var outter_array;
    outter_array = _.map(tags, function(item) {
      var inner_array;
      inner_array = _.map(item, function(item) {
        return '<div class="row"><div class="span4">' + item + '</div></div>';
      });
      return inner_array;
    });
    outter_array = outter_array.join('<div class="row"><div class="span4"><hr/></div></div>');
    return new Handlebars.SafeString(outter_array);
  });

  domainDisplay = function(options) {
    var buffer, classname, domain, isNumbers, list, _ref;
    if (options == null) {
      options = {};
    }
    if ((_ref = options.withDefault) == null) {
      options.withDefault = true;
    }
    domain = options.domain;
    classname = domain.classname;
    if (classname.match(/RealDomain/) || classname.match(/IntegerDomain/)) {
      buffer = "";
      buffer = buffer + ("<div class=\"row\">            <div class=\"span2\">Domain</div>            <div class=\"span7\">" + (classname.match(/RealDomain/) ? "Real" : "Integer") + "</div>        </div>");
      if (options.withDefault) {
        buffer = buffer + ("<div class=\"row\">                <div class=\"span2\">Default</div>                <div class=\"span7\">" + domain["default"] + "</div>            </div>");
      }
      buffer = buffer + ("<div class=\"row\">            <div class=\"span2\">Range</div>            <div class=\"span7\">[" + domain.range[0] + ", " + domain.range[1] + "]</div>        </div>");
      if (domain.scale != null) {
        buffer = buffer + ("<div class=\"row\">                <div class=\"span2\">Scale</div>                <div class=\"span7\">" + (domain.scale === "LOG" ? "Logarithmic" : "Exponential") + "</div>            </div>");
      }
      if ((domain.hasSemantics != null) && domain.hasSemantics) {
        buffer = buffer + ("<div class=\"row\">                <div class=\"span2\">Semantics</div>                <div class=\"span7\">" + domain.semantics + "</div>            </div>");
      }
      return new Handlebars.SafeString(buffer);
    } else if (classname.match(/CategoricalDomain/)) {
      isNumbers = _.reduce(domain.items, function(acc, val) {
        return acc = acc && _.isNumber(val);
      }, true);
      list = domain.items;
      if (!isNumbers) {
        list = _.map(list, function(item) {
          return "&quot;" + item + "&quot;";
        });
      }
      buffer = "";
      buffer = buffer + "<div class=\"row\">            <div class=\"span2\">Domain</div>            <div class=\"span7\">Categorical</div>        </div>";
      if (options.withDefault) {
        buffer = buffer + ("<div class=\"row\">                <div class=\"span2\">Default</div>                <div class=\"span7\">" + (isNumbers ? domain["default"] : "&quot;" + domain["default"] + "&quot;") + "</div>            </div>");
      }
      buffer = buffer + ("<div class=\"row\">            <div class=\"span2\">Values</div>            <div class=\"span7\">[" + (list.join(", ")) + "]</div>        </div>");
      if ((domain.hasSemantics != null) && domain.hasSemantics) {
        buffer = buffer + ("<div class=\"row\">                <div class=\"span2\">Semantics</div>                <div class=\"span7\">" + domain.semantics + "</div>            </div>");
      }
      return new Handlebars.SafeString(buffer);
    } else if (classname.match(/BooleanDomain/)) {
      buffer = "";
      buffer = buffer + ("<div class=\"row\">            <div class=\"span2\">Domain</div>            <div class=\"span7\">Boolean</div>        </div>        <div class=\"row\">            <div class=\"span2\">Default</div>            <div class=\"span7\">" + domain["default"] + "</div>        </div>        <div class=\"row\">            <div class=\"span2\">Regex</div>            <div class=\"span7\">" + domain.regex + "</div>        </div>");
      if ((domain.hasSemantics != null) && domain.hasSemantics) {
        buffer = buffer + ("<div class=\"row\">                <div class=\"span2\">Semantics</div>                <div class=\"span7\">" + domain.semantics + "</div>            </div>");
      }
      return new Handlebars.SafeString(buffer);
    } else if (classname.match(/FileDomain/)) {
      buffer = "";
      buffer = buffer + "<div class=\"row\">            <div class=\"span2\">Domain</div>            <div class=\"span7\">File</div>        </div>";
      if (options.withDefaults) {
        buffer = buffer + ("<div class=\"row\">                <div class=\"span2\">Default</div>                <div class=\"span7\">" + ((domain["default"] != null) && domain["default"] ? "" + domain["default"] : "") + "</div>            </div>");
      }
      buffer = buffer + ("<div class=\"row\">            <div class=\"span2\">Restrictions</div>            <div class=\"span7\">" + domain.restriction + "</div>        </div>");
      if ((domain.hasSemantics != null) && domain.hasSemantics) {
        buffer = buffer + ("<div class=\"row\">                <div class=\"span2\">Semantics</div>                <div class=\"span7\">" + domain.semantics + "</div>            </div>");
      }
      return new Handlebars.SafeString(buffer);
    } else {
      return "";
    }
  };

  displayType = function(type) {
    if (type === "REAL_INTERVAL") {
      return "Real";
    } else if (type === "INTEGER_INTERVAL") {
      return "Integer";
    } else if (type === "CATEGORICAL") {
      return "Categorical";
    } else if (type === "FILE") {
      return "File";
    } else if (type === "BOOLEAN") {
      return "Boolean";
    } else {
      return "Unknown";
    }
  };

  $(function() {
    return $.ajax({
      url: '/jsp/getInstanceDistributionJSON.jsp',
      dataType: 'json',
      data: {
        'instanceDistributionName': $.QueryString['instanceDistributionName']
      },
      success: function(response) {
        var array, feature, instance, instanceDistribution, instances, template, _i, _j, _ref, _ref1;
        if (response.successful) {
          instanceDistribution = response.result.instanceDistribution;
          instances = [];
          for (instance = _i = 0, _ref = instanceDistribution.instances.length; 0 <= _ref ? _i < _ref : _i > _ref; instance = 0 <= _ref ? ++_i : --_i) {
            array = [];
            for (feature = _j = 0, _ref1 = instanceDistribution.features.length; 0 <= _ref1 ? _j < _ref1 : _j > _ref1; feature = 0 <= _ref1 ? ++_j : --_j) {
              array.push({
                'feature': instanceDistribution.features[feature],
                'value': instanceDistribution.values[feature][instance]
              });
            }
            instances.push({
              'instance': instanceDistribution.instances[instance],
              'features': array
            });
          }
          instanceDistribution.instances = instances;
          instanceDistribution.numberOfInstances = instanceDistribution.instances.length;
          template = Handlebars.templates['instances/instanceDistributions'];
          return $('#tableDiv').append(template(response.result.instanceDistribution));
        }
      }
    });
  });

}).call(this);
