//$(document).ready(function() {
//	$.ajax({
//		url: "/jsp/getParameterizedAlgorithmNames.jsp",
//		dataType: "json",
//		success: function(data) {
//			if (data.successful && data.result.algorithmNames.length > 0) {
//				// create the select box
//				var algorithmNames = data.result.algorithmNames;
//				
//				var parameterizedAlgorithmSelectionBox = $("<select></select>");
//				
//				var emptySelector = $("<option></option>");
//				emptySelector.attr('id',"empty");
//				emptySelector.attr('value','');
//				emptySelector.html("Clone an Existing Algorithm");
//				
//				parameterizedAlgorithmSelectionBox.append(emptySelector);
//				
//				for(var i in algorithmNames) {
//					var newOption = $("<option></option>");
//					newOption.attr("id", algorithmNames[i]);
//					newOption.attr("value", algorithmNames[i]);
//					newOption.html(algorithmNames[i]);
//					parameterizedAlgorithmSelectionBox.append(newOption);
//				}
//				
//				$('#cloneAlgorithm_container').append(parameterizedAlgorithmSelectionBox);
//				
//				parameterizedAlgorithmSelectionBox.change(function() {
//					var algName = $(this).val();
//					
//					if (algName != '') {
//					
//						$.ajax({
//							url: "/jsp/getAlgorithmJSON.jsp",
//							data: { algorithmName: algName },
//							dataType: "json",
//							success: function(data) {
//								if (data.successful) {
//									var algorithmObj = createAlgorithmObject(data.result.algorithm);
//								
//									$('#newAlgorithm_container').html('');
//								
//									createNewAlgorithmForm({ 
//										classesToUpdate: [], 
//										target: $('#newAlgorithm_container'), 
//										defaults: algorithmObj });
//								}
//							}
//						
//						});
//					}
//				});
//				
//				
//			}
//		}
//	});
	
	
	
	
	
	
	//------------------- HELPER FUNCTIONS -------------------
	var createAlgorithmObject = function(data) {
		return {
			// in the parameterized algorithm case, data.name = data.implementation.name
			// but in the parameterless case, data.name is algorithm_name(configuration_name)
			// and it's this combination that shoud be displayed
			name : 		function() { return data.name; /*data.implementation.name;*/ },
			version: 	function() { return data.implementation.version; },
			description: function() { return data.implementation.description; },
			path: 		function() { return data.implementation.workingdir; },
			tags: 		function() { if (data.implementation.tags) {return data.implementation.tags; } return new Array(); },
			isExportable: function() { return data.implementation.properties.exportable; },
			isDeterministic: function() { return data.implementation.properties.DETERMINISTIC; },
			isCutoffAgnostic: function() { return data.implementation.properties.cutoffAgnostic; },
			executablePath: function() { return data.implementation.executable; },
			argumentString: function() { return data.implementation.inputFormat.callstring; },
			stdoutOutput: function() { return data.implementation.outputFormat.stdout; },
			stderrOutput: function() { return data.implementation.outputFormat.stderr; },
			configuration: function() {
				var array = new Array();
				if (data.configuration) {
					for(var parameter in data.configuration) {
						if (parameter === 'classname') continue;
						
						var value = data.configuration[parameter];
						array.push({ 'parameterName': parameter, 'value': value });
					}
				}
				
				return array;
				
			},
			configurationParameters: function() {
				var array = new Array();
				
				if (data.configurationSpace && data.configurationSpace.parameters) {
					for(var i in data.configurationSpace.parameters) {
						if (!(i == 'classname')) {
							array.push(i);
						}
					}
				}
				
				return array;
			},
			configurationSpace: function() {
				// type matches up nicely with the option value for the select
				var array = {};
				
				if (data.configurationSpace && data.configurationSpace.parameters) {
					for(var i in data.configurationSpace.parameters) {
						//data.configurationSpace.parameters[i] = adaptDomainFeaturesToUIFeatures(data.configurationSpace.parameters[i]);
						
						// map .parameterName to the real parameter name for browsing
						// but keep the array key as the parameter name for cloning
						data.configurationSpace.parameters[i].parameterName=i;
						adaptDomainFeaturesToUIFeatures(data.configurationSpace.parameters[i]);
						array[i]=data.configurationSpace.parameters[i];
					}
					//return data.configurationSpace.parameters;
				}
				
				return array;	
			},
			configurableParametersConditionalityRules: function() {	
				if (data.configurationSpace && data.configurationSpace.conditionals) {return constructConditionalityRulesArray(data.configurationSpace.conditionals);}
				return new Array();
				
			},
			configurableParametersProhibitedCombinationRules: function() {
				if (data.configurationSpace && data.configurationSpace.prohibitions) {return constructProhibitedCombinationsArray(data.configurationSpace.prohibitions);}
				return new Array();
				
			},
			scenarioSpace: function() {
				var array = {};
				
				if (data.scenarioSpace && data.scenarioSpace.parameters) {
					for(var i in data.scenarioSpace.parameters) {
						data.scenarioSpace.parameters[i] = adaptDomainFeaturesToUIFeatures(data.scenarioSpace.parameters[i]);
						
						
						if (data.scenarioSpace.parameters[i].type == 'FILE') {
							if (data.implementation && 
									data.implementation.instanceSpace && 
									data.implementation.instanceSpace.parameters[i] && 
									data.implementation.instanceSpace.semantics) {
								for (var j in data.implementation.instanceSpace.semantics) {
									if (data.implementation.instanceSpace.semantics[j]==i) {
										data.scenarioSpace.parameters[i].hasSemantics = true;
										data.scenarioSpace.parameters[i].semantics = j;
										break;
									}
								}
							}
						} else {
							if (data.scenarioSpace && data.scenarioSpace.semantics) {
								for (var j in data.scenarioSpace.semantics) {
									if (data.scenarioSpace.semantics[j]==i) {
										data.scenarioSpace.parameters[i].hasSemantics = true;
										data.scenarioSpace.parameters[i].semantics = j;
										break;
									}
								}
							}
						}
						
						// map .parameterName to the real parameter name for browsing
						// but keep the array key as the parameter name for cloning
						data.scenarioSpace.parameters[i].parameterName = i;
						array[i] = data.scenarioSpace.parameters[i];
					}
					
					
				}
				
				return array;
				
				//return data.scenarioSpace.parameters;
			},
			
			otherSettingsConditionalityRules: function() {
				if (data.scenarioSpace && data.scenarioSpace.conditionals) {return constructConditionalityRulesArray(data.scenarioSpace.conditionals);}
				else return new Array();
	            
			},
			
			otherSettingsProhibitedCombinations: function() {
				if (data.scenarioSpace && data.scenarioSpace.prohibitions) { return constructProhibitedCombinationsArray(data.scenarioSpace.prohibitions); }
				return new Array();
			},
			
			outputSpace : function() {
				var array = {};
				
				if (data.outputSpace && data.outputSpace.parameters) {
					for(var i in data.outputSpace.parameters) {
		                data.outputSpace.parameters[i] = adaptDomainFeaturesToUIFeatures(data.outputSpace.parameters[i]);
		                data.outputSpace.parameters[i].parameterName = i;
		                
		                if (data.outputSpace.parameters[i].type == 'FILE') {
		                    if (data.implementation &&
		                    		data.implementation.instanceSpace &&
		                    		data.implementation.instanceSpace.parameters &&
		                    		data.implementation.instanceSpace.semantics &&
		                    		data.implementation.instanceSpace.parameters[i]) {
		                        for (var j in data.implementation.instanceSpace.semantics) {
		                            if (data.implementation.instanceSpace.semantics[j]==i) {
		                                data.outputSpace.parameters[i].hasSemantics = true;
		                                data.outputSpace.parameters[i].semantics = j;
		                                break;
		                            }
		                        }
		                    }
		                } else {
		                	if (data.outputSpace && data.outputSpace.semantics) {
		                		for (var j in data.outputSpace.semantics) {
			                        if (data.outputSpace.semantics[j]==i) {
			                            data.outputSpace.parameters[i].hasSemantics = true;
			                            data.outputSpace.parameters[i].semantics = j;
			                            break;
			                        }
			                    }
		                	}
		                    
		                }
		                
		                // map .parameterName to the real parameter name for browsing
						// but keep the array key as the parameter name for cloning
		                data.outputSpace.parameters[i].parameterName = i;
		                array[i] = data.outputSpace.parameters[i];
		            }
				}
				
	            //return data.outputSpace.parameters;
				return array;
			}
			
			

		};
	}

	var constructConditionalityRulesArray = function(source) {
		var array = new Array();
	    for(var i in source) {
	        var obj = {};
	        obj.parameterName = i;
	        
	        for(var j in source[i]) {
	            obj.entries = new Array();
	            
	            for(var k in source[i][j]) {
	                var entryObj = {};
	                
	                entryObj.parameterName = k;
	                entryObj.domain = adaptDomainFeaturesToUIFeatures(source[i][j][k]);
	                obj.entries.push(entryObj);
	            }
	        }
	        
	        array.push(obj);    
	    }
	    return array;
	}

	var constructProhibitedCombinationsArray = function(source) {
		var array = new Array();
	    
	    for (var i in source) {
	        
	        var rule = source[i];
	        
	        var entries = new Array();
	        
	        for(var param in rule) {
	            var obj = {};
	            
	            obj.parameterName = param;
	            obj.domain = adaptDomainFeaturesToUIFeatures(source[i][param]);
	            
	            entries.push(obj);
	        }
	        
	        array.push({ "entries" : entries } );
	    }
	    
	    return array;
	}

	// This function is used to add new properties to the parameter object in
	// accordance with the expected property names defined by the various create*DomainSpec()
	// functions.
	//
	// This is so that the automatic filling out of various input forms
	// can be done automatically.

	var adaptDomainFeaturesToUIFeatures = function(param) {
		//var param = options.parameter;
		if (param.classname.match(/.*\.RealDomain$/)) {
	        param.type="REAL_INTERVAL";
	        
	        // adapt domain for halUIUtilities.createRealIntervalDomainSpecifics
	        
	        param.lowerBound = checkForInfinity(param.range[0]);
	        param.upperBound = checkForInfinity(param.range[1]);

	        if (param.default !== undefined) {
	        	param.hasDefaultValue = true;
	        	param.defaultValue = param.default;
	        }
	        
	        if (param.scale) {
	            param.transformation = param.scale;
	        }
	    } else if (param.classname.match(/.*\.IntegerDomain$/)) {
	        param.type="INTEGER_INTERVAL";
	        
	        param.lowerBound = checkForInfinity(param.range[0]);
	        param.upperBound = checkForInfinity(param.range[1]);
	        
	        
	        
	        if (param.default !== undefined) {
	        	//alert(param.default);
	            param.hasDefaultValue=true;
	            param.defaultValue = param.default;
	        }
	        
	        if (param.scale) {
	            param.transformation = param.scale;
	        }
	        
	    } else if (param.classname.match(/.*\.CategoricalDomain$/)) {
	        param.type="CATEGORICAL";
	        param.values = param.items;
	        
	        if (param.default !== undefined) {
	        	param.hasDefaultValue = true;
	        	param.defaultValue = param.default;
	        }
	        
	    } else if (param.classname.match(/.*\.BooleanDomain$/)) {
	        param.type="BOOLEAN";
	        param.isInverted = param.invert;
	        
	        if (param.default !== undefined) {
	        	param.hasDefaultValue = true;
	        	param.defaultValue = param.default;
	        }
	        
	    } else if (param.classname.match(/.*\.StringDomain$/)) {
	        param.type="STRING";
	        
	        if (param.default !== undefined) {
	        	param.hasDefaultValue = true;
	        	param.defaultValue = param.default;
	        }
	        
	    } else if (param.classname.match(/.*\.FileDomain$/)) {
	        param.type="FILE";
	        if (param.default !== undefined) {
	        	param.hasDefaultValue = true;
	        	param.defaultValue = param.default;
	        }
	    } else {
	        param.type="UNKNOWN";
	    }
		
		return param;
	}

	var checkForInfinity = function(value) {
		if (value == 'inf') { return "Infinity"; }
		if (value == '-inf') { return "-Infinity"; }
		else return value;
	}

//});

