// Generated by CoffeeScript 1.3.3
(function() {
  var AdvancedMenu, FileFiltersMenu, FileSelectionAndFilterMenu, InstanceFileSpecificationMenu, InstanceSetInformationMenu, InstanceSpecificationMenu, Menu, MenuWithHelpIcon, TagSetMenu, beforeAndAfter, fileSelectionAndFilterPreviousButtonHandler, fileSelectionAndFilterSubmitButtonHandler, form, instanceSetNextButtonHandler, instanceSpecificationNextButtonHandler, instanceSpecificationPreviousButtonHandler, registerFileSelectionAndFilterMenuButtonFunctions, registerInstanceSetInformationMenuButtonFunctions, registerInstanceSpecificationMenuButtonFunctions,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  Menu = (function() {

    function Menu(options) {
      var _ref, _ref1, _ref2, _ref3, _ref4, _ref5, _ref6, _ref7;
      if (options == null) {
        options = {};
      }
      if ((_ref = options.headerContent) == null) {
        options.headerContent = 'Menu';
      }
      if ((_ref1 = options.idPrefix) == null) {
        options.idPrefix = 'noid';
      }
      if ((_ref2 = options.isMenuEnabled) == null) {
        options.isMenuEnabled = true;
      }
      if ((_ref3 = options.isMenuExpanded) == null) {
        options.isMenuExpanded = true;
      }
      if ((_ref4 = options.showPrevious) == null) {
        options.showPrevious = true;
      }
      if ((_ref5 = options.showNext) == null) {
        options.showNext = true;
      }
      if ((_ref6 = options.description) == null) {
        options.description = '';
      }
      if ((_ref7 = options.descriptionHeader) == null) {
        options.descriptionHeader = null;
      }
      this.menu = HAL.menu({
        header: options.headerContent,
        enabled: options.isMenuEnabled,
        expanded: options.isMenuExpanded,
        showPrevious: options.showPrevious,
        showNext: options.showNext
      });
      if (options.descriptionHeader != null) {
        $('<label></label>').html(options.descriptionHeader.text).appendTo(this.menu.getContentElement()).attr({
          "for": options.descriptionHeader["for"]
        });
      }
      this.description = $('<div></div>').addClass("formFieldDescription").html(options.description).appendTo(this.menu.getContentElement());
    }

    Menu.prototype.getMenuElement = function() {
      return this.menu.getMenuElement();
    };

    Menu.prototype.getMenuObject = function() {
      return this.menu;
    };

    Menu.prototype.getContentElement = function() {
      return this.menu.getContentElement();
    };

    Menu.prototype.addOnNext = function(f) {
      this.menu.addOnNext(f);
      return this;
    };

    Menu.prototype.addOnPrevious = function(f) {
      this.menu.addOnPrevious(f);
      return this;
    };

    Menu.prototype.disable = function() {
      this.menu.disable();
      return this;
    };

    Menu.prototype.enable = function() {
      this.menu.enable();
      return this;
    };

    Menu.prototype.expand = function() {
      this.menu.expand();
      return this;
    };

    Menu.prototype.collapse = function() {
      this.menu.collapse();
      return this;
    };

    Menu.prototype.setBusy = function(val) {
      this.menu.setBusy(val);
      return this;
    };

    Menu.prototype.addErrorMessage = function(val) {
      this.menu.addErrorMessage(val);
      return this;
    };

    Menu.prototype.addSuccessMessage = function(val) {
      this.menu.addSuccessMessage(val);
      return this;
    };

    Menu.prototype.addWarningMessage = function(val) {
      this.menu.addWarningMessage(val);
      return this;
    };

    Menu.prototype.clearMessages = function() {
      this.menu.clearMessages();
      return this;
    };

    Menu.prototype.showPreviousButton = function() {
      this.menu.showPreviousButton();
      return this;
    };

    Menu.prototype.setDescription = function(desc) {
      this.description.html(desc);
      return this;
    };

    Menu.prototype.setHeaderText = function(text) {
      this.menu.setHeaderContent(text);
      return this;
    };

    return Menu;

  })();

  MenuWithHelpIcon = (function(_super) {

    __extends(MenuWithHelpIcon, _super);

    function MenuWithHelpIcon(options) {
      var _ref, _ref1, _ref2, _ref3;
      if (options == null) {
        options = {};
      }
      if ((_ref = options.idPrefix) == null) {
        options.idPrefix = 'newInstanceSet';
      }
      if ((_ref1 = options.headerContent) == null) {
        options.headerContent = 'MenuWithHelpIcon';
      }
      if ((_ref2 = options.idPrefix) == null) {
        options.idPrefix = 'noid';
      }
      if ((_ref3 = options.helpURL) == null) {
        options.helpURL = '';
      }
      MenuWithHelpIcon.__super__.constructor.call(this, options);
      this.helpLink = $('<a></a>').click(function() {
        if (options.helpURL !== '') {
          return window.open(options.helpURL);
        }
      }).append($('<img></img>').attr({
        src: '/hal/commands/getFile/web/icons/question_mark.png'
      })).appendTo(this.menu.getHeader());
    }

    return MenuWithHelpIcon;

  })(Menu);

  AdvancedMenu = (function(_super) {

    __extends(AdvancedMenu, _super);

    function AdvancedMenu(options) {
      var _ref, _ref1, _ref2, _ref3, _ref4, _ref5;
      if (options == null) {
        options = {};
      }
      if ((_ref = options.idPrefix) == null) {
        options.idPrefix = 'newInstanceSet';
      }
      if ((_ref1 = options.headerContent) == null) {
        options.headerContent = 'Advanced';
      }
      if ((_ref2 = options.helpURL) == null) {
        options.helpURL = '/jsp/HelpPage.jsp#exportableInstances';
      }
      if ((_ref3 = options.isMenuExpanded) == null) {
        options.isMenuExpanded = false;
      }
      if ((_ref4 = options.showPrevious) == null) {
        options.showPrevious = false;
      }
      if ((_ref5 = options.showNext) == null) {
        options.showNext = false;
      }
      AdvancedMenu.__super__.constructor.call(this, options);
      this.exportLabel = $('<label></label>').html('Is your instance set exportable?').attr({
        'for': "" + options.idPrefix + "_isExportable"
      });
      this.exportCheckbox = $('<input></input>').attr({
        id: "" + options.idPrefix + "_isExportable",
        name: "" + options.idPrefix + "_isExportable",
        type: 'checkbox'
      });
      this.exportContainer = $('<div></div>').addClass('formElementInline').append(this.exportLabel).append(this.exportCheckbox).appendTo(this.menu.getContentElement());
    }

    return AdvancedMenu;

  })(MenuWithHelpIcon);

  TagSetMenu = (function(_super) {

    __extends(TagSetMenu, _super);

    function TagSetMenu(options) {
      var _ref, _ref1, _ref2, _ref3, _ref4;
      if (options == null) {
        options = {};
      }
      if ((_ref = options.idPrefix) == null) {
        options.idPrefix = 'newInstanceSet_';
      }
      if ((_ref1 = options.headerContent) == null) {
        options.headerContent = 'Tag sets';
      }
      if ((_ref2 = options.isMenuExpanded) == null) {
        options.isMenuExpanded = false;
      }
      if ((_ref3 = options.showPrevious) == null) {
        options.showPrevious = false;
      }
      if ((_ref4 = options.showNext) == null) {
        options.showNext = false;
      }
      TagSetMenu.__super__.constructor.call(this, options);
      createMultipleTagSetSelector({
        target: this.menu.getContentElement(),
        idPrefix: "" + options.idPrefix,
        description: 'Please specify each of the sets of tags satisfied by this instance set.<br/> \
				Each tag set should be a comma-separated list of tags, <br/>and you may use the \
				drop-down selector to insert tags that are already defined in HAL.'
      });
    }

    return TagSetMenu;

  })(Menu);

  InstanceSetInformationMenu = (function(_super) {

    __extends(InstanceSetInformationMenu, _super);

    function InstanceSetInformationMenu(options) {
      var _ref, _ref1, _ref2, _ref3, _ref4, _ref5;
      if (options == null) {
        options = {};
      }
      if ((_ref = options.idPrefix) == null) {
        options.idPrefix = 'newInstanceSet';
      }
      if ((_ref1 = options.headerContent) == null) {
        options.headerContent = 'Instance set information';
      }
      if ((_ref2 = options.isMenuEnabled) == null) {
        options.isMenuEnabled = true;
      }
      if ((_ref3 = options.isMenuExpanded) == null) {
        options.isMenuExpanded = true;
      }
      if ((_ref4 = options.showPrevious) == null) {
        options.showPrevious = false;
      }
      if ((_ref5 = options.showNext) == null) {
        options.showNext = true;
      }
      InstanceSetInformationMenu.__super__.constructor.call(this, options);
      this.nameLabel = $('<label></label>').attr({
        'for': "" + options.idPrefix + "_name"
      }).html('Instance set name');
      this.nameField = $('<input></input>').attr({
        'type': 'text',
        'size': 50,
        'name': "" + options.idPrefix + "_name",
        'id': "" + options.idPrefix + "_name"
      });
      this.nameContainer = $('<div></div>').addClass('formElement').append(this.nameLabel).append(this.nameField);
      this.descriptionLabel = $('<label></label>').attr({
        'for': "" + options.idPrefix + "_description"
      }).html('Instance set description (optional)');
      this.descriptionField = $('<textarea></textarea>').attr({
        'id': "" + options.idPrefix + "_description",
        name: "" + options.idPrefix + "_description",
        'cols': 75,
        'rows': 6
      });
      this.descriptionContainer = $('<div></div>').addClass('formElement').append(this.descriptionLabel).append(this.descriptionField);
      this.advancedMenu = new AdvancedMenu;
      this.tagSetMenu = new TagSetMenu;
      this.menu.getContentElement().append(this.nameContainer).append(this.descriptionContainer).append(this.advancedMenu.getMenuElement()).append(this.tagSetMenu.getMenuElement());
    }

    InstanceSetInformationMenu.prototype.getFormData = function() {
      return this.descriptionContainer.serialize();
    };

    return InstanceSetInformationMenu;

  })(Menu);

  InstanceFileSpecificationMenu = (function(_super) {

    __extends(InstanceFileSpecificationMenu, _super);

    function InstanceFileSpecificationMenu(options) {
      var _ref, _ref1, _ref2, _ref3, _ref4, _ref5;
      if (options == null) {
        options = {};
      }
      if ((_ref = options.idPrefix) == null) {
        options.idPrefix = 'newInstanceSet';
      }
      if ((_ref1 = options.headerContent) == null) {
        options.headerContent = 'Instance file specification';
      }
      if ((_ref2 = options.description) == null) {
        options.description = 'This is the path to a directory on the server \
			filesystem containing the instance files for this set';
      }
      if ((_ref3 = options.descriptionHeader) == null) {
        options.descriptionHeader = {
          "for": "" + options.idPrefix + "_directoryPath",
          text: 'Path to the directory containing the instance files'
        };
      }
      if ((_ref4 = options.showPrevious) == null) {
        options.showPrevious = false;
      }
      if ((_ref5 = options.showNext) == null) {
        options.showNext = false;
      }
      InstanceFileSpecificationMenu.__super__.constructor.call(this, options);
      this.directoryPathField = $('<input></input>').attr({
        type: "text",
        size: 100,
        id: "" + options.idPrefix + "_directoryPath",
        name: "" + options.idPrefix + "_directoryPath"
      }).appendTo(this.menu.getContentElement());
      this.descendIntoSubdirectoriesLabel = $('<label></label>').html("Descend into subdirectories").attr({
        "for": "" + options.idPrefix + "_descendIntoSubdirectories"
      });
      this.descendIntoSubdirectoriesCheckbox = $('<input></input>').attr({
        type: 'checkbox',
        id: "" + options.idPrefix + "_descendIntoSubdirectories",
        name: "" + options.idPrefix + "_descendIntoSubdirectories",
        checked: 'on'
      });
      $('<div></div>').addClass('formElementInline').append(this.descendIntoSubdirectoriesLabel).append(this.descendIntoSubdirectoriesCheckbox).appendTo(this.menu.getContentElement());
    }

    return InstanceFileSpecificationMenu;

  })(Menu);

  InstanceSpecificationMenu = (function(_super) {

    __extends(InstanceSpecificationMenu, _super);

    function InstanceSpecificationMenu(options) {
      var _ref, _ref1, _ref2, _ref3, _ref4, _ref5;
      if (options == null) {
        options = {};
      }
      if ((_ref = options.idPrefix) == null) {
        options.idPrefix = 'newInstanceSet';
      }
      if ((_ref1 = options.headerContent) == null) {
        options.headerContent = 'Instance specification';
      }
      if ((_ref2 = options.isMenuEnabled) == null) {
        options.isMenuEnabled = false;
      }
      if ((_ref3 = options.isMenuExpanded) == null) {
        options.isMenuExpanded = false;
      }
      if ((_ref4 = options.showPrevious) == null) {
        options.showPrevious = true;
      }
      if ((_ref5 = options.showNext) == null) {
        options.showNext = true;
      }
      InstanceSpecificationMenu.__super__.constructor.call(this, options);
      (new InstanceFileSpecificationMenu).getMenuElement().appendTo(this.menu.getContentElement());
    }

    return InstanceSpecificationMenu;

  })(Menu);

  FileFiltersMenu = (function(_super) {

    __extends(FileFiltersMenu, _super);

    function FileFiltersMenu(options) {
      var _ref, _ref1, _ref2, _ref3, _ref4,
        _this = this;
      if (options == null) {
        options = {};
      }
      if ((_ref = options.idPrefix) == null) {
        options.idPrefix = 'newInstanceSet';
      }
      if ((_ref1 = options.headerContent) == null) {
        options.headerContent = 'File filters';
      }
      if ((_ref2 = options.description) == null) {
        options.description = "Each filter is a regular expression used to match files in the chosen directory. Any files that are not matched by all filters will be ignored. For example, using the filter \".*\\.cnf\" will match all files with a .cnf extension.";
      }
      if ((_ref3 = options.showPrevious) == null) {
        options.showPrevious = false;
      }
      if ((_ref4 = options.showNext) == null) {
        options.showNext = false;
      }
      FileFiltersMenu.__super__.constructor.call(this, options);
      createMultipleStringFilterSelector({
        idPrefix: 'newInstanceSet_',
        target: this.menu.getContentElement(),
        showFilterButton: true,
        onFilter: function() {
          var formData;
          formData = form.serializeObject();
          formData.hal_httpContentResponse = 'json';
          formData.validateOnly = true;
          return $.ajax({
            url: '/hal/getFormSnippet/createInstanceSet/createInstanceSet',
            data: formData,
            dataType: 'json',
            type: 'POST',
            success: function(response) {
              var list;
              if (response.successful) {
                list = $('<ul></ul>');
                _.map(response.matchedFiles, function(file) {
                  return $('<li></li>').html(file).appendTo(list);
                });
                options.updateMenu.setHeaderText("" + (numberOfProperties(response.matchedFiles)) + " files matched.");
                return options.updateMenu.getContentElement().html(list);
              } else {
                return _this.menu.addErrorMessage(response.errorMessage);
              }
            }
          });
        }
      });
    }

    return FileFiltersMenu;

  })(Menu);

  FileSelectionAndFilterMenu = (function(_super) {

    __extends(FileSelectionAndFilterMenu, _super);

    function FileSelectionAndFilterMenu(options) {
      var _ref, _ref1, _ref2, _ref3, _ref4, _ref5;
      if (options == null) {
        options = {};
      }
      if ((_ref = options.idPrefix) == null) {
        options.idPrefix = 'newInstanceSet';
      }
      if ((_ref1 = options.headerContent) == null) {
        options.headerContent = 'File selection and filter';
      }
      if ((_ref2 = options.showNext) == null) {
        options.showNext = false;
      }
      if ((_ref3 = options.showPrevious) == null) {
        options.showPrevious = true;
      }
      if ((_ref4 = options.isMenuEnabled) == null) {
        options.isMenuEnabled = false;
      }
      if ((_ref5 = options.isMenuExpanded) == null) {
        options.isMenuExpanded = false;
      }
      FileSelectionAndFilterMenu.__super__.constructor.call(this, options);
      this.matchedFilesMenu = new Menu({
        isMenuExpanded: false,
        showPrevious: false,
        showNext: false
      });
      (new FileFiltersMenu({
        "updateMenu": this.matchedFilesMenu
      })).getMenuElement().appendTo(this.menu.getContentElement());
      this.matchedFilesMenu.getMenuElement().appendTo(this.menu.getContentElement());
      this.submitButton = $('<button></button>').html('Submit');
      this.menu.addNavigationElement(this.submitButton);
    }

    FileSelectionAndFilterMenu.prototype.setMatchedFilesMenu = function(options) {
      if (options == null) {
        options = {};
      }
      this.matchedFilesMenu.setHeaderText(options.text);
      this.matchedFilesMenu.getContentElement().html(options.content);
      return this;
    };

    FileSelectionAndFilterMenu.prototype.addOnSubmit = function(f) {
      this.submitButton.click(f);
      return this;
    };

    FileSelectionAndFilterMenu.prototype.disableSubmitButton = function() {
      this.submitButton.attr({
        'disabled': 'disabled'
      });
      return this;
    };

    FileSelectionAndFilterMenu.prototype.enableSubmitButton = function() {
      this.submitButton.removeAttr('disabled');
      return this;
    };

    return FileSelectionAndFilterMenu;

  })(Menu);

  beforeAndAfter = function(before, after) {
    before.disable().collapse().clearMessages();
    return after.enable().expand();
  };

  registerInstanceSetInformationMenuButtonFunctions = function(instanceSet, instanceSpecification) {
    return instanceSet.addOnNext(function() {
      return instanceSetNextButtonHandler(instanceSet, instanceSpecification);
    });
  };

  registerInstanceSpecificationMenuButtonFunctions = function(instanceSet, instanceSpecification, fileSelection) {
    instanceSpecification.addOnPrevious(function() {
      return instanceSpecificationPreviousButtonHandler(instanceSpecification, instanceSet);
    });
    return instanceSpecification.addOnNext(function() {
      return instanceSpecificationNextButtonHandler(instanceSpecification, fileSelection);
    });
  };

  registerFileSelectionAndFilterMenuButtonFunctions = function(instanceSpecification, fileSelection) {
    fileSelection.addOnSubmit(function() {
      return fileSelectionAndFilterSubmitButtonHandler(fileSelection);
    });
    return fileSelection.addOnPrevious(function() {
      return fileSelectionAndFilterPreviousButtonHandler(instanceSpecification, fileSelection);
    });
  };

  instanceSetNextButtonHandler = function(instanceSet, instanceSpecification) {
    return beforeAndAfter(instanceSet, instanceSpecification);
  };

  instanceSpecificationPreviousButtonHandler = function(instanceSpecification, instanceSet) {
    return beforeAndAfter(instanceSpecification, instanceSet);
  };

  instanceSpecificationNextButtonHandler = function(instanceSpecification, fileSelectionFilter) {
    var formData;
    formData = form.serializeObject();
    formData.hal_httpContentResponse = 'json';
    formData.validateOnly = true;
    return $.ajax({
      url: '/hal/getFormSnippet/createInstanceSet/createInstanceSet',
      data: formData,
      dataType: 'json',
      type: 'POST',
      success: function(response) {
        var list;
        if (response.successful) {
          beforeAndAfter(instanceSpecification, fileSelectionFilter);
          list = $('<ul></ul>');
          _.map(response.matchedFiles, function(file) {
            return $('<li></li>').html(file).appendTo(list);
          });
          return fileSelectionFilter.setMatchedFilesMenu({
            text: "" + (numberOfProperties(response.matchedFiles)) + " files matched.",
            content: list
          });
        } else {
          return instanceSpecification.addErrorMessage(response.errorMessage);
        }
      }
    });
  };

  fileSelectionAndFilterPreviousButtonHandler = function(instanceSelection, fileSelection) {
    return beforeAndAfter(fileSelection, instanceSelection);
  };

  fileSelectionAndFilterSubmitButtonHandler = function(fileSelectionMenu) {
    var formData;
    formData = form.serializeObject();
    formData.hal_httpContentResponse = 'json';
    formData.validateOnly = false;
    fileSelectionMenu.clearMessages();
    fileSelectionMenu.addSuccessMessage('Submitting instance distribution.  This process can take a long time.');
    fileSelectionMenu.disableSubmitButton();
    $.ajax({
      url: '/hal/getFormSnippet/createInstanceSet/createInstanceSet',
      data: formData,
      dataType: 'json',
      type: 'POST',
      success: function(response) {
        if (response.successful) {
          fileSelectionMenu.addSuccessMessage('Instance set was defined successfully');
          fileSelectionMenu.addSuccessMessage("Redirecting to HAL's homepage");
          return setTimeout((function() {
            return window.location = '/hal';
          }), 2000);
        } else {
          fileSelectionMenu.clearMessages();
          fileSelectionMenu.addErrorMessage(response.errorMessage);
          return fileSelectionMenu.enableSubmitButton();
        }
      }
    });
    return false;
  };

  form = $('<form></form>');

  window.createInstanceSetForm = function(options) {
    var fileSelectionMenu, informationMenu, specificationMenu;
    informationMenu = new InstanceSetInformationMenu;
    specificationMenu = new InstanceSpecificationMenu;
    fileSelectionMenu = new FileSelectionAndFilterMenu;
    registerInstanceSetInformationMenuButtonFunctions(informationMenu, specificationMenu);
    registerInstanceSpecificationMenuButtonFunctions(informationMenu, specificationMenu, fileSelectionMenu);
    registerFileSelectionAndFilterMenuButtonFunctions(specificationMenu, fileSelectionMenu);
    return form.append(informationMenu.getMenuElement()).append(specificationMenu.getMenuElement()).append(fileSelectionMenu.getMenuElement()).appendTo(options.target);
  };

  window.createInstanceDistributionSelector = function(options) {
    return $.ajax({
      url: '/hal/getFormSnippet/utilities/getDefinedInstanceSets',
      data: {
        'hal_httpResponseContentType': 'json'
      },
      dataType: 'json',
      success: function(response) {
        var name, setNames;
        if (response.successful) {
          setNames = response.result.instanceSets;
          options.target.html('');
          $('<option></option>').html('--- Choose an instance distribution ---').appendTo(options.target).attr({
            value: ''
          });
          for (name in setNames) {
            $('<option></option>').html(name).appendTo(options.target).attr({
              value: name
            });
          }
        }
        return options.onFinished({
          successful: response.successful
        });
      }
    });
  };

  window.HAL.instanceDistributionSelector = function(options) {
    var initialValue, _changeCallbacks, _instanceDistributionContainer, _instanceDistributionField, _instanceDistributionLabel;
    if (!(this instanceof HAL.instanceDistributionSelector)) {
      return new HAL.instanceDistributionSelector(options);
    }
    initialValue = options.initialValue;
    _instanceDistributionLabel = $('<label></label>').html('Instance distribution').attr({
      'for': "" + options.idPrefix + "_instanceDistributionName"
    });
    _instanceDistributionField = $('<select></select>').append($('<option></option>').attr('value', '').html('Populating...')).attr({
      'name': "" + options.idPrefix + "_instanceDistributionName",
      id: "" + options.idPrefix + "_instanceDistributionName"
    });
    _instanceDistributionContainer = $('<div></div>').addClass('formElement');
    if (options.showLabel === null || options.showLabel) {
      _instanceDistributionContainer.append(_instanceDistributionLabel);
    }
    _instanceDistributionContainer.append(_instanceDistributionField);
    _changeCallbacks = [];
    _instanceDistributionField.change(function() {
      var i, _results;
      _results = [];
      for (i in _changeCallbacks) {
        _results.push(_changeCallbacks[i]());
      }
      return _results;
    });
    $.ajax({
      url: '/hal/getFormSnippet/utilities/getDefinedInstanceSets',
      data: {
        'hal_httpResponseContentType': 'json'
      },
      success: function(response) {
        var defaultOpt, i, instanceDistributionNames, isValidValue, opt;
        if (response.successful) {
          instanceDistributionNames = response.result.instanceSets;
          _instanceDistributionField.empty();
          defaultOpt = $('<option></option>').attr('value', '');
          if (numberOfProperties(instanceDistributionNames) !== 0) {
            defaultOpt.html('--- Choose an instance distribution ---');
          } else {
            defaultOpt.html('--- No instance distributions defined! ---');
          }
          _instanceDistributionField.append(defaultOpt);
          for (i in instanceDistributionNames) {
            opt = $('<option></option>');
            if (initialValue && initialValue === instanceDistributionNames[i]) {
              isValidValue = true;
            }
            opt.attr('value', instanceDistributionNames[i]).html(instanceDistributionNames[i]);
            _instanceDistributionField.append(opt);
          }
          if (initialValue) {
            return _instanceDistributionField.children().each(function(index, item) {
              if ($(item).val() === initialValue) {
                return _instanceDistributionField.val(initialValue);
              }
            });
          }
        }
      }
    });
    return {
      getElement: function() {
        return _instanceDistributionContainer;
      },
      addChangeCallback: function(callback) {
        return _changeCallbacks.push(callback);
      },
      getValue: function() {
        return _instanceDistributionField.val();
      },
      clear: function() {
        _instanceDistributionField.val('');
        return this;
      },
      setValue: function(value) {
        _instanceDistributionField.children().each(function(index, item) {
          if ($(item).val() === value) {
            return _instanceDistributionField.val(value);
          }
        });
        return this;
      }
    };
  };

}).call(this);
