$(document).ready(function(){
	var logsDiv = $("#logDiv");
	
	var logsHeader = logsTableHeader();
	var logsContent = logsTableContent();
	
	logsDiv.append(logsHeader.getElement());
	logsDiv.append(logsContent.getElement());
	
	logsHeader.hideSpinner();
	ajaxContent({ offset: 0, limit: 10 });
	
	var formDiv = $('#logFormDiv');
	
	var menu = createDropdownMenu();
	
	formDiv.append(menu.getElement());
	
	var forms = createFormElements();
	
	formDiv.append(forms.getElement());
	
	menu
	.addLevelLinkClickHandler(function() { forms.showLevelForm(); })
	.addTimeLinkClickHandler(function() { forms.showTimeForm(); })
	.addHostLinkClickHandler(function() { forms.showHostForm() });
	
	function ajaxContent(myData) {
		logsHeader.showSpinner();
		return $.ajax({
			url: '/hal/logs/getLogs',
			data: myData,
			dataType: 'json',
			success: function(data) {
				if (data.successful) {
					logsHeader.changeContent(data.result.maxLogs, myData);
					logsContent.changeContent(data.result.logs);	
				}
				
				logsHeader.hideSpinner();
			}
		});
	}
	
	function logsTableHeader() {
		var _currentPage = 1;
		var _limit = 10;
		var _maxLogs = 0;
		
		var _header = $('<div></div>');
		
		var _table = $('<table></table>').appendTo(_header);
		var _tbody = $('<tbody></tbody').appendTo(_table);
		var _tr = $('<tr></tr>').appendTo(_tbody);
		
		var _pagDiv = $('<div></div>').addClass('pagination');
		var _pagination = $('<ul></ul>').attr('id','pageNavigation').appendTo(_pagDiv);
		
		var _limDiv = $('<div></div>').addClass('pagination');
		var _limits = $('<ul></ul>').appendTo(_limDiv);
		
		var _refDiv = $('<div></div>').addClass('pagination');
		_autorefresh = $('<ul></ul>').appendTo(_refDiv);
		
		var _spinDiv = $('<div></div>').addClass('pagination');
		var _spinner = $('<ul></ul>').appendTo(_spinDiv);
		
		$('<td></td>').append(_pagDiv).appendTo(_tr);
		$('<td></td>').append(_limDiv).appendTo(_tr);
		$('<td></td>').append(_refDiv).appendTo(_tr);
		$('<td></td>').append(_spinDiv).appendTo(_tr);
		
		var buildPaginationElements = function(maxNumberOfLogs, numberOfLogsPerPage, formData) {
			_pagination.children().remove();
			_maxLogs = maxNumberOfLogs;
			
			var maxPages = 1;
			
			if (maxNumberOfLogs <= 1) { maxPages = 1; }
			else if (maxNumberOfLogs % numberOfLogsPerPage == 0) { maxPages = maxNumberOfLogs / numberOfLogsPerPage }
			else { maxPages = Math.ceil(maxNumberOfLogs/numberOfLogsPerPage); }
			
			var firstPageLink = $('<a></a>').html('&lt;&lt;').attr({
				name: '1',
				id: 'firstPageLink',
				href: '/hal/logs/getLogs?limit='+_limit,
			}).click(function() {
				_currentPage = 1;
				var sub = (formData) ? formData : {};
				sub.offset = 0;
				sub.limit = _limit;
				
				//alert(JSON.stringify(sub));
				ajaxContent(sub);
				return false;
			});
			
			$('<li></li>').append(firstPageLink).appendTo(_pagination);
			
			var pageLowerBound = _currentPage-2;
			var pageUpperBound = _currentPage+2;
			
			if (pageLowerBound<1) { pageLowerBound=1; pageUpperBound=5; }
			if (pageUpperBound>maxPages) { pageUpperBound = maxPages; pageLowerBound = (maxPages-4<1) ? 1 : maxPages-4; }
			if (maxPages < pageUpperBound) { pageUpperBound = maxPages; }
			
			var prevBound = (_currentPage-1 > 0) ? (_currentPage-1) : 1;
			var nextBound = (_currentPage+1 <= pageUpperBound) ? (_currentPage+1) : pageUpperBound;
			
			var prevPageLink = $('<a></a>').html('&lt;').attr({
				name: prevBound,
				id : 'previousPageLink',
				href: '/hal/logs/getLogs?limit='+_limit+'&offset='+((prevBound-1)*_limit)
			}).click(function() {
				_currentPage = prevBound;
				
				var sub = (formData) ? formData : {};
				sub.offset = (_currentPage-1)*_limit;
				sub.limit = _limit;
				
				//ajaxContent({ offset: ((prevBound-1)*_limit), limit: _limit });
				
				//alert(JSON.stringify(sub));
				
				ajaxContent(sub);
				return false;
			});
			
			$('<li></li>').append(prevPageLink).appendTo(_pagination);
			
			var i;
			for(i=pageLowerBound; i<=pageUpperBound; i=i+1) {
				var link = $('<a></a>').html(i).attr({
					href: '/hal/logs/getLogs?limit='+_limit+'&offset='+((i-1)*_limit),
				}).click(function(e) {
					return function() { 
						_currentPage = e;
						
						var sub = (formData) ? formData : {};
						sub.offset = (_currentPage-1)*_limit;
						sub.limit = _limit;
						
						//alert(JSON.stringify(sub));
						ajaxContent(sub);
						//ajaxContent(((e-1)*_limit), _limit);
						return false;
					}
					
				}(i));
				
				var li = $('<li></li>').appendTo(_pagination).append(link);
				
				if (i==_currentPage) { li.addClass("active").addClass("disabled"); }
			}
			
			var nextPageLink = $('<a></a>').html('&gt;').attr({
				name: nextBound,
				id: 'nextPageLink',
				href: '/hal/logs/getLogs?limit='+_limit+'&offset='+((nextBound-1)*_limit)
			}).click(function() {
				_currentPage = nextBound;
				
				var sub = (formData) ? formData : {};
				sub.offset = (_currentPage-1)*_limit;
				sub.limit = _limit;
				
				//alert(JSON.stringify(sub));
				ajaxContent(sub);
				
				//ajaxContent({ offset: ((nextBound-1)*_limit), limit: _limit });
				return false;
			});
			
			$('<li></li>').append(nextPageLink).appendTo(_pagination);
			
			var lastPageLink = $('<a></a>').html('&gt;&gt;').attr({
				name: maxPages,
				id: 'lastPageLink',
				href: '/hal/logs/getLogs?limit='+_limit+'&offset='+((maxPages-1)*_limit),
			}).click(function() {
				_currentPage = maxPages;
				
				var sub = (formData) ? (formData) : {};
				sub.offset = (_currentPage-1)*_limit;
				sub.limit = _limit;
				
				//alert(JSON.stringify(sub));
				ajaxContent(sub);
				
				//ajaxContent({ offset: ((maxPages-1)*_limit), limit: _limit });
				return false;
			});
			
			$('<li></li>').appendTo(_pagination).append(lastPageLink);
			
		};
		
		var buildLimitElements = function(formData) {
			var limitValues = [10,25,50,100];
			
			_limits.children().remove();
			
			$('<li></li>').addClass('active').addClass('disabled').append($('<a></a>').html('Per Page').attr({ name: 'limit' })).appendTo(_limits);
			
			var i;
			for(i=0; i < limitValues.length; i=i+1) {
				var anchor = $('<a></a>').html(limitValues[i]).attr({ 
					href: '/hal/logs/getLogs?limit='+limitValues[i]+'&offset='+((_currentPage-1)*_limit) 
				}).click(function(e) {
					return function() {
						var oldLimit = _limit;
						
						_limit = e;
						
						var offset = (_currentPage*oldLimit);
						offset = (offset < _maxLogs) ? offset : _maxLogs;
						
						_currentPage = Math.ceil(offset/_limit);
						
						var sub = (formData) ? formData : {};
						sub.offset = (_currentPage-1)*_limit;
						sub.limit = _limit;
						
						//alert(JSON.stringify(sub));
						ajaxContent(sub);
						
						//ajaxContent({ offset: ((_currentPage-1)*e), limit: e });
						_limits.find('.active.disabled:gt(0)').removeClass('active disabled');
						$(this).parent().addClass('active disabled');
						
						return false;
					}
				}(limitValues[i]));
				
				
				var li = $('<li></li>').appendTo(_limits).append(anchor);
				
				if (limitValues[i] == _limit) { li.addClass('active').addClass('disabled'); }
			}
		};
		
		var buildAutoRefreshElements = function() {
			var isAutoRefreshing = false;
			var timer;
			
			var button = $('<button></button>').html('Start').attr({ name: '1', id: 'autorefreshbutton', 'data-toggle':'button' })
			.addClass('btn btn-large autorefresh btn-success').button();
			
			var clicky = function(e) {
				if (isAutoRefreshing) {
					unpoll();
					button.removeClass('btn-danger').addClass('btn-success active').html('Start');
				
				} else {
					poll(1000, e);
					button.removeClass('btn-success active').addClass('btn-danger').html('Stop');
				}
			
				isAutoRefreshing = !isAutoRefreshing;
				
			}

			button.click(function() {
				clicky({ offset: 0, limit: _limit });
			});
			
			$('<li></li>').appendTo(_autorefresh).append($('<a></a>').html('Autorefresh')).addClass('active disabled').attr('name','refresh');
			$('<li></li>').appendTo(_autorefresh).append(button);
			
			return {
				changeAjaxData: function(d) { button.unbind('click').click(function() {
					clicky(d);
				}); }
			}
		}();
		
		var shouldPoll=false;
		
		function doPolling(timeout, formData) {
			logsHeader.showSpinner();
			
			var sub = (formData) ? formData : {};
			sub.offset = 0;
			sub.limit = _limit;
			
			$.ajax({
				url: '/hal/logs/getLogs',
				data: sub,
				dataType: 'json',
				timeout: timeout,
				maxRetries: 3,
				success: function(data) {
					if (data.successful) {
						_currentPage = 1;
						logsHeader.changeContent(data.result.maxLogs, formData);
						logsContent.changeContent(data.result.logs);	
					}
					
					logsHeader.hideSpinner();
				},
				complete: function() {
					return function(e) { if (e) { setTimeout(doPolling,2000,timeout, formData); } }(shouldPoll);
				},
				error: function(jqhxr,statusText,thrownError) {
					if (statusText === 'timeout') {
						timeout = timeout * 2;
					}
				}
			});
		}
		
		function poll(timeout, formData) {
			shouldPoll = true;
			doPolling(timeout, formData);
		}
		
		function unpoll() {
			shouldPoll = false;
		}
		
		var buildSpinnerElements = function() {
			var anchor = $('<a></a>').append($('<img></img>').attr({ src: '/hal/commands/getFile/web/icons/ajax-loader.gif' }));
			
			$('<li></li>').appendTo(_spinner).append(anchor).addClass('disable');
		}();
		
		return {
			getElement: function() { return _header; },
			changeContent : function(numRuns, data) { buildPaginationElements(numRuns, _limit, data); buildLimitElements(data); buildAutoRefreshElements.changeAjaxData(data); return this; },
			hideSpinner : function() { _spinDiv.css('visibility','hidden'); return this; },
			showSpinner : function() { _spinDiv.css('visibility','visible'); return this; },
			getCurrentPage : function() { return _currentPage; },
			getCurrentLimit: function() { return _limit; },
		}
	}
	
	function logsTableContent() {
		var hostspan	= 2;
		var levelspan	= 1;
		var timespan	= 2;
		var messagespan	= 7;
		
		var errorCodes = ["SEVERE"];
		var warnCodes  = ["WARNING"];
		
		var _content = $('<div></div>').attr({ id: 'subrunsData' }).addClass('container');
		
		
		var _firstRow = $('<div></div>').addClass('row');
		$('<div></div>').addClass('span'+hostspan).appendTo(_firstRow).append($('<strong></strong>').html('Host'));
		$('<div></div>').addClass('span'+levelspan).appendTo(_firstRow).append($('<strong></strong>').html('Level'));
		$('<div></div>').addClass('span'+timespan).appendTo(_firstRow).append($('<strong></strong>').html('Time'));
		$('<div></div>').addClass('span'+messagespan).appendTo(_firstRow).append($('<strong></string>').html('Message/Thrown'));
		
		_content.append(_firstRow);
		
		var buildTable = function(data) {
			_content.children().remove();
			
			var _firstRow = $('<div></div>').addClass('row');
			$('<div></div>').addClass('span'+hostspan).appendTo(_firstRow).append($('<strong></strong>').html('Host'));
			$('<div></div>').addClass('span'+levelspan).appendTo(_firstRow).append($('<strong></strong>').html('Level'));
			$('<div></div>').addClass('span'+timespan).appendTo(_firstRow).append($('<strong></strong>').html('Time'));
			$('<div></div>').addClass('span'+messagespan).appendTo(_firstRow).append($('<strong></string>').html('Message/Thrown'));
			
			_content.append(_firstRow);
			
			var i;
			for(i=0; data && i<data.length; i=i+1) {
				var row = $('<div></div>').addClass('row');
				var hostname = data[i].hostname;
				var level = data[i].level;
				var time = data[i].time;
				var message = data[i].message;
				
				var labeledLevel;
				
				if ($.inArray(data[i].level,errorCodes) > -1) {
					labeledLevel = $('<span></span>').addClass('label label-important').html(level);
				} else if ($.inArray(data[i].level, warnCodes) > -1) {
					labeledLevel = $('<span></span>').addClass('label label-warning').html(level);
				} else {
					labeledLevel = $('<span></span>').addClass('label label-info').html(level);
				}
				
				$('<div></div>').addClass('span'+hostspan).appendTo(row).html(hostname);
				$('<div></div>').addClass('span'+levelspan).appendTo(row).html(labeledLevel);
				$('<div></div>').addClass('span'+timespan).appendTo(row).html(time);
				$('<div></div>').addClass('span'+messagespan).appendTo(row).html(message);
				
				
				_content.append(row);
			}
		}
		
		return {
			changeContent: function(data) {
				buildTable(data);
			},
			getElement: function() { return _content; }
		}
	}
	
	function createDropdownMenu() {
		var filterDiv = $('<div></div>').attr({ id: 'filterByDropdown' });
		
		var menu = $('<ul></ul>').addClass('nav nav-pills').appendTo(filterDiv);
		var outterLI = $('<li></li>').addClass('dropdown').appendTo(menu);
		
		var anchor = $('<a></a>').addClass('dropdown-toggle').appendTo(outterLI)
		.attr({
			'data-toggle' : 'dropdown',
			href : '#'
		}).html('Filter by: <b class="caret"></b>').dropdown();
		
		var innerUL = $('<ul></ul>').addClass('dropdown-menu').appendTo(outterLI);
		
		var filterByLevel = $('<a></a>').addClass('filterby').attr({
			id : 'filterByLevelLink'
		}).html('Log Level');
		
		$('<li></li>').append(filterByLevel).appendTo(innerUL);
		
		var filterByTime = $('<a></a>').addClass('filterby').attr({
			id : 'filterByTimeLink'
		}).html('Time');
		
		$('<li></li>').append(filterByTime).appendTo(innerUL);
		
		var filterByHost = $('<a></a>').addClass('filterby').attr({
			id : 'filterByHostnameLink'
		}).html('Hostname');
		
		$('<li></li>').append(filterByHost).appendTo(innerUL);
		
		return {
			addLevelLinkClickHandler : function(f) {
				filterByLevel.click(f);
				return this;
			},
			
			addTimeLinkClickHandler : function(f) {
				filterByTime.click(f);
				return this;
			},
			
			addHostLinkClickHandler : function(f) {
				filterByHost.click(f);
				return this;
			},
			getElement: function() {
				return filterDiv;
			}
			
		}
	}
	
	function createFilterByLevelForm() {
		var levels = ["SEVERE","WARNING","INFO","CONFIG","FINE","FINER","FINEST"];
		var formDiv = $('<div></div>').attr({
			id : 'filterByLevelForm'
		});
		
		var form = $('<form></form>').appendTo(formDiv);
		
		var row1 = $('<div></div>').addClass('row').appendTo(form);
		
		$('<div></div>').addClass('span2')
		.append($('<label></label>').html('Log Level:'))
		.appendTo(row1);
		
		var selector = $('<select></select>').attr({ name: 'level' });
		
		for(var i in levels) {
			$('<option></option>').addClass('filterByLevel').html(levels[i]).attr({ value: levels[i], }).appendTo(selector);
		}
		
		$('<div></div>').addClass('span10').append(selector).appendTo(row1);
		
		var row2 = $('<div></div>').addClass('row').appendTo(form);
		
//		var submitButton = $('<input></input>').addClass('submitButton').attr({
//			type: 'submit',
//			value: 'Submit',
//		});
		
		var submitButton = document.createElement('input');
		submitButton.type = 'submit';
		
		$(submitButton).click(function() {
			var formData = form.serializeObject();
			formData.offset = (logsHeader.getCurrentPage()-1)*logsHeader.getCurrentLimit();
			formData.limit = logsHeader.getCurrentLimit();
			
			//alert(JSON.stringify(formData));
			ajaxContent(formData);
			return false;
		});
		
		$('<div></div>').addClass('span10 offset2').append(submitButton).appendTo(row2);
		
		return {
			getElement: function() { return formDiv; },
		}
	}
	
	function createFilterByTimeForm() {
		var formDiv = $('<div></div>');
		
		var form = $('<form></form>').appendTo(formDiv);
		
		var row1 = $('<div></div>').addClass('row').appendTo(form);
		
		$('<div></div>').addClass('span2')
		.append($('<label></label>').html('By Time'))
		.appendTo(row1);
		
		var selector = $('<select></select>').attr({ name: 'time', id: 'filterByTimeSelector' });
		
		$('<option></option>').attr({ value: '5min' })
		.html('Last 5 minutes').appendTo(selector);
		
		$('<option></option>').attr({ value: '10min' })
		.html('Last 10 minutes').appendTo(selector);
		
		$('<option></option>').attr({ value: '30min' })
		.html('Last 30 minutes').appendTo(selector);
		
		$('<option></option>').attr({ value: 'int' })
		.html('Interval').appendTo(selector);
		
		$('<div></div>').addClass('span10').append(selector).appendTo(row1);
		
		var row2 = $('<div></div>').addClass('row').attr({ 
			id: 'filterByTimeBetweenInput'
		}).appendTo(form).hide();
		
		$('<div></div>').addClass('span2')
		.append($('<label></label>').html('Between Interval:')).appendTo(row2);
		
//		var inputBefore = $('<input></input>').attr({
//			'type': 'text',
//			name: 'before',
//			id: 'filterByTimeBefore'
//		});
		
		var inputBefore = document.createElement('input');
		inputBefore.type = 'text';
		$(inputBefore).attr({ name: 'before', id: 'filterByTimeBefore' });
		
//		var inputAfter = $('<input></input>').attr({ 
//			type: 'text',
//			name: 'after',
//			id: 'filterByTimeAfter'
//		});
		
		var inputAfter = document.createElement('input');
		inputAfter.type = 'text';
		$(inputAfter).attr({ name: 'after', id: 'filterByTimeAfter' });
		
		var today = new Date();
		var yesterday = new Date();
		yesterday.setDate(today.getDate()-1);
		
		$(inputBefore).attr({ value: formatDateToString(yesterday) });
		$(inputAfter).attr({ value: formatDateToString(today) });
		
		$('<div></div>').addClass('span10')
		.append(inputBefore)
		.append(' and ')
		.append(inputAfter)
		.appendTo(row2);
		
		selector.change(function() {
			if ($(this).val() === 'int') {
				row2.show();
			} else {
				row2.hide();
			}
		});
		
		var row3 = $('<div></div>').addClass('row').appendTo(form);
		
//		var submitButton = $('<input></input').addClass('submitButton').attr({ 
//			type: 'submit',
//			value: 'Submit'
//		});
		
		var submitButton = document.createElement('input');
		submitButton.type = 'submit';
		$(submitButton).click(function() {
			var formData = form.serializeObject();
			formData.offset = (logsHeader.getCurrentPage()-1)*logsHeader.getCurrentLimit();
			formData.limit = logsHeader.getCurrentLimit();
			
			//alert(JSON.stringify(formData));
			ajaxContent(formData);
			return false;
		});
		
		$('<div></div>').addClass('span10 offset2').appendTo(row3).append(submitButton);
		
		return {
			getElement: function() { return formDiv; },
		}
	}
	
	function createFilterByHostnameForm() {
		var formDiv = $('<div></div>').attr({ id: 'filterByHostnameForm' });
		
		var form = $('<form></form>').appendTo(formDiv);
		
		var row1 = $('<div></div>').addClass('row').appendTo(form);
		
		$('<div></div>').addClass('span2').appendTo(row1)
		.append($('<label></label>').html('Hostname:'));
		
//		var input = $('<input></input>').attr({ 
//			type: 'text',
//			name: 'hostname',
//		});
		
		var input = document.createElement('input');
		input.type = 'text';
		$(input).attr({ name: 'hostname' });
		
		$('<div></div>').addClass('span10').append(input).appendTo(row1);
		
		var row2 = $('<div></div>').addClass('row').appendTo(form);
		
//		var submitButton = $('<input></input>').addClass('submitButton').attr({ 
//			type: 'submit',
//			value: 'Submit',
//		});
		
		var submitButton = document.createElement('input');
		submitButton.type = 'submit';
		
		$(submitButton).click(function() {
			var formData = form.serializeObject();
			formData.offset = (logsHeader.getCurrentPage()-1)*logsHeader.getCurrentLimit();
			formData.limit = logsHeader.getCurrentLimit();
			
			//alert(JSON.stringify(formData));
			ajaxContent(formData);
			return false;
		});
		
		$('<div></div>').addClass('offset2 span10').append(submitButton).appendTo(row1);
		
		return {
			getElement: function() { return formDiv; },		
		}
	}
	
	function createFormElements() {
		var formDiv = $('<div></div>').attr({ id: 'filterForm' });
		
		var levelForm = createFilterByLevelForm();
		var timeForm  = createFilterByTimeForm();
		var hostForm  = createFilterByHostnameForm();
		
		//formDiv.append(levelForm.getElement()).append(timeForm.getElement()).append(hostForm.getElement());
		
		return {
			getElement: function() { return formDiv; },
			showLevelForm: function() { formDiv.children().detach(); formDiv.append(levelForm.getElement()); return this; },
			showTimeForm:  function() { formDiv.children().detach(); formDiv.append(timeForm.getElement()); return this; },
			showHostForm:  function() { formDiv.children().detach(); formDiv.append(hostForm.getElement()); return this; }
		}
		
	}
	
	function formatDateToString(date) {
		var string = '';
		string = string + date.getFullYear();
		string = string + '-';
		
		if (date.getMonth()+1 < 10) { string = string + '0' + (date.getMonth()+1); }
		else { string = string + (date.getMonth()+1); }
		
		string = string + '-';
		string = string + date.getDate();
		string = string + ' ';
		string = string + date.getHours();
		string = string + ':';
		
		if (date.getMinutes() < 10) { string = string + '0' + date.getMinutes(); }
		else { string = string + date.getMinutes(); }
		//string = string + ':';
		//string = string + date.getSeconds();
		
		return string;
	}
	
	
	
//	var timeFormatString = "YYYY-MM-DD HH:mm";
//	var today = new Date();
//	var yesterday = new Date()
//	yesterday.setDate(today.getDate()-1);
//	
//	var formatDateToString = function(date) {
//		var string = '';
//		string = string + date.getFullYear();
//		string = string + '-';
//		
//		if (date.getMonth()+1 < 10) { string = string + '0' + (date.getMonth()+1); }
//		else { string = string + (date.getMonth()+1); }
//		
//		string = string + '-';
//		string = string + date.getDate();
//		string = string + ' ';
//		string = string + date.getHours();
//		string = string + ':';
//		string = string + date.getMinutes();
//		//string = string + ':';
//		//string = string + date.getSeconds();
//		
//		return string;
//	}
//	
//	var beforeString = formatDateToString(yesterday);
//	
//	var afterString = formatDateToString(today);
//	
//	// hide/show input text fields depending on whether
//	// we need those input boxes
//	// ~ James' suggestion.
//	
//	$('#filterByTimeSelector').change(function() {
//		if ($(this).val() == "int") {
//			$('#filterByTimeBetweenInput').show();
//		} else {
//			$('#filterByTimeBetweenInput').hide();
//		}
//	});
//	
//	// show the format that we want the timestamp to be in
//	
//	$('#filterByTimeBefore')
//	.val(beforeString)
//	.change(function() {
//		if ($(this).val() == '') {
//			$(this).val(beforeString);
//		}
//	})
////	.focus(function() {
////		if ($(this).val() == timeFormatString) {
////			$(this).val('');
////		}
////	});
//	
//	$('#filterByTimeAfter')
//	.val(afterString)
//	.change(function() {
//		if ($(this).val() == '') {
//			$(this).val(afterString);
//		}
//	})
////	.focus(function() {
////		if ($(this).val() == timeFormatString) {
////			$(this).val('');
////		}
////	});
//	
//	function ajaxLogsTable(fURL) {
//		$('#loadingLogTableSpinnerIconDiv').css('visibility','visible');
//
//		
//		ajaxInProgress = true;
//		
//		
//		jqXHR = $.ajax({
//			//data: { 'page': curPage, 'limit': limit },
//			url: fURL,
//			dataType: 'html',
//			success: function(data) {
//				setTimeout(function() {
//					$('#loadingLogTableSpinnerIconDiv').css('visibility','hidden');
//				},500);
//				
//				displayAndLinkData(data);
//				ajaxInProgress = false;
//				timeoutLength = 1000;
//			}
//		});
//	}
//	
//	function displayAndLinkData(data) {
//		//$('#logDiv').html(data);
//		
//		if (document.getElementById('logData')) {
//			$('#pageNavigation').html($(data).find('#pageNavigation').html());
//			$('#limitNavigation').html($(data).find('#limitNavigation').html());
//			$('#autoRefreshNavigation').html($(data).find('#autoRefreshNavigation').html());
//			$('#logsData').html($(data).find('#logsData').html());
//		} else {
//			$('#logDiv').html(data);
//		}
//		
//		$('a.log').click(function() {
//			if ($(this).parent().hasClass("disabled")) return false;
//			fetchURL = $(this).attr('href');
//			ajaxLogsTable(fetchURL);
//			return false;
//		});
//		
//		$('a.limit').click(function() {
//			if ($(this).parent().hasClass("disabled")) return false;
//			fetchURL = $(this).attr('href');
//			ajaxLogsTable(fetchURL);
//			return false;
//		});
//		
//		$('button.autorefresh').click(function() {
//			if($(this).hasClass('active')) {
//				$(this)
//					.removeClass('active')
//					.addClass('btn-danger')
//					.html('Stop');
//			} else {
//				$(this)
//					.addClass('active')
//					.addClass('btn-success')
//					.html('Start');
//			}
//			doRefreshing();
//		});
//	}
//	
//	function doRefreshing() {
//		var shouldAutoRefresh = $('#autorefreshbutton').hasClass("active");
//		if (shouldAutoRefresh) {
//			refreshing(shouldAutoRefresh);
//		} else {
//			clearTimeout(timer);
//			var href=$('#firstPageLink').attr('href')+"&autorefresh=false";
//			ajaxLogsTable(href);	
//		}
//	}
//	
//	function refreshing(autorefresh) {
//		var href = $('#firstPageLink').attr('href')+"&autorefresh="+autorefresh;
//		
//		if (!ajaxInProgress) {
//			// timeoutLength will be reset to its default 1000 after the ajax
//			// call is successful
//			ajaxLogsTable(href);
//			timer = setTimeout(refreshing, timeoutLength, autorefresh);
//		} else if (ajaxInProgress && (numTimeouts < 3)) { numTimeouts++; }
//		else if (numTimeouts >=3) {
//			jqXHR.abort();
//			numTimeouts = 0;
//			timeoutLength = timeoutLength*2;
//			ajaxLogsTable(href);
//			timer = setTimeout(refreshing,timeoutLength,autorefresh);
//		}
//		
//	}
//	
//	var filterByLevelForm = $('#filterByLevelForm');
//	var filterByTimeForm = $('#filterByTimeForm');
//	var filterByHostnameForm = $('#filterByHostnameForm');
//	
//	var curPage = 1;
//	var limit = 10;
//	var fetchURL = "/jsp/getLogs.jsp";
//	
//	var ajaxInProgress = false;
//	var numTimeouts = 0;
//	var timeoutLength = 1000;
//	var jqXHR;
//	
//	
//	//(".hidden").hide();
//	
//	$(".submitButton").click(function() {
//		var form = $(this).closest("form");
//		//alert(form.serialize());
//		$.ajax({
//			data: form.serialize(),
//			url: "/jsp/getLogs.jsp",
//			dataType: 'html',
//			success: function(data) {
//				displayAndLinkData(data);
//			}
//		});
//		
//		return false;
//	});
//	
//	$('.dropdown-toggle').dropdown();
//	
//	$('#filterByLevelLink').click(function() {
//		//$('#filterForm').children().remove();
//		$('#filterForm').children().detach()
//		//.remove()
//		$('#filterForm').append(filterByLevelForm.show());
//	});
//	
//	$('#filterByTimeLink').click(function() {
//		$('#filterForm').children().detach()
//		//.remove();
//		$('#filterForm').append(filterByTimeForm.show());
//	});
//	
//	$('#filterByHostnameLink').click(function() {
//		$('#filterForm').children().detach()
//		//.remove();
//		$('#filterForm').append(filterByHostnameForm.show());
//	});
//	
//	//$.ajax({
//	//	data: {page: 1, limit: 10},
//	//	url: "/jsp/getLogs.jsp",
//	//	dataType: 'html',
//	//	success: function(data) {
//	//		$('#logDiv').html(data);
//	//	}
//	//});
//	
//	ajaxLogsTable(fetchURL);
	
});