function createMetricSelector(options) {
	$.post('/hal/getFormSnippet/utilities/getDefinedMetrics',
		{
			'hal_httpResponseContentType' : 'json'
		},
		function(response) {
			if (response.successful) {
				var metricNames = response.result.metrics
				options.target.html('');

				var defaultOpt = $('<option></option>');
				defaultOpt.attr('value', '');
				defaultOpt.html('--- Choose a metric ---');
				options.target.append(defaultOpt);

				for (var i in metricNames) {
					var opt = $('<option></option>');
					opt.attr('value', metricNames[i]);
					opt.html(metricNames[i]);

					options.target.append(opt);
				}
			}
			
			options.onFinished({
				'successful' : response.successful
			});
		},
		'json'
	);
}

HAL.metricSelector = function(options) {
	if ( !(this instanceof HAL.metricSelector) ) {
	      return new HAL.metricSelector(options);
	}
	
	var initialValue = options.initialValue;
	
	var _metrics = options.metrics == null ? {} : options.metrics;
	var _idPrefix = options.idPrefix == null ? 'noid' : options.idPrefix;
	
	var _metricLabel = $('<label></label>');
	_metricLabel.attr('for', _idPrefix+'_metricName');
	_metricLabel.html('Performance metric');
	
	var _metricElement = $('<select></select>');
	_metricElement.attr('name', _idPrefix+'_metricName');
	_metricElement.attr('id', _idPrefix+'_instanceDistributionName');

	var _updateField = function() {
		var oldValue = _metricElement.val();
		
		_metricElement.empty();
		
		var defaultOpt = $('<option></option>');
		defaultOpt.attr('value', '');
		if (numberOfProperties(_metrics) > 0) {
			defaultOpt.html('--- Select a performance metric ---');
		} else {
			defaultOpt.html('--- No appropriate metrics defined ---');
		}
		_metricElement.append(defaultOpt);
		
		for (var i in _metrics) {
			var opt = $('<option></option>');
			opt.attr('value', _metrics[i]);
			opt.html(_metrics[i]);
			_metricElement.append(opt);
		}
		
		if (oldValue !== null && oldValue !== undefined && oldValue !== '') {
			_metricElement.val(oldValue);
		} else if (initialValue) {
			_metricElement.val(initialValue);
		} else {
			_metricElement.val('');
		}
		
	};
	
	_updateField();
	
	var _container = $('<div></div>');
	_container.addClass('formElement');
	_container.append(_metricLabel);
	_container.append(_metricElement);
	
	return {
		getElement : function() {
			return _container;
		},		
		getValue : function() {
			return _container.find('select').val();
		},
		setValue : function(value) {
			var selector = _container.find('select');
			
			selector.children().each(function(index,item) {
				if ($(item).val() == value) { selector.val(value); }
			});
			
			return this;
		},
		updateMetricList : function(newMetricList) {
			_metrics = newMetricList;
			
			_updateField();
		}
	};
};