$(document).ready(function() {
	
	function getURLParameter(name) {
		return decodeURIComponent(
			(location.search.match(RegExp("[?|&]"+name+'=(.+?)(&|$)'))||[,null])[1]
		);  
	}
	
	
	var runSettings = $('#runSettings > div');
	var runStatus 	= $('#runStatus > div');
	var statistics	= $('#statistics > div');
	var hypothesis	= $('#hypothesisTesting > div');
	var scdOverlay	= $('#scdOverlayPlot > div');
	var scatterPlot	= $('#scatterPlot > div');
	
	var spinner = $('<div></div>')
	.addClass('spinner')
	.append($('<img></img>').attr('src','/hal/commands/getFile/web/icons/ajax-loader.gif'));
	
	for(var i in divs = [runSettings, runStatus, statistics, hypothesis, scdOverlay, scatterPlot]) {
		divs[i].html(spinner.clone());
	}
	
	var pageRunId = getURLParameter('runId');
	
	$.ajax({
		url: '/hal/getFormSnippet/runStatusMonitoring/metaAlgorithmRunSettings',
		dataType: 'html',
		data: { 'runId' : pageRunId },
		success: function(data) {
			runSettings.html(data);
		}
	});
	
	$.ajax({
		url: '/hal/getFormSnippet/runStatusMonitoring/metaAlgorithmRunStatus',
		dataType: 'html',
		data: { 'runId' : pageRunId },
		success: function(data) {
			runStatus.html(data);
		}
	});
	
	$.ajax({
		url: '/hal/getFormSnippet/runStatusMonitoring/metaAlgorithmRunStatistics',
		dataType: 'html',
		data: { 'runId' : pageRunId },
		success: function(data) {
			statistics.html(data);
		}
	});
	
	$.ajax({
		url: '/hal/getFormSnippet/runStatusMonitoring/metaAlgorithmHypothesisTestingResults',
		dataType: 'html',
		data: { 'runId' : pageRunId },
		success: function(data) {
			hypothesis.html(data);
		}
	});
	
	$.ajax({
		url: '/hal/getFormSnippet/runStatusMonitoring/createPlot',
		dataType: 'html',
		data: { 'runId': pageRunId, 'plotType': 'SCD_OVERLAY' },
		success: function(data) {
			scdOverlay.html(data);
		}
	});
	
	$.ajax({
		url: '/hal/getFormSnippet/runStatusMonitoring/createPlot',
		data: { 'runId' : pageRunId, 'plotType' : 'SCATTER' },
		dataType: 'html',
		success: function(data) {
			scatterPlot.html(data);
		}
	});
	
	var subruns = addSubrunsTableFunctionality(pageRunId);
	
	var refreshStatus = function() {
		$.ajax({
			url: '/hal/getFormSnippet/runStatusMonitoring/metaAlgorithmRunStatus',
			dataType: 'html',
			data: { 'runId' : pageRunId },
			success: function(data) {
				runStatus.html(data);
			}
		});
		
		$.ajax({
			url: '/hal/getFormSnippet/runStatusMonitoring/metaAlgorithmRunStatistics',
			dataType: 'html',
			data: { 'runId' : pageRunId },
			success: function(data) {
				statistics.html(data);
			}
		});
		
		$.ajax({
			url: '/hal/getFormSnippet/runStatusMonitoring/metaAlgorithmHypothesisTestingResults',
			dataType: 'html',
			data: { 'runId' : pageRunId },
			success: function(data) {
				hypothesis.html(data);
			}
		});
		
		$.ajax({
			url: '/hal/getFormSnippet/runStatusMonitoring/createPlot',
			dataType: 'html',
			data: { 'runId': pageRunId, 'plotType': 'SCD_OVERLAY' },
			success: function(data) {
				scdOverlay.html(data);
			}
		});
		
		$.ajax({
			url: '/hal/getFormSnippet/runStatusMonitoring/createPlot',
			data: { 'runId' : pageRunId, 'plotType' : 'SCATTER' },
			dataType: 'html',
			success: function(data) {
				scatterPlot.html(data);
			}
		});
	}
	
	setInterval(refreshStatus, 5000);
});