$(document).ready(function() {
	function getURLParameter(name) {
		return decodeURIComponent(
			(location.search.match(RegExp("[?|&]"+name+'=(.+?)(&|$)'))||[,null])[1]
		);  
	}
	
	// function ajaxSubrunTable(pagenum) {
// 		// we only modify the subruns data table div, instead of the entire
// 		// div so that the nav buttons remain shown, instead of being replaced
// 		// by the spinner.  this lets the user click the nav buttons while
// 		// the spinner is showing.
// 		$('#subrunsData').html(spinner.clone().height(subruns.height()));
// 		
// 		ajaxInProgress = true;
// 		
// 		jqHXR = $.ajax({
// 			url: '/jsp/Subruns.jsp',
// 			dataType: 'html',
// 			data: { 'runId' : pageRunId, 'page' : pagenum, 'limit' : limit, "autorefresh" : shouldAutorefresh },
// 			success: function(data) {
// 				subruns.html(data);
// 				
// 				ajaxInProgress = false;
// 				
// 				$('a.subrun').click(function() {
// 					if($(this).parent().hasClass('disabled')) return false;
// 					currentPage = this.name;
// 					ajaxSubrunTable(currentPage, false);
// 					return false;
// 				});
// 				
// 				$('a.limit').click(function() {
// 					if($(this).parent().hasClass('disabled')) return false;
// 					limit = this.name;
// 					ajaxSubrunTable(currentPage, false);
// 					return false;
// 				});
// 				
// 				$('a.autorefresh').click(function() {
// 					if($(this).hasClass("active")) {
// 						$(this).removeClass("active");
// 						shouldAutorefresh=false;
// 					} else {
// 						$(this).addClass("active");
// 						shouldAutorefresh=true;
// 					};
// 					doRefreshing();
// 				});
// 				
// 				
// 			}
// 			
// 		});
// 	}
// 	
// 	function refreshing() {
// 		var maxPage = $('#firstPageLink').attr("name");
// 		
// 		if (!ajaxInProgress) {
// 			if (timeoutLength <= 1000) { changeAndSetTimeoutLength(timeoutLength-100); }
// 			ajaxSubrunTable(maxPage);
// 		} else if (ajaxInProgress && (numTimeouts<3)) {
// 			numTimeouts++;
// 		} else if (numTimeouts>=3) {
// 			jqHXR.abort();
// 			numTimeouts = 0;
// 			
// 			changeAndSetTimeoutLength(2*timeoutLength);
// 			
// 			ajaxSubrunTable(maxPage);
// 		}
// 	}
// 	
// 	function changeAndSetTimeoutLength(newLength) {
// 		if (newLength < 500) { timeoutLength = 500; }
// 		else { timeoutLength = newLength; }
// 		
// 		clearInterval(timer);
// 		timer = setInterval(refreshing,timeoutLength);
// 	}
// 	
// 	function doRefreshing() {
// 		if(shouldAutorefresh) {
// 			// here autorefresh = true
// 			refreshing();
// 			//changeAndSetTimeoutLength(1000);
// 		} else {
// 			// here autorefresh = false
// 			//
// 			// clear out current timer so that we can
// 			// change state properly.  we have to
// 			// call refreshing once more, so that we can
// 			// ajax the page with the autorefresh button set to 
// 			// off.  we immediately clear the timer so that we
// 			// don't keep refreshing
// 			clearInterval(timer);
// 		
// 			ajaxSubrunTable($('#firstPageLink').attr("name"));
// 		}
// 	}
	
	var runSettings 					= $('#runSettings > div');
	var runStatus 						= $('#runStatus > div');
	var runIncumbentDesignInformation	= $('#runIncumbentDesignInformation > div');
	var incumbentSQTPlot				= $('#incumbentSQTPlot > div');
	var subruns							= $('#subruns > div');
	
	var spinner = $('<div></div>')
		.addClass('spinner')
		.append($('<img></img>').attr('src','/hal/commands/getFile/web/icons/ajax-loader.gif'));
		
	for(var i in divs = [runSettings, runStatus, runIncumbentDesignInformation, incumbentSQTPlot]) {
		divs[i].html(spinner.clone());
	}

	var pageRunId = getURLParameter('runId');
	var limit = 50;
	var currentPage=1;
	var timer;
	
	var jqXHR;
	var ajaxInProgress = false;
	var timeoutLength = 1000;
	var numTimeouts = 0;
	var shouldAutorefresh = false;
	
	$.ajax({
		url: '/hal/getFormSnippet/runStatusMonitoring/metaAlgorithmRunSettings',
		dataType: 'html',
		data: {'runId': pageRunId},
		success: function(data) {
			runSettings.html(data);
		}
	});
	
	$.ajax({
		url: '/hal/getFormSnippet/runStatusMonitoring/metaAlgorithmRunStatus',
		dataType: 'html',
		data: {'runId': pageRunId},
		success: function(data) {
			runStatus.html(data);
		}
	});
	
	$.ajax({
		url: '/hal/getFormSnippet/runStatusMonitoring/metaAlgorithmRunIncumbentDesignInformation',
		data: {'runId': pageRunId},
		dataType: 'html',
		success: function(data) {
			runIncumbentDesignInformation.html(data);
			
			// the above data contains a form element named 
			// newNamedAlgorithmForm
			
			var newNamedAlgorithmForm = $('#newNamedAlgorithmForm');
			newNamedAlgorithmForm.ajaxForm({ 
				dataType: "json",
				success: function(data) { 
					var tabledata = newNamedAlgorithmForm.parent();
					newNamedAlgorithmForm.remove();
					
					if (data.successful) {
						tabledata.html("Algorithm successfully named.");
					} else {
						tabledata.html("<p>Could not name this algorithm because:</p><p>"+data.errorMessage+"</p>");
					}
				}
			});
		}
	});
	
	$.ajax({ 
		url: '/hal/getFormSnippet/runStatusMonitoring/createPlot',
		dataType: 'html',
		data: {'runId': pageRunId, 'plotType': 'PARAMETER_OVER_TIME', 'parameterName': 'SOLUTION_QUALITY', 'plotXScale':'LINEAR'},
		success: function(data) {
			incumbentSQTPlot.html(data);
		}
	});
	
	//ajaxSubrunTable(currentPage);
	
	var subrun = addSubrunsTableFunctionality(pageRunId);
	
	var refreshStats = function() {
		$.ajax({
			url: '/hal/getFormSnippet/runStatusMonitoring/metaAlgorithmRunStatus',
			dataType: 'html',
			data: {'runId': pageRunId},
			success: function(data) {
				runStatus.html(data);
			}
		});
		
		$.ajax({
			url: '/hal/getFormSnippet/runStatusMonitoring/metaAlgorithmRunIncumbentDesignInformation',
			data: {'runId': pageRunId},
			dataType: 'html',
			success: function(data) {
				runIncumbentDesignInformation.find('.results').html($(data).find('.results'));
				
				// the above data contains a form element named 
				// newNamedAlgorithmForm
				
//				var newNamedAlgorithmForm = $('#newNamedAlgorithmForm');
//				newNamedAlgorithmForm.ajaxForm({ 
//					dataType: "json",
//					success: function(data) { 
//						var tabledata = newNamedAlgorithmForm.parent();
//						newNamedAlgorithmForm.remove();
//						
//						if (data.successful) {
//							tabledata.html("Algorithm successfully named.");
//						} else {
//							tabledata.html("<p>Could not name this algorithm because:</p><p>"+data.errorMessage+"</p>");
//						}
//					}
//				});
			}
		});
		
		$.ajax({ 
			url: '/hal/getFormSnippet/runStatusMonitoring/createPlot',
			dataType: 'html',
			data: {'runId': pageRunId, 'plotType': 'PARAMETER_OVER_TIME', 'parameterName': 'SOLUTION_QUALITY', 'plotXScale':'LINEAR'},
			success: function(data) {
				incumbentSQTPlot.html(data);
			}
		});
	}
	
	setInterval(refreshStats, 5000);
	
	
	
});