var addSubrunsTableFunctionality = function(pageId) {
	var runPageId = pageId;
	var subrunsDiv = $('#subruns > div');
	
	var subrunsHeader = subrunsTableHeader();
	var subrunsContent = subrunsTableContent();
	
	subrunsDiv.find(".spinner").remove();
	
	subrunsDiv.append(subrunsHeader.getElement());
	subrunsDiv.append(subrunsContent.getElement());
	
	subrunsHeader.hideSpinner();
	ajaxContent(0,10);
	
	function ajaxContent(myOffset, myLimit, callback) {
		subrunsHeader.showSpinner();
		return $.ajax({
			url: '/hal/subruns/getSubruns',
			data: { runId : runPageId, offset: myOffset, limit: myLimit },
			dataType: 'json',
			success: function(data) {
				if (data.successful) {
					subrunsHeader.changeContent(data.result.maxSubruns);
					subrunsContent.changeContent(data.result.subruns);	
				}
				
				subrunsHeader.hideSpinner();
				if (callback) { callback(); }
			}
		});
	}
	
	
	function subrunsTableHeader() {
		var _currentPage = 1;
		var _limit = 10;
		var _maxSubruns = 0;
		
		
//		var _header = $('<div></div>').attr('id','subrunsTableNav').addClass('pagination');
//		
//		var _pagination = $('<ul></ul>').attr('id','pageNavigation').appendTo(_header);
//		var _limits = $('<ul></ul>').attr('id','limitsNavigation').appendTo(_header);
//		var _autorefresh = $('<ul></ul>').attr('id','autoRefreshNaviation').appendTo(_header);
//		var _spinner = $('<ul></ul').attr('id','spinner').appendTo(_header);
		
		var _header = $('<div></div>');
		
		var _table = $('<table></table>').appendTo(_header);
		var _tbody = $('<tbody></tbody').appendTo(_table);
		var _tr = $('<tr></tr>').appendTo(_tbody);
		
		var _pagDiv = $('<div></div>').addClass('pagination');
		var _pagination = $('<ul></ul>').attr('id','pageNavigation').appendTo(_pagDiv);
		
		var _limDiv = $('<div></div>').addClass('pagination');
		var _limits = $('<ul></ul>').appendTo(_limDiv);
		
		var _refDiv = $('<div></div>').addClass('pagination');
		_autorefresh = $('<ul></ul>').appendTo(_refDiv);
		
		var _spinDiv = $('<div></div>').addClass('pagination');
		var _spinner = $('<ul></ul>').appendTo(_spinDiv);
		
		$('<td></td>').append(_pagDiv).appendTo(_tr);
		$('<td></td>').append(_limDiv).appendTo(_tr);
		$('<td></td>').append(_refDiv).appendTo(_tr);
		$('<td></td>').append(_spinDiv).appendTo(_tr);
		
		var buildPaginationElements = function(maxNumberOfSubruns, numberOfRunsPerPage) {
			_pagination.children().remove();
			
			_maxSubruns = maxNumberOfSubruns;
			
			var maxPages = 1;
			
			if (maxNumberOfSubruns <= 1) { maxPages = 1; }
			else if (maxNumberOfSubruns % numberOfRunsPerPage == 0) { maxPages = maxNumberOfSubruns / numberOfRunsPerPage }
			else { maxPages = Math.ceil(maxNumberOfSubruns/numberOfRunsPerPage); }
			
			var firstPageLink = $('<a></a>').html('&lt;&lt;').attr({
				name: '1',
				id: 'firstPageLink',
				href: '/hal/subruns/getSubruns?runId='+runPageId+'&limit='+_limit,
			}).click(function() {
				_currentPage = 1;
				ajaxContent(0,_limit);
				return false;
			});
			
			$('<li></li>').append(firstPageLink).appendTo(_pagination);
			
			var pageLowerBound = _currentPage-2;
			var pageUpperBound = _currentPage+2;
			
			if (pageLowerBound<1) { pageLowerBound=1; pageUpperBound=5; }
			if (pageUpperBound>maxPages) { pageUpperBound = maxPages; pageLowerBound = (maxPages-4<1) ? 1 : maxPages-4; }
			if (maxPages < pageUpperBound) { pageUpperBound = maxPages; }
			
			var prevBound = (_currentPage-1 > 0) ? (_currentPage-1) : 1;
			var nextBound = (_currentPage+1 <= pageUpperBound) ? (_currentPage+1) : pageUpperBound;
			
			var prevPageLink = $('<a></a>').html('&lt;').attr({
				name: prevBound,
				id : 'previousPageLink',
				href: '/hal/subruns/getSubruns?runId='+runPageId+'&limit='+_limit+'&offset='+((prevBound-1)*_limit)
			}).click(function() {
				_currentPage = prevBound;
				ajaxContent(((prevBound-1)*_limit),_limit);
				return false;
			});
			
			$('<li></li>').append(prevPageLink).appendTo(_pagination);
			
			var i;
			for(i=pageLowerBound; i<=pageUpperBound; i=i+1) {
				var link = $('<a></a>').html(i).attr({
					href: '/hal/subruns/getSubruns?runId='+runPageId+'&limit='+_limit+'&offset='+((i-1)*_limit),
				}).click(function(e) {
					return function() { 
						_currentPage = e;
						ajaxContent(((e-1)*_limit), _limit);
						return false;
					}
					
				}(i));
				
				var li = $('<li></li>').appendTo(_pagination).append(link);
				
				if (i==_currentPage) { li.addClass("active").addClass("disabled"); }
			}
			
			var nextPageLink = $('<a></a>').html('&gt;').attr({
				name: nextBound,
				id: 'nextPageLink',
				href: '/hal/subruns/getSubruns?runId='+runPageId+'&limit='+_limit+'&offset='+((nextBound-1)*_limit)
			}).click(function() {
				_currentPage = nextBound;
				ajaxContent(((nextBound-1)*_limit),_limit);
				return false;
			});
			
			$('<li></li>').append(nextPageLink).appendTo(_pagination);
			
			var lastPageLink = $('<a></a>').html('&gt;&gt;').attr({
				name: maxPages,
				id: 'lastPageLink',
				href: '/hal/subruns/getSubruns?runId='+runPageId+'&limit='+_limit+'&offset='+((maxPages-1)*_limit),
			}).click(function() {
				_currentPage = maxPages;
				ajaxContent(((maxPages-1)*_limit), _limit);
				return false;
			});
			
			$('<li></li>').appendTo(_pagination).append(lastPageLink);
			
		};
		
		var buildLimitElements = function() {
			var limitValues = [10,25,50,100];
			
			$('<li></li>').addClass('active').addClass('disabled').append($('<a></a>').html('Per Page').attr({ name: 'limit' })).appendTo(_limits);
			
			var i;
			for(i=0; i < limitValues.length; i=i+1) {
				var anchor = $('<a></a>').html(limitValues[i]).attr({ 
					href: '/hal/subruns/getSubruns?runId='+runPageId+'&limit='+limitValues[i]+'&offset='+((_currentPage-1)*_limit) 
				}).click(function(e) {
					return function() {
						var oldLimit = _limit;
						
						_limit = e;
						
						var offset = (_currentPage*oldLimit);
						offset = (offset<_maxSubruns) ? offset : _maxSubruns;
						
						_currentPage = Math.ceil(offset/_limit);
						
						ajaxContent(((_currentPage-1)*e),e);
						_limits.find('.active.disabled:gt(0)').removeClass('active disabled');
						$(this).parent().addClass('active disabled');
						
						return false;
					}
				}(limitValues[i]));
				
				
				var li = $('<li></li>').appendTo(_limits).append(anchor);
				
				if (limitValues[i] == _limit) { li.addClass('active').addClass('disabled'); }
			}
		}();
		
		var buildAutoRefreshElements = function() {
			var isAutoRefreshing = false;
			var timer;
			
			var button = $('<button></button>').html('Start refreshing subruns').attr({ name: '1', id: 'autorefreshbutton', 'data-toggle':'button' }).addClass('btn btn-large autorefresh btn-success').click(function() {
				if (isAutoRefreshing) {
					//clearInterval(timer);
					unpoll();
					$(this).removeClass('btn-danger').addClass('btn-success active').html('Start refreshing subruns');
					
					
				} else {
					//timer = setTimeout(ajaxContent,1000,0,_limit);
					poll(1000);
					$(this).removeClass('btn-success').addClass('btn-danger active').html('Stop refreshing subruns');
				}
				
				isAutoRefreshing = !isAutoRefreshing;
				
			}).button();
			
			//$('<li></li>').appendTo(_autorefresh).append($('<a></a>').html('Autorefresh')).addClass('active disabled').attr('name','refresh');
			$('<li></li>').appendTo(_autorefresh).append(button);
		}();
		
		var shouldPoll=false;
		
		function doPolling(timeout) {
			subrunsHeader.showSpinner();
			$.ajax({
				url: '/hal/subruns/getSubruns',
				data: { runId : runPageId, offset: 0, limit: _limit },
				dataType: 'json',
				timeout: timeout,
				maxRetries: 3,
				success: function(data) {
					if (data.successful) {
						_currentPage = 1;
						subrunsHeader.changeContent(data.result.maxSubruns);
						subrunsContent.changeContent(data.result.subruns);	
					}
					
					subrunsHeader.hideSpinner();
				},
				complete: function() {
					return function(e) { if (e) { setTimeout(doPolling,2000,timeout); } }(shouldPoll);
				},
				error: function(jqhxr,statusText,thrownError) {
					if (statusText === 'timeout') {
						timeout = timeout * 2;
					}
				}
			});
		}
		
		function poll(timeout) {
			shouldPoll = true;
			doPolling(timeout);
		}
		
		function unpoll() {
			shouldPoll = false;
		}
		
		var buildSpinnerElements = function() {
			var anchor = $('<a></a>').append($('<img></img>').attr({ src: '/hal/commands/getFile/web/icons/ajax-loader.gif' }));
			
			$('<li></li>').appendTo(_spinner).append(anchor).addClass('disable');
		}();
		
		return {
			getElement: function() { return _header; },
			changeContent : function(numRuns) { buildPaginationElements(numRuns, _limit); return this; },
			hideSpinner : function() { _spinDiv.css('visibility','hidden'); return this; },
			showSpinner : function() { _spinDiv.css('visibility','visible'); return this; },
		}
	}
	
	function subrunsTableContent() {
		var idspan=1;
		var statusspan=2;
		var algspan=3;
		var startspan=2;
		var finishspan=2;
		var cpuspan=2;
		
		var errorCodes = [0.8, 0.69];
		var warnCodes  = [0.4];
		
		var _content = $('<div></div>').attr({ id: 'subrunsData' }).addClass('container');
		
		
		var _firstRow = $('<div></div>').addClass('row');
		$('<div></div>').addClass('span'+idspan).appendTo(_firstRow).append($('<strong></strong>').html('Id'));
		$('<div></div>').addClass('span'+statusspan).appendTo(_firstRow).append($('<strong></strong>').html('Status'));
		$('<div></div>').addClass('span'+algspan).appendTo(_firstRow).append($('<strong></strong>').html('Target Algorithm'));
		$('<div></div>').addClass('span'+startspan).appendTo(_firstRow).append($('<strong></string>').html('Start Time'));
		$('<div></div>').addClass('span'+finishspan).appendTo(_firstRow).append($('<strong></strong').html('Finish Time'));
		$('<div></div>').addClass('span'+cpuspan).appendTo(_firstRow).append($('<strong></strong>').html('CPU Time (s)'));
		
		_content.append(_firstRow);
		
		var buildTable = function(data) {
			_content.children().remove();
			
			var _firstRow = $('<div></div>').addClass('row');
			$('<div></div>').addClass('span'+idspan).appendTo(_firstRow).append($('<strong></strong>').html('Id'));
			$('<div></div>').addClass('span'+statusspan).appendTo(_firstRow).append($('<strong></strong>').html('Status'));
			$('<div></div>').addClass('span'+algspan).appendTo(_firstRow).append($('<strong></strong>').html('Target Algorithm'));
			$('<div></div>').addClass('span'+startspan).appendTo(_firstRow).append($('<strong></string>').html('Start Time'));
			$('<div></div>').addClass('span'+finishspan).appendTo(_firstRow).append($('<strong></strong').html('Finish Time'));
			$('<div></div>').addClass('span'+cpuspan).appendTo(_firstRow).append($('<strong></strong>').html('CPU Time (s)'));
			
			_content.append(_firstRow);
			
			var i;
			for(i=0; data && i<data.length; i=i+1) {
				var row = $('<div></div>').addClass('row');
				var id = data[i].id;
				var statusCode = parseFloat(data[i].status);
				var status = data[i].humanReadableStatus;
				var algorithm = data[i].name;
				var startTime = data[i].startTime;
				var finishTime = data[i].finishTime;
				var cpuTime = data[i].cpuTime;
				
				var labeledStatus;
				
				if ($.inArray(statusCode,errorCodes) > -1 || data[i].status > 0.9) {
					labeledStatus = $('<span></span>').addClass('label label-important').html(status);
				} else if ($.inArray(statusCode, warnCodes) > -1) {
					labeledStatus = $('<span></span>').addClass('label label-warning').html(status);
				} else if (data[i].status == 0) {
					labeledStatus = $('<span></span>').addClass('label label-success').html(status);
				} else {
					labeledStatus = $('<span></span>').addClass('label label-info').html(status);
				}
				
				$('<div></div>').addClass('span'+idspan).appendTo(row).append($('<a></a>').html(id).attr({ href: '/hal/monitorRun?runId='+id }));
				$('<div></div>').addClass('span'+statusspan).appendTo(row).html(labeledStatus);
				$('<div></div>').addClass('span'+algspan).appendTo(row).html(algorithm);
				$('<div></div>').addClass('span'+startspan).appendTo(row).html(startTime);
				$('<div></div>').addClass('span'+finishspan).appendTo(row).html(finishTime);
				$('<div></div>').addClass('span'+cpuspan).appendTo(row).html(cpuTime);
				
				_content.append(row);
			}
			
			
		}
		
		
		return {
			changeContent: function(data) {
				buildTable(data);
			},
			getElement: function() { return _content; }
		}
	}
}