%% compute score for every canadidate solver based on some given reference
%% solvers. (The solvers which compete with SATzilla in SAT competition)

function [yData, sScore] = time2score(yDataAll, yReference, cutoff, useSCORE, serial, useSERIAL, scoreClass)
sScore=[];
if scoreClass==1
stdP = 1000;
spdP = 1000;
yData = yDataAll * 0;
[numI, numS]=size(yDataAll);
yDataAll = min(yDataAll, cutoff);
yReference = min(yReference, cutoff);
serM =3;
sScore =zeros(size(yDataAll));
if useSCORE ==1
    for ii= 1:numS;
        tmpYdata=[yDataAll(:,ii), yReference];
        foo = tmpYdata *0; ;
        foo(find(tmpYdata < cutoff)) =1;
        tmpScore = foo .* repmat(stdP ./(max(sum(foo,2), 0.0001)), 1, size(foo,2));
        spdf = cutoff ./ (1+tmpYdata);
        spdf(find(tmpYdata >=cutoff)) = 0;
        spds = spdP * spdf ./repmat(max(sum(spdf,2),0.0001), 1, size(foo,2));
        yData(:,ii) = tmpScore(:,1) + spds(:,1);
    end
    yData(find(yDataAll >=cutoff)) = 0;
    if useSERIAL ==1
        totalSerial = max(serial);
        for jj=1:numS
            tmpYdata=[yDataAll(:,jj), yReference];
            for ii = 1:totalSerial
                sID =find(serial == ii);
                sizeID =size(sID, 1);
                tmpsScore = zeros(sizeID,size(yReference,2)+1);
                if sizeID > 0
                    tmpyDataAll=tmpYdata(sID,:);
                    tmpsScore(find(tmpyDataAll<cutoff)) =1;
                    tmpSum = sum(tmpsScore,2);
                    tmpnum = sum(tmpsScore,1);
                    numGood = size(find(tmpnum>0),2); 
                    tmpSCORE = find(tmpSum > 0);
                    if size(tmpSCORE, 2) >0
                        if sizeID > 4
                            score = serM *stdP /max(size(tmpSCORE, 1)*numGood, 0.0001);
                        else
                            score = stdP /max(size(tmpSCORE, 1)* numGood, 0.0001);
                        end
                        tmpsScore = tmpsScore .* score;
                        sScore(sID,jj) = tmpsScore(:,1);
                    end
                end
            end
        end
        sScore(find(yDataAll >=cutoff)) = 0;
    end
    
else
    yData = yDataAll;
end
end

if scoreClass==2
    
    yData=yDataAll;
    yData(find(yData>=cutoff))=cutoff*100;
    yData=cutoff*100 - yData;
end

if scoreClass==3
    yData=log10(yDataAll);
   yData(find(yDataAll>=cutoff))=log10(cutoff);
   yData=log10(cutoff)-yData;

end

if scoreClass==4
   yData=log10(yDataAll);
   yData(find(yDataAll>=cutoff))=log10(cutoff*10);
   yData=log10(cutoff*10)-yData;

end

if scoreClass==5
   yData=yDataAll;
   yData(find(yDataAll>=cutoff))=cutoff*10;
   yData=cutoff*10-yData;

end